<?php
if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly
function church_admin_display_classes($today,$allow_registration=TRUE)
{
	global $wpdb,$current_user;
	if(defined('CA_DEBUG'))$wpdb->show_errors();
	$user = wp_get_current_user();

	$out='';
	if(empty($today))
	{
		$sql='SELECT * FROM '.CA_CLA_TBL.' WHERE end_date >= CURDATE() ';
	}
	else
	{
		$sql='SELECT a.* FROM '.CA_CLA_TBL.' a, '.CA_DATE_TBL.' b WHERE a.event_id=b.event_id AND b.start_date=CURDATE() ';
	}
	if(defined('CA_DEBUG'))church_admin_debug($sql);
	$results=$wpdb->get_results($sql);
	if(!empty($results))
	{
		foreach($results AS $row)
		{
			$out.=church_admin_display_class($row->class_id,FALSE,$allow_registration);
		}
		
	}//there are classes
	else
	{
		if(empty($today))$out.='<p>'.__('No classes running at the moment','church-admin').'</p>';
		else{$out.='<p>'.__('No classes today','church-admin').'</p>';}
	}

	return $out;

}

function church_admin_display_class($class_id=NULL,$show=TRUE,$allow_registration=TRUE)
{
	global $wpdb,$current_user;
	$wpdb->show_errors();
	$user = wp_get_current_user();
	$out='';
	$sql='SELECT * FROM '.CA_CLA_TBL.' WHERE class_id="'.intval($class_id).'"';

	$row=$wpdb->get_row($sql);
	if(!empty($row))
	{
			if(empty($show))
            {
                $out.='<h2 class="class-toggle" id="class-'.intval($class_id).'">'.esc_html($row->name).' ('.__('Click to toggle','church-admin').')</h2>';
			     $out.='<div class="class-'.intval($class_id).'" style="display:none">';
            }
            else
            {
                $out.='<h2>'.esc_html($row->name).'</h2><div class=""class-'.intval($class_id).'">';
            }
			if(!empty($row->description))
			{
                $allowed_html=array(
                    'a' => array(
                        'href' => array(),
                        'title' => array()
                    ),
                    'br' => array(),
                    'em' => array(),
                    'strong' => array(),
                    'p'=>array(),
                    'div'=>array('class'=>array(),'style'=>array('width'=>array(),'height'=>array(),'position'=>array(),'top'=>array(),'left'=>array())),
                    'iframe'=>array('src'=>array(),'style'=>array('width'=>array(),'height'=>array(),'position'=>array(),'top'=>array(),'left'=>array()))
                );
				$out.=$row->description;
            }
            if(!empty($row->next_start_date))$out.='<p>'.mysql2date(get_option('date_format'),$row->next_start_date);
			if(!empty($row->end_date))$out.=' - '.mysql2date(get_option('date_format'),$row->end_date);
				$out.='</p><p>';
        
            switch($row->recurring)
            {
                case'1':$out.=sprintf(__('From %1$s to %2$s','church-admin'),mysql2date(get_option('time_format'),$row->start_time),mysql2date(get_option('time_format'),$row->end_time));break;    
                case'7':$out.=sprintf(__('Weekly from %1$s to %2$s','church-admin'),mysql2date(get_option('time_format'),$row->start_time),mysql2date(get_option('time_format'),$row->end_time));break; 
                case'14':$out.=sprintf(__('Fortnightly from %1$s to %2$s','church-admin'),mysql2date(get_option('time_format'),$row->start_time),mysql2date(get_option('time_format'),$row->end_time)); break;  
                case 'm':$out.=sprintf(__('Monthly from %1$s to %2$s','church-admin'),mysql2date(get_option('time_format'),$row->start_time),mysql2date(get_option('time_format'),$row->end_time)); break; 
                case 'a':$out.=sprintf(__('Annually from %1$s to %2$s','church-admin'),mysql2date(get_option('time_format'),$row->start_time),mysql2date(get_option('time_format'),$row->end_time)); break;  
                 
            }
			$out.='<p>';
			//check if logged in and whether leader or punter
			if(!is_user_logged_in())
			{
				if(!empty($_POST['class-register'])&&!empty($_POST['class_id'])&&!empty($allow_registration))
                {
                    //handle register and booking
                  
                    /****************************
                    *
                    *   Registering and booking
                    *
                    *****************************/
                    $email=trim(stripslashes($_POST['booking_email']));
                    $first_name=trim(stripslashes($_POST['booking_first_name']));
                    $last_name=trim(stripslashes($_POST['booking_last_name']));
                    $class_id=(int)$_POST['class_id'];
                    $email_send=0;
                    if(!empty($_POST['email_send']))$email_send=1;
                    //do spam checks
                    if(church_admin_spam_check($email,'email'))exit(__('You appear to be a spammer- email'));
                    if(church_admin_spam_check($first_name,'text'))exit(__('You appear to be a spammer - first name'));
                    if(church_admin_spam_check($last_name,'text'))exit(__('You appear to be a spammer - last name'));
                    $people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE first_name="'.esc_sql($first_name).'" AND last_name="'.esc_sql($last_name).'" AND email="'.esc_sql($email).'"');
                    $message='';
                    if(!$people_id)
                    {
                        //probably not in database!
                        $wpdb->query('INSERT INTO '.CA_HOU_TBL.' (privacy)VALUES("1")');
                        $household_id=$wpdb->insert_id;
                        $wpdb->query('INSERT INTO '.CA_PEO_TBL.' (first_name,last_name,email,email_send,household_id)VALUES("'.esc_sql($first_name).'","'.esc_sql($last_name).'","'.esc_sql($email).'","'.$email_send.'","'.(int)$household_id.'")');
                        $people_id=$wpdb->insert_id;
                        church_admin_email_confirm($people_id);
                        $message='Please confim your email by clicking the link in the email we have just sent you.';
                    }
                    church_admin_update_people_meta((int)$_POST['class_id'],(int)$people_id,'class');
                    church_admin_class_booking_email($class_id,$people_id,$email);
                    $out.='<div class="notice notice-sucess inline">'.__('Class Booked. ','church-admin').$message.'</div>';
                }
                else
                {
                    if($allow_registration)
                    {
                        $out.='<div class="ca-next-step"><div class="church-admin-form-group"><label>'.__('Please start your booking with your email address','church-admin').'</label>';
                        $out.='<input type="email" id="ca-email-address" class="form-control"></div><p><button class="btn btn-success" id="ca-next-step">'.__("Next step",'church-admin').'</button></p></div></div>';
                        $out.='<div id="ca-login" style="display:none">';
                        $out.='<p>'.__('It looks like you are already registed on our website, please login to continue','church-admin').'</p>';
                        $out.=wp_login_form(array('echo'=>FALSE));
                        $out.='<a href="'.esc_url( wp_lostpassword_url( get_permalink() ) ).'" alt="'.__( 'Lost Password', 'church-admin' ).'">'.__( "I've forgotten my password", 'church-admin' ).'</a></p></div>';
                        $out.='<div class="ca-register-form" style="display:none"><form action="" method="POST">';
                        $out.='<table class="form-table"><tr><th scope="row">'.__('First name','church-admin').'</th><td><input type="text" required="required" name="booking_first_name"/></td></tr><tr><th scope="row">'.__('Last name','church-admin').'</th><td><input type="text" required="required" name="booking_last_name"/></td></tr><tr><th scope="row">'.__('Email','church-admin').'</th><td><input type="text" required="required" class="booking-email" name="booking_email"/></td></tr><tr><th scope="row">'.__('Do you want to be on our weekly email list?','church-admin').'</th><td><input type="checkbox" name="email_send"/></td></tr>';
                        $out.='<tr><td colspan=2><input type="hidden" name="class_id" value="'.intval($row->class_id).'"/><input type="hidden" name="class-register" value="yes"/><input type="submit" value="'.__('Book','church-admin').'"/></td></tr></table></form></div>';
                        $out.='<script type="text/javascript">jQuery(function($){  
                          $("#ca-next-step").click(function(e){
                          e.preventDefault();
                            console.log("clicked");
                                var email=$("#ca-email-address").val();
                                var nonce="'.wp_create_nonce("email-checker").'";
                                var args = {"action": "church_admin","method": "email-checker","email": email,"nonce":nonce};
                                console.log(args);
                                $.ajax({
                                    url: ajaxurl,
                                    type: "post",
                                    data:  args,
                                    success: function(response) {
                                        console.log(response);
                                        if(response=="Found")
                                        {
                                            $(".ca-register-form").hide();
                                            $("#ca-login").show();
                                            $(".ca-next-step").hide();
                                        }
                                        else
                                        {
                                            $(".booking-email").val(email);
                                            $(".ca-register-form").show();
                                            $("#ca-login").hide();
                                            $(".ca-next-step").hide();
                                        }

                                    }
                                });
                            });
                            });</script>'."\r\n";
                    }
                    else{
                  
                        //output login/register form
                        $out.='<div class="login"><h3>'.__('Please login to book in yourself or check in attendees','church-admin').'</h3>'.wp_login_form(array('echo'=>FALSE,'form_id'=> 'login'.$class_id,
                        'id_username'    => 'user_login'.$class_id,
                        'id_password'    => 'user_pass'.$class_id,
                        'id_remember'    => 'rememberme'.$class_id,
                        'id_submit'      => 'wp-submit'.$class_id)).'</div>';
                    }
                    
                        
                    
                }
			}
			else
			{
				//form post
                
				if(!empty($_POST['class-check-in'])&&!empty($_POST['class_id']))
				{

					//add people to the class
					if(!empty($_POST['delegate']))
					{
						$people=maybe_unserialize(church_admin_get_people_id(stripslashes($_POST['delegate'])));

						if(!empty($people))foreach($people AS $key=>$people_id)
						{
							church_admin_update_people_meta(intval($_POST['class_id']),$people_id,'class');

						}
					}
					if(!empty($_POST['people_id']))
					{
						$adult=$child=0;
						foreach($_POST['people_id'] AS $key=>$people_id)
						{
							$check=$wpdb->get_var('SELECT attendance_id FROM '.CA_IND_TBL.' WHERE `date`="'.esc_sql($_POST['class_date']).'" AND people_id="'.(int)$people_id.'" AND meeting_type="class" AND meeting_id="'.intval($_POST['class_id']).'"' );

							if(empty($check))
							{
								$wpdb->query('INSERT INTO '.CA_IND_TBL.' (`date`,people_id,meeting_type,meeting_id) VALUES ("'.esc_sql($_POST['class_date']).'","'.(int)$people_id.'","class","'.intval($_POST['class_id']).'")');
								//check people type
								$sql='SELECT people_type_id FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"';
								$person_type=$wpdb->get_var($sql);
								switch($person_type)
								{
									case 1:$adult++;break;
									case 2:$child++;break;
									case 3:$child++;break;
								}
							}
						}

						if(empty($check))
						{
							$sql='INSERT INTO '.CA_ATT_TBL .' (`date`,adults,children,service_id,mtg_type) VALUES ("'.esc_sql($_POST['class_date']).'","'.$adult.'","'.$child.'","'.intval($_POST['class_id']).'","class")';
							$wpdb->query($sql);
						}
					}
					$out.='<div class="notice notice-sucess inline">'.__('Class Checked in','church-admin').'</div>';
				}
				elseif(!empty($_POST['class-book-in'])&&!empty($_POST['class_id']))
				{
					foreach($_POST['people_id'] AS $key=>$people_id)
					{
						church_admin_update_people_meta((int)$_POST['class_id'],(int)$people_id,'class');
					}
                    $user=wp_get_current_user();
                    $email=$wpdb->get_var('SELECT email FROM '.CA_PEO_TBL.' WHERE user_id="'.(int)$user->ID.'"');
                    if(!empty($email))church_admin_class_booking_email((int)$_POST['class_id'],$_POST['people_id'],$email);
					$out.='<div class="notice notice-sucess inline">'.__('Class Booked','church-admin').'</div>';
				}
				else
				{//show data
					$person=$wpdb->get_row('SELECT * FROM '.CA_PEO_TBL.' WHERE user_id="'.(int)$user->ID.'"');

					if(!empty($person))
					{
						//logged in user is in the direcory

						$ldrs=maybe_unserialize($row->leadership);


						if(is_array($ldrs)&&in_array($person->people_id,$ldrs))
						{
							//leader of course, so show who is in the class to check them in and then fireld to add more people



							$out.='<h3>'.__('Check in class students','church-admin').'</h3>';
							$out.='<form action="" method="POST"><table class="form-table">';
							$dates=$wpdb->get_results('SELECT start_date FROM '.CA_DATE_TBL.' WHERE event_id="'.(int)$row->event_id.'" AND start_date>=CURDATE() ORDER BY start_date');
							if(!empty($dates)){
								$class_dates='<select name="class_date">';
								foreach($dates AS $date){$class_dates.='<option value="'.esc_html($date->start_date).'">'.mysql2date(get_option('date_format'),$date->start_date).'</option>';}
								$class_dates.='</select>';
							}
							else{$class_dates=__('No class dates set, please re-edit the class','church-admin');}

							$out.='<tr><th scope="row">'.__('Class Date','church-admin').'</th><td>'.$class_dates.'</td></tr>';
							$people_result=church_admin_people_meta($row->class_id,NULL,'class');

							if(!empty($people_result))
							{//people are booked in for class, so can check them in
								foreach($people_result AS $data)
								{
									$name=array_filter(array($data->first_name,$data->prefix,$data->last_name));
									$out.='<tr><th scope="row">'.esc_html(implode(" ",$name)).'</th><td><input type="checkbox" value="'.intval($data->people_id).'" ';

									$out.='name="people_id[]"/></td></tr>';

								}
							}
							$out.= '<tr><th scope="row">'.__('Add people on the class','church-admin').'</th><td><textarea style="width:100%;height:50px" name="delegate">'.__('Type in names, separated by a comma','church-admin').'</textarea></td></tr>';
							$out.='<tr><td colspan=2><input type="hidden" name="class_id" value="'.intval($row->class_id).'"/><input type="hidden" name="class-check-in" value="yes"/><input type="submit" value="'.__('Check in','church-admin').'"/></td></tr></table></form>';

						}
						else
						{
							//not a leader so show the whole household so they can book in people
							//grab household
							$household=$wpdb->get_results('SELECT CONCAT_WS(" ",first_name,last_name) AS name,people_id FROM '.CA_PEO_TBL.' WHERE household_id="'.intval($person->household_id).'" ORDER BY people_order');
							$out.='<h3>'.__('Book in members of your household','church-admin').'</h3>';
							$out.='<form action="" method="POST"><table class="form-table">';
							foreach($household AS $data)
							{
								$out.='<tr><td style="width:50px;"><input type="checkbox" value="'.intval($data->people_id).'" name="people_id[]" ';
								$check=$wpdb->get_var('SELECT meta_id FROM '.CA_MET_TBL.' WHERE meta_type="class" AND people_id="'.intval($data->people_id).'" AND ID="'.intval($row->class_id).'"');
								if($check) $out.=' checked="checked" ';
								$out.='"/></td><td  class="ca-names">'.esc_html($data->name).'</td></tr>';

							}
							$out.='<tr><td colspan=2><input type="hidden" name="class_id" value="'.intval($row->class_id).'"/><input type="hidden" name="class-book-in" value="yes"/><input type="submit" value="'.__('Book','church-admin').'"/></td></tr></table></form>';
						}


					}

				}//show data

			}//logged in
							$out.='</div>';

	}
	else
	{
		$out.=__('No class for today to display','church-admin');
	}
	return $out;
}

function church_admin_class_booking_email($class_id,$people_ids,$booking_email)
{
    global $wpdb;
    if (empty($class_id))return;
    if(empty($people_ids))return;
    if(!is_array($people_ids))$people_ids=array($people_ids);
    
    $class_details=$wpdb->get_row('SELECT * FROM '.CA_CLA_TBL.' WHERE class_id="'.(int)$class_id.'"');
    $people=array();
    foreach($people_ids AS $key=>$people_id)$people[]=$wpdb->get_row('SELECT * FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
    $message='<p>'.sprintf(__('Thanking you for signing up for %1$s. The first occasion is %2$s at %3$s. Further details will follow.','church-admin'),esc_html($class_details->name),mysql2date(get_option('date_format'),$class_details->next_start_date),mysql2date(get_option('time_format'),$class_details->start_time)).'</p>';
    $message.='<p>'.__('On this booking','church-admin').'</p>';
    foreach($people AS $person)
    {
        $message.='<p>'.implode(" ",array_filter(array($person->first_name,$person->prefix,$person->last_name))).'</p>';
    }
    $subject=sprintf(__('Class booking for %1$s','church-admin'),esc_html($class_details->name));
    $headers =array('Cc:'.get_option('admin_email'));
    add_filter( 'wp_mail_from_name','church_admin_from_name' );
    add_filter( 'wp_mail_from', 'church_admin_from_email');
    add_filter('wp_mail_content_type','church_admin_email_type');
    wp_mail($booking_email,$subject,$message,$headers);
    remove_filter('wp_mail_content_type','church_admin_email_type');
    
}