<?php
if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly


function church_admin_podcast_display($series_id=NULL,$file_id=NULL,$exclude=NULL,$most_popular=TRUE,$order='DESC',$limit=5)
{
    global $wpdb;
    $out='';
    
    if(!empty($_REQUEST['order']) && $_REQUEST['order']=='ASC'){
        $order='ASC';
    }
    else
    {
        $order='DESC';
    }
    $latest_sermon=$wpdb->get_row('SELECT * FROM '.CA_FIL_TBL.' ORDER BY pub_date '.$order.' LIMIT 1');
    if(!empty($series_id))
    {
        $latest_sermon=$wpdb->get_row('SELECT * FROM '.CA_FIL_TBL.' WHERE series_id="'.(int)$series_id.'" ORDER BY pub_date '.$order.' LIMIT 1');
        $File_id=$latest_sermon->file_id;
    }
    
    if(!empty($_GET['sermon-series']))
    {
        //coming from sermon series link
        $series=$wpdb->get_row('SELECT * FROM '.CA_SERM_TBL.' WHERE series_slug="'.esc_sql(stripslashes($_GET['sermon-series'])).'"');
        if(!empty($series))
        {
            $series_id=(int)$series->series_id;
            $latest_sermon= $latest_sermon=$wpdb->get_row('SELECT * FROM '.CA_FIL_TBL.' WHERE series_id="'.$series_id.'" ORDER BY pub_date DESC LIMIT 1');
        }
    }
    if(!empty($_GET['sermon']))
    {
        $sermon=$wpdb->get_row('SELECT * FROM '.CA_FIL_TBL.' WHERE file_slug="'.esc_sql(stripslashes($_GET['sermon'])).'"  LIMIT 1');
        if(!empty($sermon))
        {
              $file_id=$sermon->file_id;
            $series_id=$sermon->series_id;
        }
    }
    $page=!empty($_GET['page'])?(int)$_GET['page']:1;
    
    
    if(empty($file_id))$file_id=$latest_sermon->file_id;    
    //if(empty($series_id))$series_id=$latest_sermon->series_id;
    /********************************************************
    *
    *   Output
    *
    *********************************************************/
    $out.='<div class="ca-podcast clearfix" id="ca-sermons">';
    $out.='<div class="ca-podcast-left-column">
                <div class="ca-series-current">'.church_admin_podcast_series_detail($series_id,$exclude,$limit).'</div>
                <div class="ca-podcast-current">'.church_admin_podcast_file_detail($file_id).'</div>
            </div>
            <div class="ca-podcast-list">
                <div class="ca-menu-area">'.church_admin_podcast_menu($page,$limit,$series_id).'</div>
                <div class="ca-media-file-list">'.church_admin_podcast_files_list($series_id,$page,$limit).'</div>
            </div>'; 
    
    $out.='</div>';
    $out.='<script>var mp3nonce="'.wp_create_nonce("church_admin_mp3_play").';"</script>';
    return $out;
}



function church_admin_podcast_files_list($series_id,$page=1,$limit=5,$speaker=NULL,$search=NULL,$order='DESC')
{
    global $wpdb;
    if(!empty($order))
    {
        switch($order)
        {
            case'ASC':$order='ASC';break;    
            default:case'DESC':$order='DESC';break;   
        }
    }else $order='DESC';
    $out='';
    $template='<div class="ca-media-list-item" data-id="{file_id}" data-date="{pub_date}" title="'.__('Click to play sermon','church-admin').'"><span class="dashicons dashicons-controls-play ca-play"></span><h3>{title}</h3><span class="ca-name">{speakers}</span><br>{human_date}</div>';
    $searchTerm='';
    if(!empty($search))
    {
        $searchTerm=stripslashes($search);
        $s='%'.esc_sql($searchTerm).'%';
        $sql='SELECT * FROM '.CA_FIL_TBL.' WHERE file_title LIKE "'.$s.'" OR file_description LIKE "'.$s.'" OR speaker LIKE "'.$s.'" OR bible_texts LIKE "'.$s.'" ORDER BY pub_date '.$order;
    }
    else
    {
        $SQL=array();
        if(!empty($speaker))
        {
            $speaker=stripslashes($speaker);
            $SQL[]=' AND speaker LIKE "%'.esc_sql($speaker).'%"';
        }
        if(!empty($series_id))
        {
            //Get Series Name
            $seriesName=$wpdb->get_var('SELECT series_name FROM '.CA_SERM_TBL.' WHERE series_id="'.(int)$series_id.'"');
            if(!empty($seriesName))$out.='<h2>'.sprintf(__('%1$s series','church-admin'),$seriesName).'</h2>';
            $SQL[]= 'AND series_id="'.(int)$series_id.'"';
        }
        
        $sql='SELECT * FROM '.CA_FIL_TBL.' WHERE 1=1 '.implode('',$SQL).' ORDER BY pub_date '.$order; 
    }
    if(defined('CA_DEBUG'))church_admin_debug($sql);
    $countResult=$wpdb->get_results($sql);
    $count=$wpdb->num_rows;
    //church_admin_debug("Count: $count");
    //church_admin_debug("Page: $page");
    if($page==0){$paged=0;}else{$paged=($page-1)*$limit;}
    $results=$wpdb->get_results($sql.' LIMIT '.($paged).','.$limit);
   
    if(empty($results))return __('No sermons found');
    else
    {
        foreach($results AS $row )
        {
            $thisFile=$template;
            $thisFile=str_replace('{file_id}',$row->file_id,$thisFile);
            $thisFile=str_replace('{pub_date}',$row->pub_date,$thisFile);
            $thisFile=str_replace('{title}',$row->file_title,$thisFile);
            $thisFile=str_replace('{speakers}',$row->speaker,$thisFile);
            $thisFile=str_replace('{human_date}',mysql2date(get_option('date_format').' '.get_option('time_format'),$row->pub_date),$thisFile);
            $out.=$thisFile;
        }
    }

        $next=$page+1;
        $prev=$page-1;
        if($prev>0)$out.='<span class="more-sermons prev-sermons btn btn-danger" data-page="'.$prev.'" data-search="'.esc_html($search).'" data-series="'.(int)$series_id.'" data-limit="'.$limit.'" data-speaker="'.esc_html($speaker).'">'.__('Previous','church-admin').'</span>';
        if($count>=($limit*$page)&&$next>0)$out.='<span class="more-sermons next-sermons btn btn-danger" data-page="'.$next.'" data-search="'.esc_html($search).'" data-series="'.(int)$series_id.'" data-limit="'.$limit.'" data-speaker="'.esc_html($speaker).'">'.__('Next','church-admin').'</span>';
   
    return $out; 
}
function church_admin_podcast_menu($page,$limit,$series_id)
{
    global $wpdb;
    $out='';
    $ca_podcast_settings=get_option('ca_podcast_settings');
    if(!empty($ca_podcast_settings['itunes_link'])||!empty($ca_podcast_settings['spotify_link']))$out.='<div class="ca-podcast-links">';
	if(!empty($ca_podcast_settings['itunes_link']))$out.='<a title="Download on Itunes" href="'.$ca_podcast_settings['itunes_link'].'">
<img class="alignleft" alt="iTunes" src="'.plugins_url('/images/badge_itunes-lrg.png',dirname(__FILE__) ).'" width="110" height="40" /></a>';
    if(!empty($ca_podcast_settings['spotify_link']))$out.='&nbsp; <a title="Download on Spotify" href="'.$ca_podcast_settings['spotify_link'].'">
<img alt="Spotify" class="alignleft" src="'.plugins_url('/images/spotify.png',dirname(__FILE__) ).'" width="110" height="40" /></a>';
    if(!empty($ca_podcast_settings['itunes_link'])||!empty($ca_podcast_settings['spotify_link']))$out.='</div>';
    //search
    $out.='<div class="ca-podcast-search">
    <input type="text" class="church-admin-form-control sermon-search" name="sermon-search" placeholder="'.__('Search sermons','church-admin').'"><div class="ca-podcast-input-group-append"><button class="ca-sermon-search btn btn-secondary" data-page="'.(int)$page.'" data-limit="'.(int)$limit.'"  type="button">?</button></div></div>';
    //series
    $series=$wpdb->get_results('SELECT * FROM '.CA_SERM_TBL.' ORDER BY last_sermon DESC');
    if(!empty($series))
    {
        $out.='<div class="church-admin-form-group"><select data-page="'.(int)$page.'" data-limit="'.(int)$limit.'" class="ca-series-dropdown" name="series_id"><option value="'.(int)$series_id.'">'.__('Or choose Series','church-admin').'</option>';
        foreach($series AS $seriesRow)
        {
            $out.='<option value="'.(int)$seriesRow->series_id.'">'.esc_html($seriesRow->series_name).'</option>';
        }
        $out.='</select></div>';
    }
    //speaker
    $speakers=$wpdb->get_results('SELECT DISTINCT(speaker) FROM '.CA_FIL_TBL);
    if(!empty($speakers))
    {
        $speakerArray=array();
        foreach($speakers AS $speaker)
        {
            if(strpos($speaker->speaker,","))
            {
                
                $speakers=array_filter(explode(",",$speaker->speaker));
                foreach($speakers AS $key=>$name)
                {
                    $name=str_replace("  "," ",trim($name));
                    if(!empty($name) && !in_array($name,$speakerArray))$speakerArray[]=$name;
                }
               
                
            }else $speakerArray[]=trim($speaker->speaker);
        }
        
        $speakerArray=array_unique(array_filter($speakerArray),SORT_STRING );
        asort($speakerArray);
        $out.='<div class="church-admin-form-group"><select data-page="'.(int)$page.'" data-limit="'.(int)$limit.'" class="ca-speaker-dropdown" name="speaker"><option value="'.(int)$series_id.'">'.__('Or choose Speaker','church-admin').'</option>';
        foreach($speakerArray AS $key=>$name)
        {
            $out.='<option value="'.esc_html(trim($name)).'">'.esc_html(trim($name)).'</option>';
        }
        $out.='</select></div>';
        $out.='<div class="church-admin-form-group"><select data-page="'.(int)$page.'" data-limit="'.(int)$limit.'" class="ca-order" name="order"><option value="DESC">'.__('Newest first','church-admin').'</option><option value="ASC">'.__('Oldest First','church-admin').'</option></select></div>';
    }
    return $out;
}

 function church_admin_podcast_series_detail($series_id=NULL,$exclude)
 {
 		global $wpdb,$podcastSettings;
        if(empty($exclude))$exclude=array();
 		$out='';

 		if(!empty($series_id))
 		{
 			$detail=$wpdb->get_row('SELECT * FROM '.CA_SERM_TBL.' WHERE series_id="'.(int)$series_id.'" ');
 			if(!empty($detail))
 			{

 				if(!empty($detail->series_name)&&!in_array('seriesName',$exclude)){$out.='<h2>'.sprintf(__('%1$s series','church-admin'),esc_html($detail->series_name)).'</h2>';}
 				if(!empty($detail->series_image)&&!in_array('seriesImage',$exclude)){$out.='<p>'.wp_get_attachment_image( $detail->series_image,'large','',array('class'=>'img-responsive')).'</p>';}

 				if(!empty($detail->series_description)&&!in_array('seriesDescription',$exclude)){$out.='<p>'.$detail->series_description.'</p>';}
 			}


 		}

 	return $out;

 }
  
function church_admin_podcast_file_detail($fileID,$exclude=NULL)
{
	global $wpdb,$wp_embed,$post;
    $podcastSettings=get_option('ca_podcast_settings');
	if(empty($exclude))$exclude=array();
	$out='';
	$upload_dir = wp_upload_dir();
	$path=$upload_dir['basedir'].'/sermons/';
	$url=content_url().'/uploads/sermons/';
	if(!is_user_logged_in()){$private=' AND a.private="0" ';}else{$private='';}
	if(empty($fileID)){return("<p>There is no file to display</p>");}
	else
	{
		$sql='SELECT a.*,b.* FROM '.CA_FIL_TBL.' a LEFT JOIN  '.CA_SERM_TBL.' b ON a.series_id=b.series_id WHERE a.file_id="'.esc_sql($fileID).'"'.$private;
    	$data=$wpdb->get_row($sql);
        if(empty($data)){return("<p>There is no file to display</p>");}
		else
		{
			
			//now playing tab
				if(!empty($data->file_title))$out.='<h2>'.esc_html($data->file_title).'</h2>';
				if(!empty($data->video_url))
                {
                    if(strpos($data->video_url, 'amazonaws.com/') !== false)
                    {
                       $out.='<video class="ca-video" width="560" height="315" controls><source src="'.$data->video_url.'" type="video/mp4">Your browser does not support the video tag.
</video>'; 
                    }else
                    {
                        $video=church_admin_generateVideoEmbedUrl($data->video_url);
                        $videoUrl=$video['embed'];
                        $out.='<div style="width:100%"><div style="position:relative;padding-top:56.25%"><iframe class="ca-video" style="position:absolute;top:0;left:0;width:100%;height:100%;" src="'.$video['embed'].'" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe></div></div>';
                        $views=church_admin_youtube_api($video['id']);
                    }
                }

				if(!empty($data->file_name)&& file_exists($path.$data->file_name))
                {
                    $out.='<p><audio class="sermonmp3" data-id="'.esc_html($data->file_id).'" src="'.esc_url($url.$data->file_name).'" preload="auto" controls></audio></p>';
				    if(!in_array('download',$exclude))$download='<a href="'.esc_url($url.$data->file_name).'" class="mp3download" data-id="'.(int)$data->file_id.'" title="'.esc_html($data->file_title).'" download>'.esc_html($data->file_title).'</a>';
				}
				elseif(!empty($data->external_file))
				{
						$out.='<p><audio class="sermonmp3" data-id="'.esc_html($data->file_id).'" src="'.esc_url($data->external_file).'" preload="auto" controls></audio></p>';

						$download='<a href="'.esc_url($data->external_file).'" class="mp3download" data-id="'.(int)$data->file_id.'" title="'.esc_html($data->file_title).'" download>'.esc_html($data->file_title).'</a>';
				}
				if(!in_array('nowPlaying',$exclude))
				{
					
							
					
						
						$plays=church_admin_plays($data->file_id);
						$out.='<div class="ca-podcast-file-content ca-tab-content">';
							if(!empty($data->file_description)&&!in_array('fileDescription',$exclude))$out.='<p>'.$data->file_description.'</p>';
							$out.='<table>';
								if(!empty($data->speaker)&&!in_array('speaker',$exclude))$out.='<tr><td>'.__('Speaker','church-admin').':&nbsp;</td><td class="ca-names">'.esc_html($data->speaker).'</td></tr>';
								if(!empty($data->series_name)&&!in_array('seriesName',$exclude))$out.='<tr><td>'.__('Series','church-admin').':&nbsp;</td><td>'.esc_html($data->series_name).'</td></tr>';
								if(!empty($data->pub_date)&&!in_array('date',$exclude))$out.='<tr><td>'.__('Date','church-admin').':&nbsp;</td><td>'.mysql2date(get_option('date_format'),$data->pub_date).'</td></tr>';
								if(!empty($download)&&!in_array('download',$exclude))$out.='<tr><td>'.__('Download','church-admin').':&nbsp;</td><td>'.$download.'</td></tr>';
								$showPlays=FALSE;
                                if(!empty($data->file_name))$showPlays=TRUE;
                                if(!empty($data->external_file))$showPlays=TRUE;
                                if(isset($plays)&&!in_array('plays',$exclude)&&$showPlays)
                                {
                                    $out.='<tr><td>'.__('Plays','church-admin').':&nbsp;</td><td class="plays">'.$plays.'</td></tr>';
                                }
                                if(isset($views)&&!in_array('views',$exclude)&&$showPlays)
                                {
                                    $out.='<tr><td>'.__('Views','church-admin').':&nbsp;</td><td class="views">'.$views.'</td></tr>';
                                }
								if(!empty($data->bible_texts))
								{
									$pass=array();
									$version=get_option('church_admin_bible_version');
									$passages=explode(",",$data->bible_texts);
									if(!empty($passages)&&is_array($passages))
									{
										foreach($passages AS $passage)$pass[]='<a href="https://www.biblegateway.com/passage/?search='.urlencode($passage).'&version='.$version.'&interface=print" target="_blank">'.esc_html($passage).'</a>';

										if(!in_array('bible',$exclude))$out.='<tr><td>'.__('Scriptures','church-admin').':&nbsp;</td><td>'.implode(", ",$pass).'</td></tr>';
									}
								}
                                if(!empty($data->transcript))
                                {
                                    $out.='<tr><td>'.__('Sermon Notes','church-admin').':&nbsp;</td><td><a href="'.site_url().'?ca_download=sermon-notes&amp;file_id='.(int)$data->file_id.'">PDF</a></td></tr>';
                                }
                                if(!in_array('sharing',$exclude))
                                {
                                    $URL=church_admin_find_sermon_page(); 
                                    $url=urlencode($URL.'?sermon='.$data->file_slug);
                                    $title=urlencode(str_replace('"','',$data->file_title));
                                    
                                    $share='<a target="_blank" class="ca-share" style="text-decoration:none" href="https://www.facebook.com/sharer/sharer.php?u='.$URL.'?sermon='.$data->file_slug.'"><span class="dashicons dashicons-facebook"></span></a> &nbsp;';
                                    $share.='<a  class="ca-share" style="text-decoration:none" target="_blank"  href="https://twitter.com/intent/tweet?text='.$title.'&url='.$url.'"><span class="dashicons dashicons-twitter"></span></a>&nbsp;';
                                    $share.='<a style="text-decoration:none" href="mailto:?subject='.$title.'&amp;body='.$url.'"><span class="dashicons dashicons-email"></span></a>&nbsp;';
                                    $share.='<a class="copy-me" style="text-decoration:none" href="'.$url.'"><span class="dashicons dashicons-admin-links"></span></a><a href="sms:?body='.$url.'"><span class="dashicons dashicons-smartphone" style="text-decoration:none"></span></a>';
                                    $out.='<tr style="vertical-align:middle"><td>'.__('Share this sermon','church-admin').':&nbsp;</td><td>'.$share.'</td></tr>';
                                }
							$out.='</table>';
							$out.='</div><!--ca-podcast-file-content-->';
				}
						

					
					
				
		}
	}

	$out=do_shortcode($out);
	return $out;
}


function church_admin_player($file_id)
{
    global $wpdb,$podcastSettings;
    $sermon=$wpdb->get_var('SELECT file_name FROM '.CA_FIL_TBL.' WHERE file_id="'.(int)$file_id.'"');
    if(!empty($sermon))
    {
        $upload_dir = wp_upload_dir();
	   $path=$upload_dir['basedir'].'/sermons/';
	   $url=content_url().'/uploads/sermons/';
        if(!empty($sermon)){$out='<p><audio class="sermonmp3" data-id="'.esc_html($file_id).'" src="'.esc_url($url.$sermon).'" preload="auto" controls></audio></p>';}
    }else{$out=__('No sermon file found','church-admin');}
    return $out;

}
    
