<?php

if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly


function church_admin_small_group_list($map=1,$zoom=13,$photo=FALSE,$loggedin=1,$title=NULL,$pdf=TRUE,$no_address=FALSE)
{
	global $wpdb,$wp_locale;
    

	if(empty($title))$title=__('Small Groups PDF','church-admin');
	//show small groups
	if(empty($loggedin)||($loggedin && is_user_logged_in()))
	{
		$out="";
		if(!empty($pdf)&&empty($no_address))$out.='<p><a href="'.home_url().'/?ca_download=smallgroups&title='.urlencode($title).'">'.__('PDF of small groups','church-admin').'</a></p>';
		$key=get_option('church_admin_google_api_key');
		if(!empty($key))
		{
			//Get centre of groups
            $centre=$wpdb->get_row('SELECT AVG(lat) AS lat, AVG(lng) AS lng FROM '.CA_SMG_TBL.' WHERE lat!="" AND lng!=""');
           
            if(empty($centre->lat)||empty($centre->lng))$centre=$wpdb->get_row('SELECT lat, lng FROM '.CA_SIT_TBL.' ORDER BY site_id ASC LIMIT 1');
			if(!empty($centre)&& !empty($map))
			{

				$out.='<script type="text/javascript">var xml_url="'.site_url().'/?ca_download=small-group-xml&small-group-xml='.wp_create_nonce('small-group-xml').'";';
				if(!empty($centre->lat)){$out.=' var lat='.esc_html($centre->lat).';';}
				if(!empty($centre->lng)){$out.=' var lng='.esc_html($centre->lng).';';}
				if(!empty($zoom)){$out.=' var zoom='.intval($zoom).';';}else{$out.=' var zoom=13;';}
				if(!is_admin()){$out.='jQuery(document).ready(function(){sgload(lat,lng,xml_url,zoom);})</script><div id="map" class="ca-small-group-map" >Map loads onfront end!</div>';}
				else{$out.='jQuery(document).ready(function(){sgload(lat,lng,xml_url,zoom);})</script><div id="admin_map" class="ca-small-group-map" >Map loads onfront end!</div>';}
			}
		}
		$leader=array();
			$sql='SELECT * FROM '.CA_SMG_TBL.' WHERE id!="1" ORDER BY group_day,group_time';
			$results = $wpdb->get_results($sql);
			if(!empty($results))
			{
				
				if(!$photo)
				{
					$out.='<ul>';
					foreach ($results as $row) 
					{
							if(!empty($row->group_day))
                            {
                                $day=$wp_locale->get_weekday($row->group_day);
                            }
                            else $day='';
                            $out.='<li><strong>'.esc_html($row->group_name).'</strong> '.$day.' '.mysql2date(get_option('time_format'),$row->group_time);
                            if(empty($no_address))$out.=' '.esc_html($row->address);
                            if(!empty($row->description))$out.='<br/>'.$row->description;
                            $out.='</li>';
					}
					$out.='</ul>';
				}
				else
				{
					/***************************
					*
					* Photo Style
					*
					****************************/
					$out.='<div class="ca-small-groups">';
					foreach ($results as $row) 
					{
						$out.='<div class="ca-small-group" id="group-'.(int)$row->id.'"><div class="ca-small-group-content">';
						
						if(!empty($row->attachment_id))
						{
							$out.=wp_get_attachment_image( $row->attachment_id,'large');
						}
						else
						{
							$out.= '<img src="'.plugins_url('/images/default-avatar.jpg',dirname(__FILE__) ).'" class="frontend-image current-photo " alt="'.__('Photo of Person','church-admin').'" id="frontend-image" />';
						}
						$out.='<p><i class="fas fa-home"></i>&nbsp;<strong>'.esc_html($row->group_name).'</strong></p>';
						$frequency='';
						if(!empty($row->frequency))$frequency=$row->frequency;
						$out.='<p><i class="far fa-calendar-alt"></i>&nbsp; '.sprintf(__('%1$s on %2$s','church-admin'),$frequency,$wp_locale->get_weekday($row->group_day)).'</p>';
						$out.='<p><i class="far fa-clock"></i> &nbsp;'.mysql2date(get_option('time_format'),$row->group_time).'</p>';
						if(empty($no_address))$out.='<p> <i class="fas fa-map-marker-alt"></i>&nbsp;'.esc_html($row->address).'</p>';
						if(!empty($row->description))$out.='<p>'.$row->description.'</p>';
						if(!empty($row->max_attendees))
						{
							$noOfPeople=$wpdb->get_var('SELECT COUNT(people_id) FROM '.CA_MET_TBL.' WHERE meta_type="smallgroup" AND ID="'.(int)$row->id.'"');
							$optimum=intval($noOfPeople*0.75);
							$out.='<p><meter min="0" max="'.$row->max_attendees.'" value="'.intval($noOfPeople).'" optimum="'.$optimum.'"></meter></p>';
							if(is_admin())$out.='<p>'.esc_html(sprintf(__('%1$s attendees out of a maximum %2$s','church-admin'),$noOfPeople,$row->max_attendees)).'</p>';
						}
						if(is_admin()){$out.='<p><a class="button-primary" href="'.wp_nonce_url("admin.php?page=church_admin/index.php&section=small_groups&amp;action=edit_small_group&id=".$row->id,'edit_small_group').'"><i class="far fa-edit"></i> '.__('Edit small group','church-admin').'</a></p><p><a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" class="button-secondary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&action=delete_small_group&section=small_groups&amp;id='.$row->id,'delete_small_group').'">'.__('Delete small group','church-admin').'</a></p>';}
						$out.="</div></div><!--small-group-->\r\n";
					}
					$out.="</div><div style='clear:left'></div><!--small-groups-->\r\n";
				}
			}
	}
	else{
        
        $out='<p>'.__('You need to be logged in to view our small groups','church-admin').'</p>';
        $out.=wp_login_form(array('echo'=>FALSE));
    }

	return $out;
}

