<?php

if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly

/*

Author URI: https://pento.net/
License: GPLv2+
*/

function church_admin_plugin_block_categories( $categories, $post ) {

    return array_merge(
        $categories,
        array(
            array(
                'slug' => 'church-admin',
                'title' => __( 'Church Admin', 'church-admin' )
            ),
        )
    );
}
add_filter( 'block_categories', 'church_admin_plugin_block_categories', 10, 2 );



add_action('enqueue_block_assets','church_Admin_block_assets');
function church_Admin_block_assets()
{
    global $church_admin_version;
    wp_enqueue_script('church-admin-calendar-script',plugins_url( '/', dirname(__FILE__ )) . 'includes/calendar.js',array( 'jquery' ),FALSE, TRUE);
	wp_enqueue_script('church-admin-calendar',plugins_url( '/', dirname(__FILE__ )) . 'includes/jQueryCalendar.js',array( 'jquery' ),FALSE, TRUE);
	wp_enqueue_script('church_admin_map', plugins_url('includes/google_maps.js',dirname(__FILE__) ), array( 'jquery' ) ,FALSE);
	wp_enqueue_script('church_admin_frontend_sg_map_script', plugins_url('includes/smallgroup_maps.js',dirname(__FILE__) ), array( 'jquery' ) ,FALSE);
   wp_enqueue_script('ca_podcast_audio_use',plugins_url('includes/audio.use.js',dirname(__FILE__)), array( 'jquery' ),$church_admin_version ,FALSE);
    wp_enqueue_script('church-admin-giving-form',plugins_url( '/', dirname(__FILE__ )) . 'includes/giving.js',array( 'jquery' ),FALSE, TRUE);
}
add_action('wp_enqueue_scripts','church_admin_gutenberg_translation');
function church_admin_gutenberg_translation(){
	if(function_exists('wp_get_jed_locale_data'))wp_add_inline_script(
		'church-admin-gutenberg-translation',
		'wp.i18n.setLocaleData( ' . json_encode(  wp_get_jed_locale_data( 'church-admin' ) ) . ', "church-admin" );',
		'before'
	);
	if ( function_exists( 'wp_set_script_translations' ) ) {
				wp_set_script_translations( 'church-admin', 'church-admin' );
				
		}
}

/**
 * Register our block and shortcode.
 */
function ca_block_init() {
	// Register our block editor script.
	wp_register_script(
		'php-block',
		plugins_url( 'php-blocks.js', __FILE__ ),
		array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-components', 'wp-editor' )
	);

	
	/***********************************************************************************************
	*
	* Adddress list
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/address-list', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string','default'=>__('All','church-admin')),
			'pdf'=> array('type' => 'boolean','default'=>1),
			'logged_in' => array('type' => 'boolean','default'=>1),
			'map'=> array('type' => 'boolean','default'=>1),
			'photo'=> array('type' => 'boolean','default'=>1),
			'kids'=> array('type' => 'boolean','default'=>1),
			'site_id'=> array('type' => 'string','default'=>''),
			'updateable'=> array('type' => 'boolean','default'=>1),
            'vcf'=> array('type' => 'boolean','default'=>1)
			
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Address List','church-admin' ),
		__( 'Directory','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_address_list',
	) );
	/**************
    *
    * Giving
    *
    **************/
    	register_block_type( 'church-admin/giving', array(
		'attributes'      => array(),
            'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Giving','church-admin' ),
		__( 'PayPal','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_giving',
	) );
       	register_block_type( 'church-admin/pledges', array(
		'attributes'      => array(),
            'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Giving','church-admin' ),
		__( 'Pledges','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_pledge',
	) );
    /***********************************************************************************************
	*
	* Attendance
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/attendance', array(
		'attributes'      => array(),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_attendance',
	) );
	/***********************************************************************************************
	*
	* Birthdays
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/birthdays', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string','default'=>__('Member','church-admin')),
			'people_type_id' => array('type' => 'string','default'=>__('Child','church-admin')),
			'days' => array('type' => 'string','default'=>31),
            'show_age'=>array('type'=>'boolean','default'=>FALSE)
		),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_birthdays',
	) );
	/***********************************************************************************************
	*
	* Calendar
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/calendar', array(
		'attributes'      => array(
			'style' => array('type' => 'string','default'=>0)
			
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Calendar','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_calendar',
	) );
	/***********************************************************************************************
	*
	* Front end register.
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/register', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string','default'=>__('Visitor','church-admin')),
			'create_user' => array('type' => 'boolean','default'=>FALSE),
		),
		'keywords'=>array(
		__( 'Church Admin' ,'church-admin'),
		__( 'Front End Register','church-admin' ),
		__( 'User edit','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_register',
	) );
	/***********************************************************************************************
	*
	*Graph
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/graph', array(
		'attributes'      => array(
			'width' => array('type' => 'string','default'=>900),
			'height' => array('type' => 'string','default'=>500)
		),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_graph',
	) );
	/***********************************************************************************************
	*
	* Member Map
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/member-map', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string'),
			'zoom'=> array('type' => 'string','default'=>12),
			'width' => array('type' => 'string','default'=>"100%"),
			'height' => array('type' => 'string','default'=>500)
		),
		'keywords'=>array(
		__( 'Church Admin' ,'church-admin'),
		__( 'Map','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_member_map',
	) );
	/***********************************************************************************************
	*
	* Ministries
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/ministries', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string','default'=>__('Member','church-admin')),
			'ministry_id' => array('type' => 'string','default'=>'#')
		),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_ministries',
	) );
	/***********************************************************************************************
	*
	* My rota
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/my-rota', array(
		'attributes'      => array(),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_my_rota',
	) );
	
	/***********************************************************************************************
	*
	* Sermon Podcast
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/sermon-podcast', array(
		'attributes'      => array(
			'series_name'=> array('type' => 'string','default'=>NULL),
			'sermon_title'=> array('type' => 'string','default'=>NULL),
			'most_popular'=>array('type' => 'boolean','default'=>1),
			'order'=>array('type'=>'string','default'=>'DESC'),
			'exclude'=>array('type'=>'string','default'=>''),
            'howmany'=>array('type'=>'string','default'=>5)
		),'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Media','church-admin' ),
			__( 'Sermons','church-admin' ),
			__( 'Podcast','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_podcast',
	) );




	/***********************************************************************************************
	*
	* Rota
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/rota', array(
		'attributes'      => array(
			'weeks'=> array('type' => 'string','default'=>5),
			'service_id' => array('type' => 'string','default'=>1),
			'logged_in' => array('type' => 'boolean','default'=>1),
            'title'=> array('type' => 'string','default'=>__("Schedule")),
            'initials'=>array('type'=>'boolean','default'=>0)
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Rota','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_rota',
	) );
    /***********************************************************************************************
	*
	* Service Prebooking
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/service-booking', array(
		'attributes'      => array(
			'days'=> array('type' => 'string','default'=>7),
            'booking_mode'=>array('type'=>'string','default'=>'individuals'),
			'service_id' => array('type' => 'string','default'=>1),
			'max_fields' =>array('type' => 'string','default'=>5),
            'admin_email_address' =>array('type' => 'string','default'=>get_option('admin_email')),
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Rota','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_service_booking',
	) );
	/***********************************************************************************************
	*
	* Small Groups List
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/small-groups-list', array(
		'attributes'      => array(
			'map'=> array('type' => 'boolean','default'=>1),
			'zoom' => array('type' => 'string','default'=>12),
			'title' => array('type' => 'string','default'=>'Small Groups'),
			'photo'=> array('type' => 'boolean','default'=>1),
			'loggedin'=>array('type' => 'boolean','default'=>1),
			'pdf'=>array('type' => 'boolean','default'=>1),
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Small groups','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_smallgroups',
	) );
	/***********************************************************************************************
	*
	* Small Groups Members
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/small-group-members', array(
		'attributes'      => array(
			'member_type_id' => array('type' => 'string','default'=>__('Member','church-admin')),
			
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Small groups','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_smallgroup_members',
	) );
    /***********************************************************************************************
	*
	* Small Groups Signup
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/small-groups-signup', array(
		'attributes'      => array(
			'people_types' => array('type' => 'string','default'=>__('Adults','church-admin')),
			'title' => array('type' => 'string','default'=>__('Small Groups Signup','church-admin')),
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Small groups','church-admin' ),
            __( 'Small groups signup','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_smallgroups_signup',
	) );
	/***********************************************************************************************
	*
	* Serving
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/serving', array(
		'attributes'      => array(
			'logged_in' => array('type' => 'boolean','default'=>1),
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Serving','church-admin' ),
		__( 'Volunteer','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_serving',
	) );
	/***********************************************************************************************
	*
	* Sessions
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/sessions', array(
		
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Sessions','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_sessions',
	) );
	/***********************************************************************************************
	*
	* Recent
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/recent', array(
		'attributes'      => array(
			'weeks' => array('type' => 'string','default'=>1)
			
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Recent activity','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_recent',
	) );

	/***********************************************************************************************
	*
	* Volunteer
	*
	***********************************************************************************************/
	register_block_type( 'church-admin/volunteer', array(
		
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Volunteer','church-admin' ),
			__( 'Serve','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_volunteer',
	) );
    
    /***********************************************************************************************
	*
	* Video Embed
	*
	***********************************************************************************************/
    
    register_block_type( 'church-admin/video-embed', array(
		'attributes'      => array(
			'url' => array('type' => 'string','default'=>''),
            'show_views'=>array('type'=>'boolean','default'=>1),
            'container'=>array('type'=>'string','default'=>'alignfull')
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Video','church-admin' ),
		__( 'YouTube','church-admin' )
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_video',
	) );
    register_block_type( 'church-admin/sermon-series', array(
		'attributes'      => array(
			'sermon_page' => array('type' => 'string','default'=>''),
            'cols'=>array('type'=>'integer','default'=>3),
            
		),
		'keywords'=>array(
		__( 'Church Admin','church-admin' ),
		__( 'Sermons','church-admin' ),
		
	),
		'editor_script'   => 'php-block', // The script name we gave in the wp_register_script() call.
		'render_callback' => 'ca_block_series',
	) );
}
add_action( 'init', 'ca_block_init' );

/**
 * Our combined block and shortcode renderer.
 *
 * For more complex shortcodes, this would naturally be a much bigger function, but
 * I've kept it brief for the sake of focussing on how to use it for block rendering.
 *
 * @param array $attributes The attributes that were set on the block or shortcode.
 */
function ca_block_service_booking($attributes)
{
   
    wp_enqueue_script('church-admin-form-case-enforcer');
    require_once(plugin_dir_path(dirname(__FILE__)).'display/covid-prebooking.php');
    $out= church_admin_covid_attendance(intval($attributes['service_id']),intval($attributes['booking_mode']),intval($attributes['max_fields']),intval($attributes['days']),$attributes['admin_email_address']);
    return $out;
}
function ca_block_video( $attributes ) {
    
    $embed=church_admin_generateVideoEmbedUrl($attributes['url']);
    $container=$attributes['container'];
    $out='<div class="'.$container.'"><div style="position:relative;padding-top:56.25%"><iframe class="ca-video" style="position:absolute;top:0;left:0;width:100%;height:100%;" src="'.$embed['embed'].'" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe></div></div>';
    $views=church_admin_youtube_api($embed['id']);
    if(!empty($views)&& !empty($attribute['show_views']))$out.='<p>'.sprintf(__('%1$s views','church-admin'),$views).'</p>';
    return $out;
}


function ca_block_calendar( $attributes ) {
	
	wp_enqueue_script('church_admin_calendar');
	$out='<table><tr><td>'.__('Year Planner pdfs','church-admin').' </td><td>  <form name="guideform" action="'.$_SERVER['PHP_SELF'].'" method="get"><select name="guidelinks" onchange="window.location=document.guideform.guidelinks.options[document.guideform.guidelinks.selectedIndex].value"> <option selected="selected" value="">-- '.__('Choose a pdf','church-admin').' --</option>';
	for($x=0;$x<5;$x++)
	{
		$y=date('Y')+$x;
		$out.='<option value="'.home_url().'/?ca_download=yearplanner&amp;yearplanner='.wp_create_nonce('yearplanner').'&amp;year='.$y.'">'.$y.__('Year Planner','church-admin').'</option>';
	}
	$out.='</select></form></td></tr></table>';
	if(!empty($attributes['style']))
	{
		require_once(plugin_dir_path(dirname(__FILE__)) .'display/calendar.php');
		$out.=church_admin_display_calendar(TRUE);
	}
	else
	{	
		require_once(plugin_dir_path(dirname(__FILE__)) .'display/calendar.new.php');
		$out.=church_admin_display_new_calendar();
	
	}
	return $out;
}
function ca_block_podcast( $attributes ) {
	
    
    require_once(plugin_dir_path(dirname(__FILE__)) .'display/sermon-podcast.php');
	global $wpdb;
	$wpdb->show_errors;
	$file_id=$series_id=NULL;
    if(!empty($attributes['howmany']))
    {
        $limit=intval($attributes['howmany']);
    }
    else{$limit=5;}
	if(!empty($attributes['series_name']))
	{
		$series_id=$wpdb->get_var('SELECT series_id FROM '.CA_SERM_TBL.' WHERE series_name LIKE "%'.esc_sql($attributes['series_name']).'%"');
		$file_id=NULL;
	}
	if(!empty($attributes['sermon_title']))
	{
		$file_id=$wpdb->get_var('SELECT file_id FROM '.CA_SER_TBL.' WHERE file_title LIKE "%'.esc_sql($attributes['sermon_title']).'%"');
		$series_id=NULL;
	}
	
	return church_admin_podcast_display($series_id,$file_id,$attributes['exclude'],$attributes['most_popular'],$attributes['order'],$limit);
}
function ca_block_ministries( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'display/ministries.php');
	$member_type_id=implode(",",church_admin_get_member_type_ids($attributes['member_type_id']));
	return church_admin_frontend_ministries($attributes['ministry_id'],$member_type_id);
}
function ca_block_serving( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'display/volunteer.php');
	return church_admin_display_volunteer();
}
function ca_block_sessions( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'includes/sessions.php');
	return church_admin_sessions(NULL,NULL);
}
function ca_block_register( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'includes/front_end_register.php');
	$member_type_id=1;
	$member_type_id=implode(",",church_admin_get_member_type_ids($attributes['member_type_id']));
	return church_admin_front_end_register($attributes['create_user'],$member_type_id,array());
}
function ca_block_address_list( $attributes ) {
    global $wpdb;
    
    
	require_once(plugin_dir_path(dirname(__FILE__)) .'display/address-list.php');
	
	if(!empty($attributes['member_type_id'])&&($attributes['member_type_id']!=__('All','church-admin'))){$member_type_id=implode(",",church_admin_get_member_type_ids($attributes['member_type_id']));}else{$member_type_id=NULL;}
	
    $out='';
	$api_key=FALSE;
	$api_key=get_option('church_admin_google_api_key');
	$access=TRUE;
	if(is_user_logged_in())
    {
      	
      	$current_user=wp_get_current_user();
      	$people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE user_id="'.(int)$current_user->ID.'"');
      	$restrictedList=get_option('church-admin-restricted-access');
      	if(is_array($restrictedList)&&in_array($people_id,$restrictedList))$access=FALSE;
    }
    if(empty($attributes['logged_in'])||(is_user_logged_in()&&!empty($access)))
    {
       
		if(!empty($attributes['pdf']))
		{
			$out.='<p><a  target="_blank" href="'.home_url().'/?ca_download=addresslist-family-photos&amp;kids='.$attributes['kids'].'&amp;addresslist='.wp_create_nonce('address-list','address-list' ).'&amp;member_type_id='.$member_type_id.'">'.__('PDF version','church-admin').'</a></p>';
					
		}
		require_once(plugin_dir_path(dirname(__FILE__)).'display/address-list.php');
       $out.=church_admin_frontend_directory($member_type_id,$attributes['map'],$attributes['photo'],$api_key,$attributes['kids'],$attributes['site_id'],$attributes['updateable'],FALSE,0,$attributes['vcf']);
        
        	
    }
    else //login required
    {
		if(empty($access)) $out.='<h2>'.__('You have not been granted access to the address list','church-admin').'</h2>';
		else $out.='<div class="login"><h2>'.__('Please login','church-admin').'</h2>'.wp_login_form(array('echo'=>FALSE)).'</div>'.'<p><a href="'.wp_lostpassword_url(get_permalink() ).'" title="Lost Password">'.__('Help! I don\'t know my password','church-admin').'</a></p>';
    }
    return $out;
}
function ca_block_rota( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'display/rota.php');
	$out='';
    church_admin_debug($attributes);
	 if(is_user_logged_in()||empty($attributes['logged_in']))
	{
       
        if(!empty($_REQUEST['rota_date'])){$date=$_REQUEST['rota_date'];}else{$date=date('Y-m-d');}
        	$out.=church_admin_front_end_rota($attributes['service_id'],$attributes['weeks'],TRUE,$date,$attributes['title'],$attributes['initials']);
	}
	else //login required
	{
		$out.='<div class="login"><h2>'.__('Please login','church-admin').'</h2>'.wp_login_form(array('echo'=>FALSE)).'</div>'.'<p><a href="'.wp_lostpassword_url(get_permalink() ).'" title="Lost Password">'.__('Help! I don\'t know my password','church-admin').'</a></p>';
	}
	return $out;
}
function ca_block_my_rota( $attributes ) {
	require_once(plugin_dir_path(dirname(__FILE__)) .'display/rota.php');
	if(empty($loggedin)||is_user_logged_in())
	{
        $out=church_admin_my_rota();
	}
	else //login required
	{
		$out='<div class="login"><h2>'.__('Please login','church-admin').'</h2>'.wp_login_form(array('echo'=>FALSE)).'</div>'.'<p><a href="'.wp_lostpassword_url(get_permalink() ).'" title="Lost Password">'.__('Help! I don\'t know my password','church-admin').'</a></p>';
	}
	return $out;
}
function ca_block_smallgroups( $attributes ) {
	wp_enqueue_script('church_admin_google_maps_api');
	wp_enqueue_script('church_admin_frontend_sg_map_script');
	require_once(plugin_dir_path(dirname(__FILE__)).'/display/small-group-list.php');
    
    $out=church_admin_small_group_list($attributes['map'],$attributes['zoom'],$attributes['photo'],$attributes['loggedin'],$attributes['title'],$attributes['pdf']);
    return $out;
	
}
function ca_block_smallgroups_signup( $attributes ) {
	
	require_once(plugin_dir_path(dirname(__FILE__)).'/display/small-group-signup.php');
    
    $out=church_admin_smallgroup_signup($attributes['title'],$attributes['people_types']);
    return $out;
	
}
function ca_block_smallgroup_members( $attributes ) {
		wp_enqueue_script('church_admin_google_maps_api');
	wp_enqueue_script('church_admin_frontend_sg_map_script');
	  require_once(plugin_dir_path(dirname(__FILE__)).'/display/small-groups.php');
      $out=church_admin_frontend_small_groups($attributes['member_type_id'],FALSE);
	return $out;
}
function ca_block_recent( $attributes ) {
			if(empty($loggedin)||is_user_logged_in())
			{
				require_once(plugin_dir_path(dirname(__FILE__)).'includes/recent.php');
				
				$out=church_admin_recent_display($attributes['weeks']);
			}
			else //login required
			{
				$out='<div class="login"><h2>'.__('Please login','church-admin').'</h2>'.wp_login_form(array('echo'=>FALSE)).'</div>'.'<p><a href="'.wp_lostpassword_url(get_permalink() ).'" title="Lost Password">'.__('Help! I don\'t know my password','church-admin').'</a></p>';
			}
			return $out;
}
function ca_block_graph($attributes)
{
		wp_enqueue_script('jquery-ui-datepicker');
		wp_enqueue_script('church_admin_google_graph_api');
		if(!empty($_POST['type']))
		{
			switch($_POST['type'])
			{
				case'weekly':$graphtype='weekly';break;
				case'rolling':$graphtype='rolling';break;
				default:$graphtype='weekly';break;
			}
		}else{$graphtype='weekly';}
		if(!empty($_POST['start'])){$start=$_POST['start'];}else{$start=date('Y-m-d',strtotime('-1 year'));}
		if(!empty($_POST['end'])){$end=$_POST['end'];}else{$end=date('Y-m-d');}
		if(!empty($_POST['service_id'])){$service_id=$_POST['service_id'];}else{$service_id='S/1';}
		require_once(plugin_dir_path(dirname(__FILE__)).'display/graph.php');
		return church_admin_graph($graphtype,$service_id,$start,$end,$attributes['width'],$attributes['height'],FALSE);

}
function ca_block_attendance($attributes)
{
	if(is_user_logged_in()&&church_admin_level_check('Directory'))
	{
		require_once(plugin_dir_path(dirname(__FILE__)).'includes/individual_attendance.php');
		$out=church_admin_individual_attendance();
	}
	else
	{
		$out='<h3>'.__('Only logged in users with permission can use this feature','church-admin').'</h3>';
		$out.=wp_login_form(array('echo' => false));
	}
	return $out;
}
function ca_block_volunteer($attributes)
{
	if(is_user_logged_in())
	{
		require_once(plugin_dir_path(dirname(__FILE__)).'display/volunteer.php');
		$out=church_admin_display_volunteer();
	}
	else
	{
		$out='<h3>'.__('Only logged in users can use this feature','church-admin').'</h3>';
		$out.=wp_login_form(array('echo' => false));
	}
	return $out;
}
function ca_block_birthdays($attributes)
{
	$member_type_id=1;
	$member_type_id=implode(",",church_admin_get_member_type_ids($attributes['member_type_id']));
	$people_type_id=implode(",",church_admin_get_people_type_ids($attributes['people_type_id']));
	$out='';
	if(empty($loggedin)||is_user_logged_in())
			{
				require_once(plugin_dir_path(dirname(__FILE__)).'includes/birthdays.php');$out.=church_admin_frontend_birthdays($member_type_id,$people_type_id, $attributes['days'],$attributes['show_age']);
			}
			else //login required
			{
				$out.='<div class="login"><h2>'.__('Please login','church-admin').'</h2>'.wp_login_form(array('echo'=>FALSE)).'</div>'.'<p><a href="'.wp_lostpassword_url(get_permalink() ).'" title="Lost Password">'.__('Help! I don\'t know my password','church-admin').'</a></p>';
			}
	return $out;
}
function ca_block_series($attributes)
{
    if(empty($attributes['cols']))$attributes['cols']=3;
    if(empty($attributes['sermon_page']))$attributes['sermon_page']=NULL;
	$out='';
	require_once(plugin_dir_path(dirname(__FILE__)).'display/sermon-series.php');
    $out.=church_admin_all_the_series_display($attributes['cols'],$attributes['sermon_page']);
			
	return $out;
}
function ca_block_member_map($attributes)
{
	global $wpdb;
	$member_type_id=1;
	$member_type_id=implode(",",church_admin_get_member_type_ids($attributes['member_type_id']));
	$out='';
	
	if(is_user_logged_in())
	{
		wp_enqueue_script('church_admin_google_maps_api');
		wp_enqueue_script('church_admin_map');
		
	    $service=$wpdb->get_row('SELECT AVG(lat) AS lat,AVG(lng) AS lng FROM '.CA_SIT_TBL);
    	$out.='<div class="church-map"><script type="text/javascript">var xml_url="'.site_url().'/?ca_download=address-xml&member_type_id='.esc_html($attributes['member_type_id']).'&address-xml='.wp_create_nonce('address-xml').'";';
    	$out.=' var lat='.esc_html($service->lat).';';
    	$out.=' var lng='.esc_html($service->lng).';';
		$out.=' var zoom='.esc_html($attributes['zoom']).';';
		$out.=' var translation=["'.__('Small Groups','church-admin').'","'.__('Unattached','church-admin').'","'.__('In a group','church-admin').'","'.__('Group','church-admin').'"];';
    	$out.='jQuery(document).ready(function(){console.log("Ready to lead");
    load(lat,lng,xml_url,zoom,translation);});</script><div id="church-admin-member-map" style="width:'.$attributes['width'].';height:'.$attributes['height'].'">Gutenberg is still a bit naff, so map will show in front end ;-)</div>';
    	$out.='<div id="groups" ><p><img src="https://maps.google.com/mapfiles/kml/paddle/blu-circle.png"/>'.__('Small Group','church-admin').'<br/><img src="https://maps.google.com/mapfiles/kml/paddle/red-circle.png"/>'.__('Not in a small group','church-admin').'<br/><img src="https://maps.google.com/mapfiles/kml/paddle/grn-circle.png"/>'.__('In a small Group','church-admin').'</p></div>';
    	$out.='</div>';
	}
	else {
		$out='<h3>'.__('You need to be logged in to view the map','church-admin').'</h3>'.wp_login_form(array('echo'=>false));
	}
    return $out;
}

function ca_block_giving()
{
    require_once(plugin_dir_path(dirname(__FILE__)).'display/giving.php');
    $premium=get_option('church_admin_premium');
    if(!empty($premium))
    {
        $out=church_admin_giving_form();
    }
    else
    {
        $out='<h2>Oh dear!</h2>'.__('The giving form is only active for app subscribers and when PayPal settings on the giving page have been filled in','church-admin').'</p>';
    }
    return $out;
}
function ca_block_pledge()
{
    require_once(plugin_dir_path(dirname(__FILE__)).'display/pledge.php');
    
    
    return church_admin_pledge_form();
}