<?php

if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly


/**********************************
 *
 * Giving CSV
 *
 **********************************/
function church_admin_giving_csv($start_date,$end_date,$people_id)
{
    
    global $wpdb;
    
    $csv='"'.__('Donation date','church-admin').'","'.__('Donor','church-admin').'","'.__('Email','church-admin').'","'.__('Service','church-admin').'","'.__('Amount','church-admin').'","'.__('Transaction Type','church-admin').'","'.__('Transaction Frequency','church-admin').'"'."\r\n";
    if(empty($people_id)){
        $sql='SELECT a.*,b.*,c.* FROM '.CA_GIV_TBL.' a LEFT JOIN '.CA_PEO_TBL.' b ON a.people_id=b.people_id LEFT JOIN '.CA_SER_TBL.' c ON a.service_id=c.service_id WHERE a.donation_date>="'.esc_sql($start_date).'" AND a.donation_date<="'.esc_sql($end_date).'"  ORDER BY donation_date DESC';
    }else
    {
        $sql='SELECT a.*,b.*,c.* FROM '.CA_GIV_TBL.' a LEFT JOIN '.CA_PEO_TBL.' b ON a.people_id=b.people_id LEFT JOIN '.CA_SER_TBL.' c ON a.service_id=c.service_id WHERE a.people_id="'.(int)$people_id.'" AND a.donation_date>="'.esc_sql($start_date).'" AND a.donation_date<="'.esc_sql($end_date).'"  ORDER BY donation_date DESC';
    }
    church_admin_debug($sql);
    $results=$wpdb->get_results($sql);
    if(!empty($results))
    {
        foreach($results AS $row)
        {
            $name=implode(" ",array_filter(array($row->first_name,$row->prefix,$row->last_name)));
            if(empty($name))$name=__('Anonymous','church-admin');
            $csv.='"'.esc_html($row->donation_date).'","'.$name.'","'.esc_html($row->email).'","'.esc_html($row->service_name. ' '.$row->venue.' '.$row->service_time).'","'.$row->amount.'","'.esc_html($row->txn_type).'","'.esc_html($row->txn_frequency).'"'."\r\n";
        }
        
        
    }
    header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename="giving.csv"');
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate');
	header('Pragma: public');
	header("Content-Disposition: attachment; filename=\"giving.csv\"");
	echo $csv;
    exit();
}

/**********************************
 *
 * GA rport CSV
 *
 **********************************/
function church_admin_gift_aid_csv($start_date,$end_date,$fund='All')
{
    
    global $wpdb;
    
    $csv='"'.__('Donation date','church-admin').'","'.__('Donor','church-admin').'","'.__('Email','church-admin').'","'.__('Service','church-admin').'","'.__('Amount','church-admin').'","'.__('Transaction Type','church-admin').'","'.__('Transaction Frequency','church-admin').'"'."\r\n";
    $csv='"Title","First name","Last name","House number","Postcode","Aggregated Donations","Sponsored event","Date","Amount"'."\r\n";
    if($fund=='All')
    {
        $fundSQL='';
    }else{$fundSQL=' AND a.fund="'.esc_sql($fund).'"';}
    
    $sql='SELECT a.*,b.*,c.* FROM '.CA_GIV_TBL.' a, '.CA_PEO_TBL.' b,'.CA_HOU_TBL.' c WHERE b.household_id=c.household_id AND  a.people_id=b.people_id AND a.gift_aid=1 AND a.donation_date>="'.esc_sql($start_date).'" AND a.donation_date<="'.esc_sql($end_date).'" '.$fundSQL.'  ORDER BY donation_date DESC';
    
    church_admin_debug($sql);
    $results=$wpdb->get_results($sql);
    if(!empty($results))
    {
        foreach($results AS $row)
        {
            
            if(empty($name))$name=__('Anonymous','church-admin');
            if($row->sex==1){$title="Mr";}else{$title="Ms";}
            $houseNo=substr($row->address, 0, strspn($row->address, "0123456789"));
            //grab postcode
            $postcodeRegex = "/((GIR 0AA)|((([A-PR-UWYZ][0-9][0-9]?)|(([A-PR-UWYZ][A-HK-Y][0-9][0-9]?)|(([A-PR-UWYZ][0-9][A-HJKSTUW])|([A-PR-UWYZ][A-HK-Y][0-9][ABEHMNPRVWXY])))) [0-9][ABD-HJLNP-UW-Z]{2}))/i";

            if (preg_match($postcodeRegex, $row->address, $matches))
            {
                $postcode = $matches[0];
            }else{$postcode='';}
            church_admin_debug($row->address);
            church_admin_debug(print_r($matches,TRUE));
            $csv.='"'.esc_html($title).'","'.esc_html($row->first_name).'","'.esc_html($row->last_name).'","'.(int)$houseNo.'","'.esc_html($postcode).'","","","'.mysql2date("d/m/Y",$row->donation_date).'","'.$row->gross_amount.'"'."\r\n";
        }
        
        
    }
    $filename=str_replace(" ","-",$fund.'-gift-aid-report.csv');
    header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename="'.$filename.'"');
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate');
	header('Pragma: public');
	header('Content-Disposition: attachment; filename="'.$filename.'"');
	echo $csv;
    exit();
}



/**
 *
 * outputs address list csv according to filters
 *
 * @author  Andy Moyle
 * @param
 * @return   application/octet-stream
 * @version  1.03
 *
 * rewritten 7th July 2016 to use filters from filter.php
 * refactored 11th April 2016 to remove multi-service bug
 *
 */
function church_admin_people_csv()
{
	global $wpdb;
	$group_by='';
	$gdpr=$custom=$months=$years=$member_types=$parents=$genders=$people_types=$sites=$smallgroups=$ministries=array();
	$customSQL=$monthSQL=$yearSQL=$marritalSQL=$genderSQL=$memberSQL=$peopleSQL=$smallgroupsSQL=$ministriesSQL=$filteredby=array();
	$gdprSQL='';
	$people_type=get_option('church_admin_people_type');
	require_once('filter.php');
	$sql= church_admin_build_filter_sql($_REQUEST['check']);

	$gender=get_option('church_admin_gender');
	$results=$wpdb->get_results($sql);

	if(!empty($results))
	{
		$table_header=array(__('First name','church-admin'),__('Last name','church-admin'),__('Date of birth','church-admin'),__('People type','church-admin'),__('Marital status','church-admin'),__('Phone','church-admin'),__('Cellphone','church-admin'),__('Email','church-admin'),__('Address','church-admin'),__('Venue','church-admin'),__('Gender','church-admin'));
		$csv='"'.iconv('UTF-8', 'ISO-8859-1',implode('","',$table_header)).'"'."\r\n";
		foreach($results AS $row)
		{
			if(!empty($row->first_name)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->first_name).'",';}else $csv.='"",';
			if(!empty($row->last_name)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->last_name).'",';}else $csv.='"",';
			if(!empty($row->date_of_birth)&&$row->date_of_birth!="0000-00-00"){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->date_of_birth).'",';}else $csv.='"",';
			if(!empty($people_type[$row->people_type_id])){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$people_type[$row->people_type_id]).'",';}else $csv.='"",';
			if(!empty($row->marital_status)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->marital_status).'",';}else $csv.='"'.__('N/A','church-admin').'",';
			if(!empty($row->phone)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->phone).'",';}else $csv.='"",';
			if(!empty($row->mobile)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->mobile).'",';}else $csv.='"",';
			if(!empty($row->email)){$csv.='"'.$row->email.'",';}else $csv.='"",';
			if(!empty($row->address)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->address).'",';}else $csv.='"",';
			if(!empty($row->venue)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->venue).'",';}else $csv.='"",';
			//if(!empty($row->group_name)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$row->group_name).'",';}else $csv.='"",';
			if(isset($row->sex)){$csv.='"'.iconv('UTF-8', 'ISO-8859-1',$gender[$row->sex]).'",';}else $csv.='"",';
			$csv.="\r\n";
		}

	header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename="filtered-address-list.csv"');
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate');
	header('Pragma: public');
	header("Content-Disposition: attachment; filename=\"filtered-address-list.csv\"");
	echo $csv;
	}
	exit();



}

/**
 *
 * Rota CSV
 *
 * @author  Andy Moyle
 * @param
 * @return   application/octet-stream
 * @version  1.2500
 *
 * 2018-01-13 Fixed
 *
 */
//DEPRECATED - new function is in rota.new.php
function church_admin_rota_csv($service_id)
{
	global $wpdb;
	$debug=FALSE;
	//get service name
	$service=$wpdb->get_var('SELECT service_name FROM '.CA_SER_TBL.' WHERE service_id="'.(int)$service_id.'"');
	//get required rota tasks
	$requiredRotaJobs=church_admin_required_rota_jobs($service_id);
	if(!empty($debug))church_admin_debug(print_r($requiredRotaJobs,TRUE));
	//get next twelve weeks of rota_jobs foreach rota task
	//first grab next twelve weeks of services
	$rotaDatesResults=$wpdb->get_results('SELECT * FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date>=CURDATE() GROUP BY rota_date ORDER BY rota_date');
	//grab people for each job and each date and populate $rota array
	$rota=array();

	foreach($rotaDatesResults AS $rotaDateRow)
	{

		foreach($requiredRotaJobs AS $rota_task_id=>$value)
		{
			$rota[$rotaDateRow->rota_date][$rota_task_id]=urldecode(church_admin_encode(church_admin_rota_people($rotaDateRow->rota_date,$rota_task_id,$service_id,'service')));

		}
	}
	if(!empty($debug))church_admin_debug(print_r($rota,TRUE));

	//create csv
	$csv='';

	$csvRow=array();
	//table header
	$csvRow[]=__('Date','church-admin');
	foreach($requiredRotaJobs AS $rota_task_id=>$rota_task)
	{
		$csvRow[]='"'.urldecode(church_admin_encode($rota_task)).'"';
	}
	$csv.=implode(",",$csvRow)."\r\n";
	//table data

	foreach($rota AS $date=>$data)
	{
		$csvRow=array(0=>$date);

		//rest of columns for that row
		foreach($data AS$key=>$value)
		{
			$csvRow[]='"'.urldecode(church_admin_encode($value)).'"';
		}
		$csv.=implode(",",$csvRow)."\r\n";
	}
	$filename="Rota-for-service-".esc_html($service).".csv";
	header("Cache-Control: public");
	header("Content-Description: File Transfer");
	header("Content-Disposition: attachment; filename=$filename");
	header("Content-Type: text/csv");
	header("Content-Transfer-Encoding: binary");
	echo $csv;
    exit();
}

function church_admin_attendance_csv()
{
    global $wpdb;
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/attendance.php');

    echo'<h1>'.__('Attendance CSV','church-admin').'</h1>';
	echo'<form action="'.admin_url().'admin.php" method="POST"><table>';
	echo'<input type="hidden" name="page" value="church_admin/index.php"/><input type="hidden" name="ca_download" value="attendance-csv"/><input type="hidden" name="service" value="attendance"/>';
    echo'<tr><th scope="row">'.__('Meeting','church-admin').'</th><td>'.church_admin_att_mtg_chooser(NULL,NULL);
	echo'</td><td><input class="button-primary" type="submit" value="'.__('Download CSV','church-admin').'"/></td></tr></table></form>';
    
}
function church_admin_attendance_csv_output()
{
    
    global $wpdb;
    $csv='"'.__('Date','church-admin').'","'.__('Adults','church-admin').'","'.__('Children','church-admin').'","'.__('Rolling Average Adults','church-admin').'","'.__('Rolling Average Children','church-admin').'"'."\r\n";

    if(!empty($_REQUEST['service_id']))
  		{
  			$meeting=explode('/',$_REQUEST['service_id']);
  			if(!empty($meeting))
  			{//meeting populated
  				switch($meeting['0'])
  				{
  					default:
  					case'S':
  						$mtg_type='service';
  					break;
  					case 'G':
  						$mtg_type='group';
  					break;
  					case 'C':
  						$mtg_type='class';
  					break;
  				}
		  		$service_id=intval($meeting['1']);
  		    }
        }
  		else
  		{
  			$service_id=1;
  			$mtg_type='service';
  		}
  		$query = 'SELECT * FROM '.CA_ATT_TBL.' WHERE mtg_type="'.$mtg_type.'" AND service_id="'.esc_sql($service_id).'" ORDER BY `date` DESC';
        $results=$wpdb->get_results($query);
        if(!empty($results))
        {
            foreach($results AS $row)
            {
                $csv.='"'.$row->date.'","'.intval($row->adults).'","'.intval($row->children).'","'.intval($row->rolling_adults).'","'.intval($row->rolling_children).'"'."\r\n";
            }
            
        }
    
    $filename="attendance.csv";
	header("Cache-Control: public");
	header("Content-Description: File Transfer");
	header("Content-Disposition: attachment; filename=$filename");
	header("Content-Type: text/csv");
	header("Content-Transfer-Encoding: binary");
	echo $csv; 
    exit();
}