<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function church_admin_facilities($current=NULL,$facilities_id=1)
{
	global $wpdb;
	echo'<h2>'.__('Use this section to organise facilities like rooms, video projectors','church-admin').'</h2>';
	echo' <p><a class="button-primary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_facility&section=facilities','edit_facility').'">'.__('Add Facility','church-admin').'</a></p>';

	$facilities=$wpdb->get_results('SELECT * FROM '.CA_FAC_TBL.' ORDER BY facilities_order');
    if(!empty($facilities))
	{
		echo'<p>'.__('Facilities can be sorted by drag and drop, for use in other parts of the plugin','church-admin').'</p>';
		echo'<table id="sortable" class="widefat striped"><thead><tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Facility','church-admin').'</th><th>'.__('Facility Shortcode','church-admin').'</th></tr></thead><tfoot><tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Facility','church-admin').'</th><th>'.__('Facility Shortcode','church-admin').'</th></tr></tfoot><tbody class="content">';
		foreach($facilities AS $facility)
		{
			$edit='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_facility&amp;facilities_id='.$facility->facilities_id,'edit_facility').'">'.__('Edit','church-admin').'</a>';

            $delete='<a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=delete_facility&facilities_id='.$facility->facilities_id,'delete_facility').'">'.__('Delete','church-admin').'</a>';
			echo'<tr class="sortable-row" id="'.$facility->facilities_id.'"><td>'.$edit.'</td><td>'.$delete.'</td><td>'.esc_html($facility->facility_name).'</td><td>[church_admin type="calendar" facilities_id="'.$facility->facilities_id.'"]</td></tr>';

		}
		echo'</tbody></table>';
		echo ' <script type="text/javascript">jQuery(document).ready(function($) {var fixHelper = function(e,ui){ui.children().each(function() {            $(this).width($(this).width());});  return ui; }; var sortable = $("#sortable tbody.content").sortable({ helper: fixHelper, stop: function(event, ui) {
        //create an array with the new order
        var Order = "order="+$(this).sortable(\'toArray\').toString();

        $.ajax({
            url: "admin.php?page=church_admin/index.php&action=church_admin_update_order&which=facilities",
            type: "post",
            data:  Order,
            error: function() {
                console.log("theres an error with AJAX");
            },
            success: function() {
                console.log("Saved.");
            }
        });}
		});
		$("#sortable tbody.content").disableSelection();
		});
		</script>';
	}
	


}


function church_admin_facility_bookings($facilities_id=NULL)
{
    global $wpdb;
    echo'<h1>'.__('Facility bookings','church-admin').'</h1>';
    if(empty($facilities_id))$facilities_id=1;
    $facilities=$wpdb->get_results('SELECT * FROM '.CA_FAC_TBL.' ORDER BY facilities_order');
    if(!empty($facilities))
	{
		echo'<form action="admin.php?page=church_admin/index.php&action=facility-bookings&section=facilities&amp;facilities_id='.intval($facilities_id).'" method="POST"><table><tbody><tr><th scope="row">'.__('Choose facility calendar to view','church-admin').'</th><td><select name="facilities_id">';
		foreach($facilities AS $fac){echo'<option value="'.esc_html($fac->facilities_id).'">'.esc_html($fac->facility_name).'</option>';}
		echo'</select><td><input type="submit" class="button-primary" name="'.__('Choose facility','church-admin').'"/></td></tr></tbody></table></form>';
	}
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/calendar.php');
	church_admin_new_calendar(time(),$facilities_id);
}
function church_admin_edit_facility($facilities_id=NULL)
{
    global $wpdb;
    
    if(isset($_POST['edit_facility']))
    {
		if(empty($facilities_id))$facilities_id=$wpdb->get_var('SELECT facilities_id FROM '.CA_FAC_TBL.' WHERE facility_name="'.esc_sql(stripslashes($_POST['facility'])).'"');
	   if(!empty($facilities_id))
        {
            $wpdb->query('UPDATE '.CA_FAC_TBL.' SET facility_name="'.esc_sql(stripslashes($_POST['facility'])).'" WHERE facilities_id="'.esc_sql($facilities_id).'"');
        }
        else
        {
            $nextorder=1+$wpdb->get_var('SELECT facilities_order FROM '.CA_FAC_TBL.' ORDER BY facilities_order LIMIT 1');
            $wpdb->query('INSERT INTO '.CA_FAC_TBL.'(facilities_order,facility_name)VALUES("'.esc_sql($nextorder).'","'.esc_sql(stripslashes($_POST['facility'])).'")');
        }
        
        echo'<div class="notice notice-success inline"><p>'.__('Facility Updated','church-admin').'</p></div>';
        require_once(plugin_dir_path(dirname(__FILE__)).'includes/calendar.php');
        church_admin_facilities();
    }
    else
    {
	
        
        echo'<div class="wrap church_admin"><h2>';
        if($facilities_id){echo' '.__('Edit','church-admin').' ';}else{echo __('Add','church-admin').' ';}
        echo __('Facility','church-admin').'</h2><form action="" method="POST">';
        echo'<p><label>'.__('Facility','church-admin').'</label><input type="text" name="facility" ';
        if(!empty($facilities_id))
	{
	    $type=$wpdb->get_var('SELECT facility_name FROM '.CA_FAC_TBL.' WHERE facilities_id="'.esc_sql($facilities_id).'"');
	    echo'value="'.$type.'" ';
	}
        echo'/></p>';
        echo'<p class="submit"><input type="hidden" name="edit_facility" value="yes"/><input  class="button-primary"  type="submit" value="'.__('Save Facility','church-admin').' &raquo;" /></p></form></div>';
        
    }
}
function church_admin_delete_facility($facilities_id=NULL)
{
    global $wpdb;

    if($facilities_id)
    {
        $wpdb->query('DELETE FROM '.CA_FAC_TBL.' WHERE facilities_id="'.esc_sql($facilities_id).'"');
        echo'<div class="notice notice-success inline"><p><strong>'.__('Facility Deleted','church-admin').'</strong></p></div>';
    }
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/calendar.php');
    church_admin_facilities();
}
