<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function church_admin_front_end_register($member_type_id=1,$exclude=array(),$admin_email=TRUE)
{
/**
 *
 * Front End Registration
 *
 * @author  Andy Moyle
 * @param    $email_verify,$admin_email
 * @return
 * @version  0.3
 *
 * 0.2 fixed address save
 * 0.3 added recaptcha service
 *
 */
 	
    global $wpdb,$people_type;
    $message='';
    $user = wp_get_current_user();
    if(!empty($user->ID))
    {
       $household_id=$wpdb->get_var('SELECT household_id FROM '.CA_PEO_TBL.' WHERE user_id="'.esc_sql($user->ID).'"'); 
    }else $household_id=NULL;
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/directory.php');
    if(defined('CA_DEBUG'))church_admin_debug(print_r($user,TRUE));
    if(defined('CA_DEBUG'))church_admin_debug(print_r($_GET,TRUE));
    $out='';
    $edit='Registering';
    /********************************************************
    *
    *   Process form
    *
    *********************************************************/
    if(!empty($_POST['save'])  && wp_verify_nonce($_POST['church_admin_register'], 'church_admin_register')   )//add verify nonce
    {//process
    	if(defined('CA_DEBUG'))church_admin_debug(print_r($_POST,TRUE));
   		if(!is_user_logged_in()&&empty($_POST['ItsAllAboutJesus'])){$out.='<h2>'.__('Sorry you look like a spammer, please go back and tick the box to prove you are not!','church-admin').'</p>';}
        else
		  {
                require_once(plugin_dir_path(dirname(__FILE__)).'includes/directory.php');
                $return=church_admin_save_household(1,$exclude,$household_id);
                church_Admin_debug(print_r($return,TRUE));
              if($edit=='Registering')
              {
                  $adminmessage='<p>'.sprintf(__('A new household has registered. Please %1$s check them %2$s out.','church-admin'),'<a href="'.site_url().'/wp-admin/admin.php?page=church_admin/index.php&action=display_household&household_id='.(int)$return['household_id'].'&section=people">','</a>').'</p>';
              }
              else 
              {
                $adminmessage='<p>'.sprintf(__('A  household has been edited. Please %1$s check them %2$s out.','church-admin'),'<a href="'.site_url().'/wp-admin/admin.php?page=church_admin/index.php&action=display_household&household_id='.(int)$return['household_id'].'&section=people">','</a>').'</p>';
              }
                if(!empty($admin_email))
                {
                    add_filter( 'wp_mail_from_name','church_admin_from_name' );
				    add_filter( 'wp_mail_from', 'church_admin_from_email');
                    add_filter('wp_mail_content_type','church_admin_email_type');
                    wp_mail(get_option('admin_email'),__('New household registration','church-admin'),$adminmessage);
                  remove_filter('wp_mail_content_type','church_admin_email_type');
                    remove_filter( 'wp_mail_from_name','church_admin_from_name' );
				    remove_filter( 'wp_mail_from', 'church_admin_from_email');
                }
                if($edit=='register'){$out.='<p>'.__('Thank you for editing your household','church-admin').'</p>';}
                  else {
                    $out.='<p>'.__('Thank you for registering on the site. You will receive a confirmation email shortly.','church-admin').'</p>';;
                  }

                /**********************
                *
                *  email verify
                *
                *
                ***********************/
                church_admin_email_confirm($return['head_people_id']);
                if(!empty($return['output']))$out.=$return['output'];
            }
    }//end process
    else
    {
            if(is_user_logged_in())
            {
              
                if(!empty($_GET['household_id']))
                  {
                      if(church_admin_level_check('Directory') || ($household_id==$_GET['household_id']))
                      {
                          $household_id=intval($_GET['household_id']);
                          //check household exists
                          $check=$wpdb->get_var('SELECT household_id FROM '.CA_PEO_TBL.' WHERE household_id="'.(int)$household_id.'"');
                          if(empty($check)){$household_id=NULL;$edit='Registering';}
                          else $edit='Editing';
                      }
                      else {
                        // user cannot edit this household
                        $out.='<div class="notice notice-warning" style="color:red">'.__('You are not allowed to edit the household, but you can edit your own!','church-admin').'</div>';

                      }

                  }
                $out.='<div id="registration-form">';    
              if(!empty($household_id))$data=$wpdb->get_row('SELECT * FROM '.CA_HOU_TBL.' WHERE household_id="'.(int)$household_id.'"');
            }
            else
            {
                
                $out.='<div id="ca-first-step">';
               
                $out.='<div class="church-admin-form-group"><label>'.__('Please start with your email address','church-admin').'</label>';
                $out.='<input type="email" id="ca-email-address" class="form-control"></div><p><button id="ca-next-step" class="btn btn-success">'.__("Next &raquo;",'church-admin').'</button></p></div>';
                
                $out.='<div id="ca-login" style="display:none">';
                $out.='<p>'.__('It looks like you are already registed, please login to continue','church-admin').'</p>';
                $out.=wp_login_form(array('echo'=>FALSE));
                $out.='<a href="'.esc_url( wp_lostpassword_url( get_permalink() ) ).'" alt="'.__( 'Lost Password', 'church-admin' ).'">'.__( "I've forgotten my password", 'church-admin' ).'</a></p></div>';
                $out.='<script type="text/javascript">jQuery(function($){  
                   
                    $("#ca-next-step").click(function(){
                    console.log("clicked");
                        var email=$("#ca-email-address").val();
                        $(".ca-email").val(email);
                        console.log(email);
                        var nonce="'.wp_create_nonce("email-checker").'";
                        var args = {"action": "church_admin","method": "email-checker","email": email,"nonce":nonce};
                        $.ajax({
                            url: ajaxurl,
                            type: "post",
                            data:  args,
                            success: function(response) {
                                console.log(response);
                                if(response=="Found")
                                {
                                    $("#registration-form").hide();
                                    $("#ca-login").show();
                                    $("#ca-first-step").hide();
                                }
                                else
                                {
                                    $("#registration-form").show();
                                    $("#ca-login").hide();
                                    $("#ca-first-step").hide();
                                }
                                
                            }
                        });
                    });
                    });</script>'."\r\n";
                
                $household_id=NULL;
                $out.='<div id="registration-form" style="display:none">';

            }

            if(!ctype_digit($member_type_id))$member_type_id=1;

            //form
                //keep church_admin class for form cloning of media upload to work!
                $out.='<div class="church_admin">';
                $out.='<form action="" method="post"><input type="hidden" name="save" value="yes"/>';
                $out.=wp_nonce_field('church_admin_register','church_admin_register',TRUE,FALSE);


                if(!empty($household_id)){
                    //get_people if $houshold_id
                    $people=$wpdb->get_results('SELECT * FROM '.CA_PEO_TBL.' WHERE household_id="'.esc_sql($household_id).'" ORDER BY people_order');
                }
                $x=1;
                if(!empty($household_id)&&!empty($people))
                {//editing an entry
                    $x=1;
                    foreach($people AS $person)
                    {

                        $out.=church_admin_edit_people_form($x,$person,$exclude);
                        $x++;
                    }
                    //Mick - decrement the count as the last invcrement would have been after the last person.
                    $x--;
                    //Mick  - now we know how many people there are we can set the "fields" hidden field.
                    $out.='<input type="hidden" id="fields" name="fields"  value="'.$x.'"/>';


                }//adding an entry
                else
                {
                    $out.='<input type="hidden" name="new_entry" value="yes"/>';
                    $out.=church_admin_edit_people_form(1,NULL,$exclude);
                }



                 $out.='<p id="jquerybuttons"><input type="button" class="btn btn-success" id="btnAdd" value="'.__('Add another person','church-admin').'" />&nbsp; <input type="button" class="btn btn-danger" id="btnDel" value="'.__('Remove person','church-admin').'" /></p>';;
                /*
                    if(!empty($household_id)){$data=$wpdb->get_row('SELECT * FROM '.CA_HOU_TBL.' WHERE household_id="'.esc_sql($household_id).'"');}else{$data=NULL;}
                    $out.='<p><label>'.__('Phone','church-admin').'</label><input name="phone" type="text" ';
                    if(!empty($person->mobile))$out.='value="'.esc_html($data->phone).'"';
                    $out.='/></p>';
                */


                if(empty($data))$data=(object)'';
                $out.= church_admin_address_form($data,NULL);

                $out.='<p><span class="ItsAllAboutJesus"></span></p>';

                $out.='<div class="clear"></div>';
                $out.= '<p>';
                if(empty($household_id)){$out.='<input type="submit" class="btn btn-success"  value="'.__('Register','church-admin').'"/>';}
                else{$out.='<input type="submit" class="btn btn-success" value="'.__('Save','church-admin').'"/>';}
                $out.='</p></form></div>';
                if(!is_user_logged_in())$out.= '<script>jQuery(document).ready(function($) {
            var content=\'<p>'.__('Check box if you are not a spammer','church-admin').'<input type="checkbox" name="ItsAllAboutJesus" value="yes"/></p>\'
            $(".ItsAllAboutJesus").html(content);
        });</script>';
        $out.='</div>';//end of form div
    }//form

    return $out;
}

