<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function church_admin_search_form()
{
    echo'<form name="ca_search" action="admin.php?page=church_admin/index.php&amp;section=people" method="POST"><p>'.__('Search','church-admin').'<input name="church_admin_search" style="width:200px;" type="text"/><input type="checkbox" name="all-records" value="TRUE"/>'.__('Include inactive entries','church-admin').'&nbsp;<input class="button-primary" type="submit" value="'.__('Go','church-admin').'"/></p></form>';
}
/*
 * Matches each symbol of PHP date format standard
 * with jQuery equivalent codeword
 * @author Tristan Jahier
 */
function dateformat_PHP_to_jQueryUI($php_format)
{
    $SYMBOLS_MATCHING = array(
        // Day
        'd' => 'dd',
        'D' => 'D',
        'j' => 'd',
        'l' => 'DD',
        'N' => '',
        'S' => '',
        'w' => '',
        'z' => 'o',
        // Week
        'W' => '',
        // Month
        'F' => 'MM',
        'm' => 'mm',
        'M' => 'M',
        'n' => 'm',
        't' => '',
        // Year
        'L' => '',
        'o' => '',
        'Y' => 'yy',
        'y' => 'y',
        // Time
        'a' => '',
        'A' => '',
        'B' => '',
        'g' => '',
        'G' => '',
        'h' => '',
        'H' => '',
        'i' => '',
        's' => '',
        'u' => ''
    );
    $jqueryui_format = "";
    $escaping = false;
    for($i = 0; $i < strlen($php_format); $i++)
    {
        $char = $php_format[$i];
        if($char === '\\') // PHP date format escaping character
        {
            $i++;
            if($escaping) $jqueryui_format .= $php_format[$i];
            else $jqueryui_format .= '\'' . $php_format[$i];
            $escaping = true;
        }
        else
        {
            if($escaping) { $jqueryui_format .= "'"; $escaping = false; }
            if(isset($SYMBOLS_MATCHING[$char]))
                $jqueryui_format .= $SYMBOLS_MATCHING[$char];
            else
                $jqueryui_format .= $char;
        }
    }
    return $jqueryui_format;
}
function church_admin_date_picker($db_date,$name,$array=FALSE,$start=NULL,$end=NULL,$class=NULL,$id=NULL,$disabled=FALSE)
{
	if(empty($start))$start=date('Y');
	if(empty($end))$end=date('Y')+10;
	$out='';
	$date_format=get_option('date_format');
	$jsdate_format=dateformat_PHP_to_jQueryUI($date_format);
	$out.='<span class="dashicons dashicons-calendar-alt"></span>';
	//text field that can be seen
	$out.='<input autocomplete="off" type="text" name="'.esc_html($name).'x';
	if($array)$out.='[]';
	$out.='" class="'.sanitize_title($class).'x  form-control"' ;
    if($disabled)$out.=' disabled="disabled" ';
	if(!empty($db_date)&&$db_date!='0000-00-00') $out.= ' value="'.mysql2date(get_option('date_format'),$db_date).'" ';
	$out.=' id="'.esc_html($id).'x"/>'."\r\n";
	
	//data that will be processed when form submitted
	$out.='<input  id="'.esc_html($id).'" type="hidden" name="'.esc_html($name);
	if($array)$out.='[]';
	$out.='" class="'.esc_html($class).'" data-name="'.esc_html($name).'" ';
	if(!empty($db_date))$out.='value="'. esc_html($db_date).'" ';
	$out.='/>';
	if(!$disabled)$out.='<script>
		jQuery(document).ready(function($){


         	$("body").on("focus",".'.esc_html($class).'x", function(){
         		var hidden = "#"+this.id.slice(0, -1);//need to be able to detect the hidden id field when cloned
    			$(this).datepicker({altFormat: "yy-mm-dd",altField:hidden, dateFormat : "'.$jsdate_format.'", changeYear: true ,yearRange: "'.intval($start).':'.intval($end).'"}).keyup(function(e) {
    if(e.keyCode == 8 || e.keyCode == 46) {
        $.datepicker._clearDate(this);
    }
});;
			});
		});
		</script>';

	return $out;

}




/**
 * Array of ministries
 *
 * @param
 * deprecated
 *
 * @author andy_moyle
 *
 */
function church_admin_ministries($childID=NULL){
	global $wpdb;
	$ministries=array();
	$sql='SELECT * FROM '.CA_MIN_TBL;
	$where='';
	//if(!empty($childID)) {$where=' WHERE childID ="'.intval($childID).'"';}
	//if($childID=='None')$where=' WHERE childID =0';
	$order=' ORDER BY ministry';
	$results=$wpdb->get_results($sql.$where.$order);
	if(!empty($results))
	{

		foreach($results as $row){$ministries[$row->ID]=$row->ministry;}

	}

	return $ministries;

}
/**
 * sets wp_mail to html type!
 *
 * Author:     Andy Moyle
 * Author URI: http://www.churchadminplugin.com
 *
 *
 */
 function church_admin_email_type($content_type){
return 'text/html';
}


/**
 * This function initialises wp_mail with stored smtp settings
 *
 * Author:     Andy Moyle
 * Author URI: http://www.churchadminplugin.com
 *
 *
 */
add_action( 'phpmailer_init', 'church_admin_smtp_email' );
function church_admin_smtp_email( $phpmailer ) {

	$smtp=get_option('church_admin_smtp_settings');
	if(!empty($smtp['username'])&&!empty($smtp['host'])&&!empty($smtp['port'])&&!empty($smtp['password'])&&!empty($smtp['secure']))
	{
		// Define that we are sending with SMTP
		$phpmailer->isSMTP();

		// The hostname of the mail server
		$phpmailer->Host = $smtp['host'];//"smtp.example.com";

		// Use SMTP authentication (true|false)
		$phpmailer->SMTPAuth = $smtp['auth'];//true;

		// SMTP port number - likely to be 25, 465 or 587
		$phpmailer->Port = $smtp['port'];//"587";

		// Username to use for SMTP authentication
		$phpmailer->Username = $smtp['username'];//yourusername";

		// Password to use for SMTP authentication
		$phpmailer->Password =$smtp['password']; "yourpassword";

		// Encryption system to use - ssl or tls
		$phpmailer->SMTPSecure =$smtp['secure']; //"tls";

		$phpmailer->From = $smtp['from'];//"you@yourdomail.com";
		$phpmailer->FromName = $smtp['from_name'];//"Your Name";
	}
}
//end smtp settings for wp_mail




function church_admin_max_file_upload_in_bytes() {
    //select maximum upload size
    $max_upload = substr(ini_get('upload_max_filesize'),0,-1);
   
    //select post limit
    $max_post = substr(ini_get('post_max_size'),0,-1);
   
    //select memory limit
    $memory_limit = substr(ini_get('memory_limit'),0,-1);
   
    // return the smallest of them, this defines the real limit
    return size_format(min($max_upload, $max_post, $memory_limit),0);
}

function church_admin_get_id_by_shortcode($shortcode) {
	global $wpdb;

	$id = NULL;

	$sql = 'SELECT ID
		FROM ' . $wpdb->posts . '
		WHERE
			post_type = "page"
			AND post_status="publish"
			AND post_content LIKE "%' . $shortcode . '%"';

	$id = $wpdb->get_var($sql);
	return $id;
}
function church_admin_initials($people)
{
	$people=maybe_unserialize($people);
	if(!empty($people))
	{

		foreach($people as $id=>$peep)
		{
			if(ctype_digit($peep)){$person=church_admin_get_person($peep);}else{$person=$peep;}
			$strlen=strlen($person);
			$initials[$id]='';
			for($i=0;$i<=$strlen;$i++)
			{
				$char=substr($person,$i,1);
				if (ctype_upper($char)){$initials[$id].=$char;}
			}
		}

		return implode(', ',$initials);

	}else return '';
}

function church_admin_checkdate($date)
{
		$d=explode('-',$date);
		if(is_array($d) && count($d)==3 && checkdate($d[1],$d[2],$d[0])){return TRUE;}else{return FALSE;}
}
function church_admin_level_check($what)
{
    global $current_user;
    wp_get_current_user();

    $user_permissions=maybe_unserialize(get_option('church_admin_user_permissions'));

    $level=get_option('church_admin_levels');

    if(!empty($user_permissions[$what]))
    {//user permissions have been set for $what

						if( in_array($current_user->ID,maybe_unserialize($user_permissions[$what]))){return TRUE;}else{return FALSE;}
				}
		//end user permissions have been set
    elseif(!empty($level[$what]) && $level[$what]=="administrator"){return current_user_can('manage_options');}
    elseif(!empty($level[$what]) && $level[$what]=="editor"){return current_user_can('delete_others_pages');}
    elseif(!empty($level[$what]) &&$level[$what]=="author"){return current_user_can('publish_posts');}
    elseif(!empty($level[$what]) &&$level[$what]=="contributor"){return current_user_can('edit_posts');}
    elseif(!empty($level[$what]) &&$level[$what]=="subscriber"){return current_user_can('read');}
    else{ return false;}
}

function church_admin_user($ID)
{
		global $wpdb;
		$people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE user_id="'.esc_sql($ID).'"');
		if(!empty($people_id)) {return $people_id;}else{return FALSE;}
}

function church_admin_collapseBoxForUser($userId, $boxId) {
    $optionName = "closedpostboxes_church-admin";
    $close = get_user_option($optionName, $userId);
    $closeIds = explode(',', $close);
    $closeIds[] = $boxId;
    $closeIds = array_unique($clodeIds); // remove duplicate Ids
    $close = implode(',', $closeIds);
    update_user_option($userId, $optionName, $close);
}



function church_admin_autocomplete($name='people',$first_id='friends',$second_id='to',$current_data=array(),$user_id=FALSE)
{
            /**
 *
 * Creates autocomplete field
 *
 * @author  Andy Moyle
 * @param    $name,$first_id,$second_id
 * @return   html string
 * @version  0.1
 *
 *
 */
    $current='';
    
    if(!empty($current_data))
    {
        $curr_data=maybe_unserialize($current_data);
        
        if(!empty($curr_data)&&is_array($curr_data))
		{
			foreach($curr_data AS $key=>$value)
			{

				if(ctype_digit($value))
				{
						if(!$user_id)
						{//people_id
							$peoplename=church_admin_get_person($value);
						}
						else
						{//user_id
							$peoplename=church_admin_get_name_from_user($value);
						}
				}else $peoplename=$value;
				$current.=$peoplename.', ';
			}
		}else$current=$current_data;
    }
    $out= '<input autocomplete="off" id="'.sanitize_title_with_dashes($first_id).'" class="to church-admin-form-control" placeholder="'.__('Enter names, separated by commas','church-admin').'" type="text" name="'.esc_html($name).'" value="'.esc_html($current).'"/> ';
    $ajax_nonce = wp_create_nonce( "church-admin-autocomplete" );
    $out.='<script type="text/javascript">

	jQuery(document).ready(function ($){

	$("#'.sanitize_title_with_dashes($first_id).'").autocomplete({
		source: function(req, add){
			req.action="church_admin";
			req.method="autocomplete";
			req.security="'.$ajax_nonce.'";
			console.log(req);
			$.getJSON("'.site_url().'/wp-admin/admin-ajax.php", req,  function(data) {

                    console.log("Response " + data);
                    //create array for response objects
                    var suggestions = [];

                    //process response
                    $.each(data, function(i, val){suggestions.push(val.name);});

                //pass array to callback
                add(suggestions);
                $(".to").removeClass(".ui-autocomplete-loading");
            });

		},
		focus: function() {
          // prevent value inserted on focus
          return false;
        },
		select: function (event, ui) {
                var terms = $("#'.sanitize_title_with_dashes($first_id).'").val().split(", ");
		// remove the current input
                terms.pop();
                console.log("current:"+terms);
		// add the selected item
                terms.push(ui.item.value);
				
                // add placeholder to get the comma-and-space at the end
                terms.push("");
                this.value = terms.join(", ");
                console.log("new:" + terms)
				$("#'.sanitize_title_with_dashes($first_id).'").val(this.value);
                return false;
            },
		minLength: 3,

	});


});


</script>';
    return $out;
}

             /**
 *
 * Returns person's names from $people_id
 *
 * @author  Andy Moyle
 * @param    $id
 * @return   string
 * @version  0.1
 *
 *
*/
function church_admin_get_person($id)
{

 global $wpdb;
 if(!ctype_digit($id))return $id;
    $row=$wpdb->get_row('SELECT first_name,middle_name,nickname,prefix,last_name FROM '.CA_PEO_TBL.' WHERE people_id="'.esc_sql($id).'"');
    if($row){
    			//build name
				$name=$row->first_name.' ';
					$middle_name=get_option('church_admin_use_middle_name');
					if(!empty($middle_name)&&!empty($row->middle_name))$name.=$row->middle_name.' ';
					$nickname=get_option('church_admin_use_nickname');
					if(!empty($nickname)&&!empty($row->nickname))$name.='('.$row->nickname.') ';
					$prefix=get_option('church_admin_use_prefix');
					if(!empty($prefix)&&!empty($row->prefix))		$name.=$row->prefix.' ';
					$name.=$row->last_name;
    return $name;
    }else{return FALSE;}
}
function church_admin_get_name_from_user($id)
{
             /**
 *
 * Returns person's names from user_id
 *
 * @author  Andy Moyle
 * @param    $id
 * @return   string
 * @version  0.1
 *
 *
*/
 global $wpdb;
 ;
    $row=$wpdb->get_row('SELECT first_name,middle_name,nickname,prefix,last_name FROM '.CA_PEO_TBL.' WHERE user_id="'.esc_sql($id).'"');

    if($row)
    {
    	//build name
		$name=$row->first_name.' ';
					$middle_name=get_option('church_admin_use_middle_name');
					if(!empty($middle_name)&&!empty($row->middle_name))$name.=$row->middle_name.' ';
					$nickname=get_option('church_admin_use_nickname');
					if(!empty($nickname)&&!empty($row->nickname))$name.='('.$row->nickname.') ';
					$prefix=get_option('church_admin_use_prefix');
					if(!empty($prefix)&&!empty($row->prefix))		$name.=$row->prefix.' ';
					$name.=$row->last_name;
    	return esc_html($name);
    }else{return FALSE;}
}


function church_admin_get_people_type_ids($people_type)
{
	global $wpdb;
	if(defined('CA_DEBUG'))church_admin_debug("********************\r\n function church_admin_get_people_type_ids($people_type)");
	$return=array();
	$people_types=get_option('church_admin_people_type');
	$ptype_array=explode(",",$people_type);
	foreach($ptype_array AS $id=>$type)
	{
		$key=array_search(trim($type),$people_types);
		if($key)$return[]=$key;
	}
	return($return);
}
function church_admin_get_member_type_ids($member_type)
{
	global $wpdb;
	//if(defined('CA_DEBUG'))church_admin_debug("********************\r\n function church_admin_get_member_type_ids($member_type)");
	$member_type_id=array();
	$member_array=explode(",",$member_type);
	//if(defined('CA_DEBUG'))church_admin_debug('$member_array '.print_r($member_array,TRUE));
	foreach ($member_array AS $key=>$memb)
	{
		$sql='SELECT member_type_id FROM '.CA_MTY_TBL.' WHERE member_type LIKE "%'.esc_sql(trim($memb)).'%"';
		if(defined('CA_DEBUG'))church_admin_debug($sql);
		$member_type_id[]=$wpdb->get_var( $sql);
	}
	if(defined('CA_DEBUG'))church_admin_debug('Returned array '.print_r($member_type_id,TRUE));
	if(!empty($member_type_id)){ return $member_type_id;} else{return NULL;}
}
 /**
 *
 * Returns peoples names from serialized array
 *
 * @author  Andy Moyle
 * @param    $idArray
 * @return   string
 * @version  0.1
 *
 */
function church_admin_get_people($idArray)
{

    global $wpdb;
    $ids=maybe_unserialize($idArray);
    if(!is_array($ids))return $ids;
    if(!empty($ids))
    {
        $names=array();
        foreach($ids AS $key=>$id)
        {
            if(ctype_digit($id))
            {//is int
                $row=$wpdb->get_row('SELECT first_name,middle_name,nickname,prefix,last_name FROM '.CA_PEO_TBL.' WHERE people_id="'.esc_sql($id).'"');
                if(!empty($row))
                {
                	$name=$row->first_name.' ';
					$middle_name=get_option('church_admin_use_middle_name');
					if(!empty($middle_name)&&!empty($row->middle_name))$name.=$row->middle_name.' ';
					$nickname=get_option('church_admin_use_nickname');
					if(!empty($nickname)&&!empty($row->nickname))$name.='('.$row->nickname.') ';
					$prefix=get_option('church_admin_use_prefix');
					if(!empty($prefix)&&!empty($row->prefix))		$name.=$row->prefix.' ';
					$name.=$row->last_name;
                	$names[]=$name;
                }
            }//end is int
            else
            {//is text
                $names[]=$id;
            }//end is text
        }
        return implode(", ", array_filter($names));
    }
    else
    return " ";
}

function church_admin_get_people_id($name)
{
        /**
 *
 * Returns serialized array of people_id if $name is in DB
 *
 * @author  Andy Moyle
 * @param    $name
 * @return   serialized array
 * @version  0.1
 *
 */
    global $wpdb;
    $names=explode(',',$name);

    $people_ids=array();
    if(!empty($names))
    {
        foreach($names AS $key=>$value)
        {
			$value=trim($value);
            if(!empty($value))
            {//only look if a name stored!
                $sql='SELECT people_id FROM '.CA_PEO_TBL.' WHERE CONCAT_WS(" ",first_name,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,middle_name,prefix,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,middle_name,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($value).'" OR  nickname LIKE "'.esc_sql($value).'" LIMIT 1';

                $result=$wpdb->get_var($sql);
                if($result){$people_ids[]=$result;}else{$people_ids[]=$value;}
            }
        }
    }
    return maybe_serialize(array_filter($people_ids));
}
function church_admin_get_user_id($name)
{
        /**
 *
 * Returns serialized array of user_id if $name is in DB
 *
 * @author  Andy Moyle
 * @param    $name
 * @return   serialized array
 * @version  0.1
 *
 */
    global $wpdb;
    $names=explode(',',$name);

    $user_ids=array();
    if(!empty($names))
    {
        foreach($names AS $key=>$value)
        {
			      $value=trim($value);

            if(!empty($value))
            {//only look if a name stored!
                //$sql='SELECT user_id FROM '.CA_PEO_TBL.' WHERE CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($value).'"OR CONCAT_WS(" ",first_name,middle_name,prefix,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,middle_name,last_name) LIKE "'.esc_sql($value).'" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($value).'" OR  nickname LIKE "'.esc_sql($value).'" LIMIT 1';
                $sql='SELECT user_id FROM '.CA_PEO_TBL.' WHERE CONCAT_WS(" ",first_name,last_name) LIKE("%'.$value.'%")||CONCAT_WS(" ",first_name,prefix,last_name) LIKE("%'.$value.'%")||first_name LIKE("%'.$value.'%")||last_name LIKE("%'.$value.'%")||nickname LIKE("%'.$value.'%")||email LIKE("%'.$value.'%")||mobile LIKE("%'.$value.'%") LIMIT 1';

                $result=$wpdb->get_var($sql);

                if($result){$user_ids[]=$result;}else
				        {
					          echo '<p>'.esc_html($value).' is not stored by Church Admin as Wordpress User. ';
					          $people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE CONCAT_WS(" ",first_name,last_name) REGEXP "^'.esc_sql($value).'" LIMIT 1');
					          if(!empty($people_id))echo'Please <a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_people&amp;people_id='.$people_id,'edit_people').'">edit</a> entry to connect/create site user account.';
					          echo'</p>';
				        }
            }
        }
    }
    if(!empty($user_ids)){ return maybe_serialize(array_filter($user_ids));}else{return NULL;}
}
function church_admin_get_one_id($name)
{
	global $wpdb;
	$sql='SELECT people_id FROM '.CA_PEO_TBL.' WHERE first_name LIKE "'.esc_sql($name).'" OR last_name LIKE "'.esc_sql($name).'" OR CONCAT_WS(" ",first_name,last_name) LIKE "'.esc_sql($name).'" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($name).'" OR CONCAT_WS(" ",first_name,middle_name,prefix,last_name) LIKE "'.esc_sql($name).'" OR CONCAT_WS(" ",first_name,middle_name,last_name) LIKE "'.esc_sql($name).'" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "'.esc_sql($name).'" OR  nickname LIKE "'.esc_sql($name).'" LIMIT 1';
    $result=$wpdb->get_var($sql);
	if(!empty($result)){return $result;}else{return $name;}
}


function church_admin_update_order($which='member_type')
{
    global $wpdb;
    if(isset($_POST['order']))
    {
        switch($which)
        {
			      case'facilities':$tb=CA_FAC_TBL;$field='facilities_order';$id='facility_id';break;
            case'member_type':$tb=CA_MTY_TBL;$field='member_type_order';$id='member_type_id';break;
            case'rota_settings':$tb=CA_RST_TBL;$field='rota_order';$id='rota_id';break;
            case'small_groups':$tb=CA_SMG_TBL;$field='smallgroup_order';$id='id';break;
			      case'people':$tb=CA_PEO_TBL;$field='people_order';$id='people_id';break;
            case'funnel':$tb=CA_FUN_TBL;$field='funnel_order';$id='funnel_id';break;
        }
        $order=explode(",",$_POST['order']);
        foreach($order AS $order=>$row_id)
        {
            $member_type_order++;
            $head=='';
            if($which=='people')
            {
            	if($order==0){$head=', head_of_household=1';}else{$head=', head_of_household=0';}
            }
            $sql='UPDATE '.$tb.' SET '.$field.'="'.esc_sql($order).'" '.$head.' WHERE '.$id.'="'.esc_sql($row_id).'"';
            church_admin_debug($sql);
            $wpdb->query($sql);
        }
    }
}


function church_admin_member_type_array()
{
    global $wpdb;
    $member_type=array();
    $results=$wpdb->get_results('SELECT * FROM '.CA_MTY_TBL.' ORDER BY member_type_order ASC');
    foreach($results AS $row)
    {
        $member_type[$row->member_type_id]=$row->member_type;
    }
    return($member_type);
}
function church_admin_kidswork_array()
{
    global $wpdb;
    $kidswork=array();
    $results=$wpdb->get_results('SELECT * FROM '.CA_KID_TBL.' ORDER BY youngest ASC');
    foreach($results AS $row)
    {
        $kidswork[$row->id]=$row->group_name;
    }
    return($kidswork);
}


/**
* This function deletes a person from a hope team
*
* @author     	andymoyle
* @param		$people_id,$meta_type
* @return		array
*
*/
function church_admin_delete_from_hope_team($people_id)
{
  global $wpdb;
  ;
  $wpdb->query('DELETE FROM '.CA_MET_TBL.' WHERE people_id="'.esc_sql($people_id).'" AND meta_type="hope_team" ');

}

function church_admin_get_ministry_hierarchy($ID)
{

	$structure=array();
	while($ID)
	{
		$thisOne=church_admin_get_ministry($ID);
		if(!empty($thisOne->ministry))$structure[$ID]=$thisOne->ministry;
		if(!empty($thisOne->parentID)){$ID=$thisOne->parentID;}
		else $ID=FALSE;
	}
	return $structure;
	
}
function church_admin_get_ministry($ID)
{
	global $wpdb;
	$result=$wpdb->get_row('SELECT * FROM '.CA_MIN_TBL.' WHERE id="'.(int)$ID.'"');
	if(empty($result)){return FALSE;}else{return $result;}

}

function church_admin_get_hierarchy($ID)
{
		$rand=rand();
  		church_admin_leadership_hierarchy($ID,$rand);
    	$hierarchy=get_option('church_admin_leadership_hierarchy'.$rand);
    	delete_option('church_admin_leadership_hierarchy'.$rand);
    	return $hierarchy;
}

function church_admin_leadership_hierarchy($ID,$rand)
{
	global $wpdb;
	$hierarchy=get_option('church_admin_leadership_hierarchy'.$rand);
	if(empty($hierarchy)||(is_array($hierarchy)&&!in_array($ID,$hierarchy))){$hierarchy=array(1=>$ID);update_option('church_admin_leadership_hierarchy'.$rand,$hierarchy);}
	$sql='SELECT parentID FROM '.CA_MIN_TBL.' WHERE ID="'.esc_sql($ID).'"';

	$nextlevel=$wpdb->get_var($sql);
	if(empty($nextlevel))
	{

	 	return $hierarchy;
	}
	else
	{
		$hierarchy[]=(int)$nextlevel;

		update_option('church_admin_leadership_hierarchy'.$rand,$hierarchy);
		church_admin_leadership_hierarchy($nextlevel,$rand);
	}
}
/**
* This function updates a people meta
*
* @author     	andymoyle
* @param		$people_id,$meta_type,$ID
* @return		array
*
*/
function church_admin_update_people_meta($ID,$people_id,$meta_type='ministry',$meta_date=NULL)
{
    
  global $wpdb;
  if(empty($meta_date))$meta_date=date('Y-m-d');
 	$wpdb->show_errors();
  	$meta_id=$wpdb->get_var('SELECT meta_id FROM '.CA_MET_TBL.' WHERE people_id="'.esc_sql($people_id).'" AND meta_type="'.esc_sql($meta_type).'" AND ID="'.esc_sql($ID).'" AND meta_date="'.esc_sql($meta_date).'"');
  	if(empty($meta_id))
  	{
  		$sql='INSERT INTO '.CA_MET_TBL.' (people_id,ID,meta_type,meta_date) VALUES ("'.esc_sql($people_id).'", "'.(int)$ID.'", "'.esc_sql($meta_type).'", "'.esc_sql($meta_date).'" );';

  		$wpdb->query($sql);

  	}
   
}

function church_admin_get_people_meta_list($meta_type,$ID)
{
	global $wpdb;
    $people=array();
    $displayCurrentPeople='';
    $sql='SELECT people_id FROM '.CA_MET_TBL.' WHERE meta_type="'.esc_sql($meta_type).'" AND ID="'.(int)$ID.'"';
	$results=$wpdb->get_results($sql);
    //church_admin_debug(print_r($results,true));
    if($results)
    {
        foreach($results AS $row)
        {
            if(ctype_digit($row->people_id))
            { 
                $sql='SELECT CONCAT_WS(" ",first_name,prefix,last_name) FROM '.CA_PEO_TBL.' WHERE people_id="'.intval($row->people_id).'"';
                $people[]= $wpdb->get_var($sql);
            }
            else $people[]=$row->people_id;
        }
    }
    //church_admin_debug(print_r($people,TRUE));
	$displayCurrentPeople=implode(', ',$people);
	
	return $displayCurrentPeople;
}

/**
* This function produces an array of meta_id for people_id
*
* @author     	andymoyle
* @param		$people_id,$meta_type
* @return		FALSE or array
*
*/
function church_admin_get_people_meta($people_id,$meta_type='smallgroup'){
  global $wpdb;
  $out=array();

  $results=$wpdb->get_results('SELECT ID FROM '.CA_MET_TBL.' WHERE people_id="'.esc_sql($people_id).'" AND meta_type="'.esc_sql($meta_type).'"');
  if(empty($results)){return FALSE;}
  else
  {
  	foreach($results AS $row)$out[]=$row->ID;
  	return $out;
  }
}

function church_admin_people_meta($ID=NULL,$people_id=NULL,$meta_type=NULL)
{
	global $wpdb;
	$sql='SELECT a.*,b.* FROM '.CA_MET_TBL.' a ,'.CA_PEO_TBL.' b WHERE a.people_id=b.people_id AND ';
	$where=array();
	if(!empty($ID)) $where[]= 'a.ID="'.(int)$ID.'" ';
	if(!empty($people_id))$where[]=' a.people_id="'.(int)$people_id.'"';
	if(!empty($meta_type))$where[]=' a.meta_type="'.esc_sql($meta_type).'"';
	$query=$sql.implode(' AND ',$where).' ORDER BY b.last_name,b.first_name ASC';

	$results=$wpdb->get_results($query);
	return $results;
}

/**
* This function deletes a meta data for a given people_id or meta ID
*
* @author     	andymoyle
* @param		$people_id,$meta_type
* @return
*
*/
function church_admin_delete_people_meta($ID=NULL,$people_id,$meta_type=NULL)
{
	global $wpdb;
	if($ID){
		$wpdb->query('DELETE FROM '.CA_MET_TBL.' WHERE people_id="'.esc_sql($people_id).'" AND meta_type="'.esc_sql($meta_type).'" AND ID="'.esc_sql($ID).'"');
	}else{
		$wpdb->query('DELETE FROM '.CA_MET_TBL.' WHERE people_id="'.esc_sql($people_id).'" AND meta_type="'.esc_sql($meta_type).'"');
	}
}

function strip_only($str, $tags)
{
    //this functions strips some tages, but not all
    if(!is_array($tags)) {
        $tags = (strpos($str, '>') !== false ? explode('>', str_replace('<', '', $tags)) : array($tags));
        if(end($tags) == '') array_pop($tags);
    }
    foreach($tags as $tag) $str = preg_replace('#</?'.$tag.'[^>]*>#is', '', $str);
    return $str;
}

function checkDateFormat($date)
{
  //match the format of the date
  if (preg_match ("/^([0-9]{4})-([0-9]{2})-([0-9]{2})$/", $date, $parts))
  {
    //check weather the date is valid of not
        if(checkdate($parts[2],$parts[3],$parts[1]))
          return true;
        else
         return false;
  }
  else
    return false;
}


function QueueEmail($to,$subject,$message,$copy=NULL,$from_name=NULL,$from_email=NULL,$attachment=NULL,$schedule=NULL)
{
    global $wpdb;

    $sqlsafe=array();
    $sqlsafe['to']=esc_sql($to);
    $sqlsafe['from_name']=esc_sql($from_name);
    $sqlsafe['from_email']=esc_sql($from_email);
    $sqlsafe['subject']=esc_sql($subject);
    $sqlsafe['message']=esc_sql($message);
    $sqlsafe['attachment']=esc_sql(maybe_serialize($attachment));
	$sqlsafe['schedule']=esc_sql($schedule);
    $sqlsafe['copy']=esc_sql(maybe_unserialize($copy));
    $sql='INSERT INTO '.CA_EMA_TBL.' (recipient,from_name,from_email,copy,subject,message,attachment,schedule)VALUES("'.$sqlsafe['to'].'","'.$sqlsafe['from_name'].'","'.$sqlsafe['from_email'].'","'.$sqlsafe['copy'].'","'.$sqlsafe['subject'].'","'.$sqlsafe['message'].'","'.$sqlsafe['attachment'].'","'.$sqlsafe['schedule'].'")';

	$result=$wpdb->query($sql);

    if($result) {return $wpdb->insert_id;}else{return FALSE;}
}

if(!function_exists('set_html_content_type')){function set_html_content_type() {return 'text/html';}}

function church_admin_plays($file_id)
{
	global $wpdb;
	$plays=$wpdb->get_var('SELECT plays FROM '.CA_FIL_TBL.' WHERE file_id="'.esc_sql($file_id).'"');
	return $plays;
}

function church_admin_dateCheck($date, $yearepsilon=5000)
{ // inputs format is "yyyy-mm-dd" ONLY !
if (count($datebits=explode('-',$date))!=3) return false;
$year = intval($datebits[0]);
$month = intval($datebits[1]);
$day = intval($datebits[2]);
if ((abs($year-date('Y'))>$yearepsilon) || // year outside given range
($month<1) || ($month>12) || ($day<1) ||
(($month==2) && ($day>28+(!($year%4))-(!($year%100))+(!($year%400)))) ||
($day>30+(($month>7)^($month&1)))) return false; // date out of range
if( checkdate($month,$day,$year)) {return ($year.'-'.sprintf("%02d", $month).'-'.sprintf("%02d", $day));}else{return FALSE;}
}

/**************************************************************************************************************************************************
*
*
*  Check if logged in user can do what is wanted
* param ID - ID of person about to be edited/deleted or ID of ministry
* admins can do anything
*
*
*
*
***************************************************************************************************************************************************/
function church_admin_user_can($ID,$meta_type='smallgroup')
{
	$can=FALSE;
	global $current_user;
	wp_get_current_user();
	$user_people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE user_id="'.(int)$current_user->ID.'"');

	//administrator
	if(current_user_can('manage_options')) return TRUE;

	//if current user is the passed ID
	if($user_people_id==$ID)return TRUE;

	if($meta_type=='smallgroup')
	{
		//check if $ID is in a group led or overseen
		$sgID=$wpdb->get_var('SELECT ID FROM '.CA_MET_TBL.' WHERE people_id="'.(int)$id.'" AND meta_key="smallgroup"');
		if(!empty($sgID))
		{
			$leaders=maybe_unserialize($wpdb->get_var('SELECT leadership FROM '.CA_SMG_TBL.' WHERE id="'.intval($sgID).'"'));
			if(is_array($leaders))
			{
				foreach($leaders AS $leaderlevel)
				{
					if(in_array($user_people_id,$leaderlevel)) return TRUE;
				}
			}
		}
	}
	else
	{//ministry
	//see if ministry has a parent
		$parentID=$wpdb->get_var('SELECT parentID FROM '.CA_MIN_TBL.' WHERE ID="'.(int)$id.'"');
		if(empty($parentID)) return FALSE;
		if(parent($ID)){return TRUE;}
		function parent($ID)
		{
			$check=$wpdb->get_var('SELECT meta_id FROM '.CA_MET_TBL.' WHERE ID="'.(int)$id.'" AND people_id="'.intval($user_people_id).'" AND meta_type="ministry"');
			if(!empty($check)) return TRUE;
			$next_level=$wpdb->get_var('SELECT parentID FROM '.CA_MIN_TBL.' WHERE ID="'.intval($parentID).'"');
			if(!empty($next_level))
			{
				if(parent($next_level)){ return TRUE;}else return FALSE;
			}
			else return FALSE;
		}
		//see if user is in that parent ministry

	}
	return FALSE;
}


function church_admin_adjust_brightness($hex, $steps)
{
    // Steps should be between -255 and 255. Negative = darker, positive = lighter
    $steps = max(-255, min(255, $steps));

    // Normalize into a six character long hex string
    $hex = str_replace('#', '', $hex);
    if (strlen($hex) == 3) {
        $hex = str_repeat(substr($hex,0,1), 2).str_repeat(substr($hex,1,1), 2).str_repeat(substr($hex,2,1), 2);
    }

    // Split into three parts: R, G and B
    $color_parts = str_split($hex, 2);
    $return = '#';

    foreach ($color_parts as $color) {
        $color   = hexdec($color); // Convert to decimal
        $color   = max(0,min(255,$color + $steps)); // Adjust color
        $return .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT); // Make two char hex code
    }

    return $return;
}
 /**
 *
 * Replace rota entry
 *
 * @author  Andy Moyle
 * @param    $people_id,$date,$mtg_type,$service_id,$rota_task_id
 * @return   BOOL
 * @version  0.1
 *
 */
 function church_admin_update_rota_entry($rota_task_id,$rota_date,$people_id,$mtg_type,$service_id,$service_time)
 {
 	global $wpdb;
 	$table=CA_ROTA_TBL;
	
 	$data=array(
 			'rota_task_id'=>$rota_task_id,
 			'people_id'=>$people_id,
 			'mtg_type'=>$mtg_type,
 			'service_id'=>$service_id,
 			'rota_date'=>$rota_date,
			'service_time'=>$service_time
 	);

 	$format=array(
 			'%d',
 			'%s',
 			'%s',
 			'%d',
 			'%s',
		'%s'
 	);
	 $rota_id=$wpdb->get_var('SELECT rota_id FROM '.CA_ROTA_TBL.' WHERE rota_task_id="'.esc_sql($rota_task_id).'" AND people_id="'.(int)$people_id.'" AND mtg_type="'.esc_sql($mtg_type).'" AND service_id="'.(int)$service_id.'" AND rota_date="'.esc_sql($rota_date).'"');

 	if(empty($rota_id))
 	{
 		$wpdb->insert($table,$data,$format);
 	}
 	else
 	{
 		$where=array('rota_id'=>$rota_id);
 		$wpdb->update( $table, $data, $where, $format  );

	}

	 church_admin_debug($wpdb->last_query);
 }
  /**
 *
 * Grab array of people_ids for particular ministry_id
 *
 * @author  Andy Moyle
 * @param    $ministry_id
 * @return   array($people_id=>$name)
 * @version  0.1
 *
 */
 function church_admin_ministry_people_array($ministry_id)
 {
 	global $wpdb;
 	$out=array();
 	$results=$wpdb->get_results('SELECT CONCAT_WS(" ",a.first_name,a.last_name) AS name, b.people_id AS people_id FROM '.CA_PEO_TBL.' a, '.CA_MET_TBL.' b WHERE a.people_id=b.people_id AND b.meta_type="ministry" AND b.ID="'.intval($ministry_id).'" ');
 	if(!empty($results))
 	{
 		foreach($results AS $row)$out[$row->people_id]=$row->name;
 	}

 	return $out;
 }
  /**
 *
 * Grab array of people_ids for particular rota_task_id and event
 *
 * @author  Andy Moyle
 * @param    $rota_date,$rota_taks_id,$service_id,$mtg_type
 * @return   array($people_id=>$name)
 * @version  0.1
 *
 */
 function church_admin_rota_people_array($rota_date,$rota_task_id,$service_id,$mtg_type)
 {
 	global $wpdb;
 	$out=array();
	$sql='SELECT * FROM '.CA_ROTA_TBL.' WHERE rota_task_id="'.(int)$rota_task_id.'" AND mtg_type="'.esc_sql($mtg_type).'" AND service_id="'.(int)$service_id.'" AND rota_date="'.esc_sql($rota_date).'"';
	

 	
	if(!empty($rota_date))$results=$wpdb->get_results($sql);
 	if(!empty($results))
 	{
 		foreach($results AS $row)$out[$row->people_id]=church_admin_get_person($row->people_id);
 	}
 	return $out;
 }
   /**
 *
 * Grab comma separated list of people for particular rota_taks_id and event
 *
 * @author  Andy Moyle
 * @param    $rota_date,$rota_taks_id,$service_id,$mtg_type
 * @return   string
 * @version  0.1
 *
 */
 function church_admin_rota_people($rota_date,$rota_task_id,$service_id,$mtg_type)
 {
 	return implode(", ",church_admin_rota_people_array($rota_date,$rota_task_id,$service_id,$mtg_type));
 }
    /**
 *
 * Grab comma separated list of people for particular rota_taks_id and event
 *
 * @author  Andy Moyle
 * @param    $rota_date,$rota_taks_id,$service_id,$mtg_type
 * @return   string
 * @version  0.1
 *
 */
 function church_admin_rota_people_initials($rota_date,$rota_task_id,$service_id,$mtg_type)
 {
 	$people=church_admin_rota_people_array($rota_date,$rota_task_id,$service_id,$mtg_type);
 	$initials=array();
 	foreach($people AS $key=>$person)
 	{
 		$words = explode(" ", $person);
        
		$acronym = "";
		if(!empty($words))
        {
            foreach ($words as $w) {if(!empty($w[0]))$acronym .= strtoupper($w[0]);}
        }
		$initials[]=$acronym;
 	}
 	return implode(", ",$initials);
 }


/**
 *
 * Works out font size and orientation for data
 *
 * @author  Andy Moyle
 * @param    $lengths, $fontSize
 * @return   array(orientation,font_size,widths)
 * @version  0.1
 *
 */
function church_admin_pdf_settings($lengths,$fontSize=10)
{
	//M is max width letter and at 1pt Arial will take up 0.35mm approx, will allow 3mm either side
	$colWidth=array();
	foreach($lengths AS $key=>$length)$colWidth[$key]=($length*$fontSize*0.2)+6;
	$pdfSettings=array('font_size'=>$fontSize,'widths'=>$colWidth);
	//find total width and check it is less than width of page
	$tableWidth=array_sum($colWidth);
	church_admin_debug("Table Width: $tableWidth");
	$pdfSize=get_option('church_admin_pdf_size');

	switch($pdfSize)
	{
		case 'A4':
					if(($tableWidth)<190)$pdfSettings['orientation']='P';
					elseif($tableWidth<277)$pdfSettings['orientation']='L';
					else{return FALSE;}
		break;
		case 'Letter':
					if(($tableWidth)<195)$pdfSettings['orientation']='P';
					elseif($tableWidth<259)$pdfSettings['orientation']='L';
					else{return FALSE;}
		break;
		case 'Legal':
					if(($tableWidth)<200)$pdfSettings['orientation']='P';
					elseif($tableWidth<346)$pdfSettings['orientation']='L';
					else{return FALSE;}
		break;
	}

	return $pdfSettings;

}

     function church_admin_api_checker($url) {
        $curl = curl_init($url);

        //don't fetch the actual page, you only want to check the connection is ok
        curl_setopt($curl, CURLOPT_NOBODY, true);

        //do request
        $result = curl_exec($curl);

        $ret = false;

        //if request did not fail
        if ($result !== false) {
            //if request was ok, check response code
            $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
       		$ret=$statusCode;
        }
        curl_close($curl);

       return $statusCode;
    }
/**
 *
 * Page id of church_admin_register shortcode containing page
 *
 * @author  Andy Moyle
 * @param    $lengths, $fontSize
 * @return   array(orientation,font_size,widths)
 * @version  0.1
 *
 */
function church_admin_register_page_id()
{
	global $wpdb;
	$page_id=$wpdb->get_var('SELECT ID FROM '.$wpdb->posts.' WHERE post_content LIKE "%[church_admin_register]%" AND post_status="publish" LIMIT 1');
    if(defined('CA_DEBUG'))church_admin_debug("PAGE id is $page_id");
	if(!empty($page_id)){return (int)$page_id;}else{return FALSE;}
}
 /**
 *
 * Page id of church_admin_unsubscribe shortcode containing page
 *
 * @author  Andy Moyle
 * @param    $lengths, $fontSize
 * @return   array(orientation,font_size,widths)
 * @version  0.1
 *
 */
function church_admin_unsubscribe_page_id()
{
	global $wpdb;
	$page_id=$wpdb->get_var('SELECT ID FROM '.$wpdb->posts.' WHERE post_content LIKE "%[church_admin_unsubscribe]%" AND post_status="publish" LIMIT 1');
	if(!empty($page_id)){return intval($page_id);}else{return FALSE;}
}

 /**
 *
 * Check whether person with peple_id is active or not
 *
 * @author  Andy Moyle
 * @param    $people_id
 * @return   BOOL
 * @version  0.1
 *
 */
function church_admin_deactivated_check($people_id)
{
	global $wpdb;
	$check=$wpdb->get_var('SELECT active FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
	if($check)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}
 /**
 *
 * Output JQuery to handle clicking on Activate/Deactivate
 *
 * @author  Andy Moyle
 * @param
 * @return   $out
 * @version  0.1
 *
 */
function church_admin_activate_script()
{	//jQuery for processing activate/deactivate peopl
		$nonce = wp_create_nonce("church_admin_people_activate");
		$out='

	<script type="text/javascript">
		jQuery(document).ready(function($) {
			$("body").on("click",".activate", function(){
				var id = this.id;
        console.log("people_id "+id);
      			var data = {
				"action": "church_admin",
				"method":"people_activate",
				"people_id": id,
				"nonce": "'.$nonce.'"
				};
      console.log( data);
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		  $.getJSON(ajaxurl, data, function(response) {
      console.log( response)
			if(response.status==1){
					$("#"+response.id).removeClass("ca-deactivated");
					$("#active-"+response.id).html("Active ");
				}else{
					$("#"+response.id).addClass("ca-deactivated");
					$("#active-"+response.id).html("Deactive ");
				}
		});
			});
		});
	</script>

	';
	return $out;
}

function church_admin_helper()
{


$out='
	<script>
		jQuery(document).ready(function($) {
			$("body").on("click"," .help", function(){
			var id=this.id;
			var message;
				switch(id)
				{
					case "active-message":
						alert("'.__('Click to change active status of person in directory','church-admin').'");
					break;


				}

			});
			});
	</script>';
return $out;


}

class ChurchAdminDateTime extends DateTime {

    public function returnAdd(DateInterval $interval)
    {
        $dt = clone $this;
        $dt->add($interval);
        return $dt;
    }

    public function returnSub(DateInterval $interval)
    {
        $dt = clone $this;
        $dt->sub($interval);
        return $dt;
    }

}



/*********************
*
*
*	AJAX operations
*
***********************/
function church_admin_date()
{
	require_once(plugin_dir_path( __FILE__) .'../display/calendar.new.php');
	echo church_admin_display_day($_POST['date']);
	exit();
}


function church_admin_note_delete_callback() {

	check_admin_referer('church_admin_delete_note','nonce');
	global $wpdb;
	$sql='DELETE FROM '.CA_COM_TBL.'  WHERE comment_id="'.intval($_POST['note_id']).'"';
	$wpdb->query($sql);
	$sql='DELETE FROM '.CA_COM_TBL.'  WHERE parent_id="'.intval($_POST['note_id']).'"';
	$wpdb->query($sql);
	echo TRUE;
	exit();
}


function church_admin_ajax_notice_handler() {
    // Pick up the notice "type" - passed via jQuery (the "data-notice" attribute on the notice)

    // Store it in the options table
    switch($_POST['type'])
    {
    	case "church-admin-bible-version":update_option('dismissed-church-admin-bible-version',TRUE);break;
    	case "church-admin-app":update_option( 'dismissed-church-admin-app', TRUE );break;
    	case "church-admin-gdpr":update_option( 'dismissed-church-admin-gdpr', TRUE );break;
    }
}

function church_admin_unattach_user()
{

	global $wpdb;
	//church_admin_debug((int)$_POST['people_id']);
	$wpdb->query('UPDATE '.CA_PEO_TBL.' SET user_id=NULL WHERE people_id="'.(int)$_POST['people_id'].'"');
}
/**
 *
 * Ajax - returns json array with people's names
 * Used by fautoe
 * @author  Andy Moyle
 * @param    null
 * @return   json array
 * @version  0.1
 *
 */
function church_admin_ajax_people($active=FALSE)
{

    global $wpdb;
    $names=explode(", ", $_GET['term']);//put passed var into array
    $name=esc_sql(stripslashes(trim(end($names))));//grabs final value for search
    if(!empty($active)){ $activeSQL=" active=1 AND ";}else{$activeSQL="";}

   $sql='SELECT CONCAT_WS(" ",first_name,prefix, last_name) AS name FROM '.CA_PEO_TBL.' WHERE '.$activeSQL.' (CONCAT_WS(" ",first_name,last_name) LIKE "%'.esc_sql($name).'%" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "%'.esc_sql($name).'%" OR CONCAT_WS(" ",first_name,middle_name,prefix,last_name) LIKE "%'.esc_sql($name).'%" OR CONCAT_WS(" ",first_name,middle_name,last_name) LIKE "%'.esc_sql($name).'%" OR CONCAT_WS(" ",first_name,prefix,last_name) LIKE "%'.esc_sql($name).'%" OR  nickname LIKE "%'.esc_sql($name).'%") ';
    //church_admin_debug($sql);
    $result=$wpdb->get_results($sql);

    if($result)
    {
        $people=array();
        foreach($result AS $row)
        {
            $people[]=array('name'=>$row->name);
        }

        //echo JSON to page

    $response =json_encode($people);

    echo $response;
    }
    exit();
}


function church_admin_mp3_plays() {
	$nonce = $_POST['data']['security'];
 	//if ( ! wp_verify_nonce( $nonce, 'church_admin_mp3_play' ) )die('busted');
    
	global $wpdb;
	$file_id = esc_sql($_POST['data']['file_id']);
    $currPlays=$wpdb->get_var('SELECT plays FROM '.CA_FIL_TBL.' WHERE  file_id = "'.$file_id.'"');
    if(empty($currPlays))$currPlays=0;
    $newPlays=$currPlays+1;
	$sql='UPDATE '.CA_FIL_TBL.' SET plays = '.intval($newPlays).' WHERE file_id = "'.$file_id.'"';
	$wpdb->query($sql);
	$plays=$wpdb->get_var('SELECT plays FROM '.CA_FIL_TBL.' WHERE file_id = "'.$file_id.'"');

	echo $plays;
	die();
}

function church_admin_username_check()
{
	check_admin_referer('church_admin_username_check','nonce');

	if(username_exists(stripslashes($_POST['user_name']))){echo'<span class="dashicons dashicons-no" style="color:red"></span>';}else{echo'<span style="color:green" class="dashicons dashicons-yes"></span>';}
	exit();
}

function church_admin_filter_callback() {

	//check_admin_referer('church_admin_filter','nonce');

	require_once(plugin_dir_path(__FILE__).'filter.php');
	//church_admin_debug("callback");

	church_admin_filter_process();

	exit();
}

function church_admin_filter_email_callback() {

	check_admin_referer('church_admin_filter','nonce');
	require_once(plugin_dir_path(__FILE__).'filter.php');
	echo church_admin_filter_email($_POST['type']);
	exit();
}




function church_admin_people_activate_callback() {

	check_admin_referer('activate','nonce');
	global $wpdb;
  $people_id=substr($_REQUEST['people_id'],7);
  //church_admin_debug($people_id);
	$sql='UPDATE '.CA_PEO_TBL.' SET active = !active WHERE people_id="'.(int)$people_id.'"';
 // church_admin_debug($sql);
	$wpdb->query($sql);
	$status=$wpdb->get_var('SELECT active FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
    if($status==0){$active=__('Inactive','church-admin');}else{$active=__('Active','church-admin');}
	$output=array('status'=>$active,'id'=>(int)$people_id);
  header('Access-Control-Max-Age: 1728000');
  header('Access-Control-Allow-Origin: *');
  header('Access-Control-Allow-Methods: *');
  header('Access-Control-Allow-Headers: Content-MD5, X-Alt-Referer');
  header('Access-Control-Allow-Credentials: true');
  echo json_encode($output);
  die();
  exit();
}

function church_admin_sites_array()
{
	global $wpdb;
	$sites=array();
	$results=$wpdb->get_results('SELECT * FROM '.CA_SIT_TBL);
	if(!empty($results)	)
	{
		foreach($results AS $row)
		{
			$sites[intval($row->site_id)]=esc_html($row->venue);
		}
	}
	return $sites;
}
function church_admin_ministries_array()
{
	global $wpdb;
	$ministries=array();
	$results=$wpdb->get_results('SELECT * FROM '.CA_MIN_TBL);
	if(!empty($results))
	{
		foreach($results AS $row)$ministries[(int)$row->ID]=esc_html($row->ministry);
	}
	return $ministries;
}

function church_admin_hope_teams_array()
{
	global $wpdb;
	$hope_team=array();
	$results=$wpdb->get_results('SELECT * FROM '.CA_HOP_TBL);
	if(!empty($results))
	{
		foreach($results AS $row)$hope_team[intval($row->hope_team_id)]=esc_html($row->job);
	}
	return $hope_team;
}
function church_admin_small_groups_array()
{
	global $wpdb;
	$small_groups=array();
	$results=$wpdb->get_results('SELECT * FROM '.CA_SMG_TBL);
	if(!empty($results))
	{
		foreach($results AS $row)$small_groups[(int)$row->id]=esc_html($row->group_name);
	}
	return $small_groups;
}

function church_admin_encode($word) {

    $word = str_replace("@","%40",$word);
    $word = str_replace("`","%60",$word);
    $word = str_replace("¢","%A2",$word);
    $word = str_replace("£","%A3",$word);
    $word = str_replace("¥","%A5",$word);
    $word = str_replace("|","%A6",$word);
    $word = str_replace("«","%AB",$word);
    $word = str_replace("¬","%AC",$word);
    $word = str_replace("¯","%AD",$word);
    $word = str_replace("º","%B0",$word);
    $word = str_replace("±","%B1",$word);
    $word = str_replace("ª","%B2",$word);
    $word = str_replace("µ","%B5",$word);
    $word = str_replace("»","%BB",$word);
    $word = str_replace("¼","%BC",$word);
    $word = str_replace("½","%BD",$word);
    $word = str_replace("¿","%BF",$word);
    $word = str_replace("À","%C0",$word);
    $word = str_replace("Á","%C1",$word);
    $word = str_replace("Â","%C2",$word);
    $word = str_replace("Ã","%C3",$word);
    $word = str_replace("Ä","%C4",$word);
    $word = str_replace("Å","%C5",$word);
    $word = str_replace("Æ","%C6",$word);
    $word = str_replace("Ç","%C7",$word);
    $word = str_replace("È","%C8",$word);
    $word = str_replace("É","%C9",$word);
    $word = str_replace("Ê","%CA",$word);
    $word = str_replace("Ë","%CB",$word);
    $word = str_replace("Ì","%CC",$word);
    $word = str_replace("Í","%CD",$word);
    $word = str_replace("Î","%CE",$word);
    $word = str_replace("Ï","%CF",$word);
    $word = str_replace("Ð","%D0",$word);
    $word = str_replace("Ñ","%D1",$word);
    $word = str_replace("Ò","%D2",$word);
    $word = str_replace("Ó","%D3",$word);
    $word = str_replace("Ô","%D4",$word);
    $word = str_replace("Õ","%D5",$word);
    $word = str_replace("Ö","%D6",$word);
    $word = str_replace("Ø","%D8",$word);
    $word = str_replace("Ù","%D9",$word);
    $word = str_replace("Ú","%DA",$word);
    $word = str_replace("Û","%DB",$word);
    $word = str_replace("Ü","%DC",$word);
    $word = str_replace("Ý","%DD",$word);
    $word = str_replace("Þ","%DE",$word);
    $word = str_replace("ß","%DF",$word);
    $word = str_replace("à","%E0",$word);
    $word = str_replace("á","%E1",$word);
    $word = str_replace("â","%E2",$word);
    $word = str_replace("ã","%E3",$word);
    $word = str_replace("ä","%E4",$word);
    $word = str_replace("å","%E5",$word);
    $word = str_replace("æ","%E6",$word);
    $word = str_replace("ç","%E7",$word);
    $word = str_replace("è","%E8",$word);
    $word = str_replace("é","%E9",$word);
    $word = str_replace("ê","%EA",$word);
    $word = str_replace("ë","%EB",$word);
    $word = str_replace("ì","%EC",$word);
    $word = str_replace("í","%ED",$word);
    $word = str_replace("î","%EE",$word);
    $word = str_replace("ï","%EF",$word);
    $word = str_replace("ð","%F0",$word);
    $word = str_replace("ñ","%F1",$word);
    $word = str_replace("ò","%F2",$word);
    $word = str_replace("ó","%F3",$word);
    $word = str_replace("ô","%F4",$word);
    $word = str_replace("õ","%F5",$word);
    $word = str_replace("ö","%F6",$word);
    $word = str_replace("÷","%F7",$word);
    $word = str_replace("ø","%F8",$word);
    $word = str_replace("ù","%F9",$word);
    $word = str_replace("ú","%FA",$word);
    $word = str_replace("û","%FB",$word);
    $word = str_replace("ü","%FC",$word);
    $word = str_replace("ý","%FD",$word);
    $word = str_replace("þ","%FE",$word);
    $word = str_replace("ÿ","%FF",$word);
    return $word;
}


function church_admin_in_array_r($needle, $haystack, $strict = false) {
   if(!empty($haystack)&&is_array($haystack))
   {
   	foreach ($haystack as $item)
   		{
    	    if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && church_admin_in_array_r($needle, $item, $strict)))
    	    {
        	    return true;
        	}
    	}
	}
    return false;
}

function church_admin_user_id_exists($user){

    global $wpdb;

    $count = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $wpdb->users WHERE ID = %d", $user));

    if($count == 1){ return true; }else{ return false; }

}


function ca_date_link($year,$month,$day,$legend=FALSE,$class=NULL,$type=calendar,$facilities_id=NULL)
{
	if(empty($legend))$legend=$day;
    if($type=='facility-bookings'){$section='facilities';}else{$section='calendar';}
	if(!empty($class)){$class=' class="'.$class.'"';}else{$class='';}
	if(is_admin())
    {
        $link='admin.php?page=church_admin/index.php&amp;action='.$type.'&amp;section='.$section;
        if(!empty($facilities_id))$link.='&amp;facilities_id='.intval($facilities_id);
    }else{$link='';}
	$out='<form action="'.$link.'" method="POST">
	<input type="hidden" name="start_date" value="'.esc_html($year.'-'.$month.'-'.sprintf('%02d', $day)).'"/><button '.$class.'>'.esc_html($legend).'</button></form>';
	return $out;

}



function church_admin_scaled_image_path($attachment_id, $size = 'thumbnail') {
    $file = get_attached_file($attachment_id, true);
    
    if (empty($size) || $size === 'full') {
        // for the original size get_attached_file is fine
        return realpath($file);
    }
    if (! wp_attachment_is_image($attachment_id) ) {
        return false; // the id is not referring to a media
    }
    $info = image_get_intermediate_size($attachment_id, $size);
   
    if (!is_array($info) || ! isset($info['file'])) {
        return false; // probably a bad size argument
    }
    $path=realpath(str_replace(wp_basename($file), $info['file'], $file));
  
    $return=array('path'=>$path,'height'=>$info['height'],'width'=>$info['width']);
    return $return;
}

function church_admin_detect_runtime_issues()
{
    global $wp_version;
    $error=array();
      if  (!in_array  ('curl', get_loaded_extensions()))
      {
        $error['curl']=__('cURL is not enabled on your server, please contact your hosting company to get it enabled','church-admin');
      }
      if (version_compare(phpversion(), '5.3.10', '<'))
      {
        $error['php']=__('Your PHP version is low and therefore is not safe and lacks some features needed by WordPress and Church Admin','church-admin');
      }
      if ( version_compare( $wp_version, '4.0', '<=' ) )
      {
        $error['wordpress']=__('Your WordPress version is very out of date. Please update now','church-admin');
      }
      //SPIT OUT ERRORS IF NEEDED
      if(!empty($error))
      {
        echo'<div class="notice notice-warning"><h2>'.__('Issues detected by Church Admin plugin','church-admin').'</h2><p><strong>'.implode("<br/>",$error).'</strong></div>';

      }


}
function church_admin_refresh_rolling_average()
{
	global $wpdb;
	$results=$wpdb->get_results('SELECT * FROM '.CA_ATT_TBL);
	if(!empty($results))
	{
		foreach($results AS $row)
		{
			$avesql='SELECT FORMAT(AVG(adults),0) AS rolling_adults,FORMAT(AVG(children),0) AS rolling_children FROM '.CA_ATT_TBL.' WHERE `mtg_type`="'.esc_sql($row->mtg_type).'" AND `service_id`="'.esc_sql($row->service_id).'" AND `date` >= DATE_SUB("'.esc_sql($row->date).'",INTERVAL 52 WEEK) AND `date`<= "'.esc_sql($row->date).'"';
    		$averow=$wpdb->get_row($avesql);
    		$wpdb->query('UPDATE '.CA_ATT_TBL.' SET rolling_adults= "'.intval($averow->rolling_adults).'",rolling_children= "'.intval($averow->rolling_children).'" WHERE attendance_id="'.intval($row->attendance_id).'"');
		}
	}

}

function church_admin_whosin_kidswork_array()
{
		global $wpdb;
		$kidswork=array();
		//select GROUPS

			$results=$wpdb->get_results('SELECT a.*,a.id AS kidswork_id, b.ministry FROM '.CA_KID_TBL.' a  LEFT JOIN '.CA_MIN_TBL.' b ON a.department_id=b.ID ORDER BY youngest DESC');
			if(!empty($results))
			{
					foreach($results AS $row)
					{
							$kidswork[$row->kidswork_id]=array('name'=>$row->group_name,'youngest'=>$row->youngest,'oldest'=>$row->oldest);
							//get kids in that group
							$sql='SELECT people_id,household_id,kidswork_override FROM '.CA_PEO_TBL.' WHERE  (kidswork_override="'.esc_sql($row->id).'" OR ((date_of_birth<"'.$row->youngest.'" AND date_of_birth>"'.$row->oldest.'") AND kidswork_override=0 ))';

							$kids=$wpdb->get_results($sql);
							if(!empty($kids))
							{
								foreach($kids AS $kid)
								{
										//get parents of that kid
										$parents=array();
										$parents_result=$wpdb->get_results('SELECT people_id FROM '.CA_PEO_TBL.' WHERE household_id="'.intval($kid->household_id).'" AND people_type_id=1');
										if(!empty($parents_result))
										{
											foreach($parents_result AS $parent)
											{
													$parents[]=$parent->people_id;
											}
										}
										$kidswork[$row->kidswork_id]['children'][]=array('people_id'=>intval($kid->people_id),'household_id'=>intval($kid->household_id),'parents'=>$parents);

								}
							}
					}
				}

				return $kidswork;

}
function church_admin_get_kids_groups($people_id)
{
  //this function finds the kids work groups a parent has children in.
    $groups=array();//array of groups people_id is a parent of a child in that group
    $kidsGroups=church_admin_whosin_kidswork_array();
    if(!empty($kidsGroups))
    {
      foreach($kidsGroups AS $group_id=>$kidsGroup)
      {
        if(!empty($kidsGroup['children']))
	    {
		  	foreach($kidsGroup['children'] AS $kids)
          	{
            	if(in_array($people_id,$kids['parents']))$groups[]=$group_id;
          	}
		}
      }
    }
    if(defined('CA_DEBUG'))church_admin_debug("people_id: $people_id is a parent of kids in these groups \r\n".print_r($groups,TRUE));
    return $groups;
}
/**
 *
 * Returns member level of current user
 *
 * @author  Andy Moyle
 * @param    $member_type_id Comma separated ids
 * @return
 * @version  0.1
 *
 */
 function church_admin_user_member_level($member_type_id)
 {
   global $wpdb,$current_user;
   wp_get_current_user();
   $permission=FALSE;
   $member_type_ids=explode(',',$member_type_id);
   if(is_user_logged_in())
   {
     $person_member_type_id=$wpdb->get_var('SELECT member_type_id FROM '.CA_PEO_TBL.' WHERE user_id="'.esc_sql($current_user->ID).'"');
     if(empty($member_type_id))$permission=TRUE;
     elseif(!empty($member_type_id) && ((is_array($member_type_ids)&& in_array($person_member_type_id,$member_type_ids))||$member_type_id=='#')){$permission=TRUE;}
        
   }
   return $permission;
 }


function church_admin_head_of_household_tidy($household_id)
{
	global $wpdb;
	/******************************************************************
		*
		* Make sure there is a head of household and tidy up if messy
		*
		*******************************************************************/
		$check=$wpdb->get_results('SELECT people_id FROM '.CA_PEO_TBL.' WHERE head_of_household=1 AND household_id="'.esc_sql($household_id).'"');
		if(!empty($check) &$wpdb->num_rows>1)
		{
			//more than one head of household so reset
			$wpdb->query('UPDATE '.CA_PEO_TBL.' SET head_of_household=0 WHERE household_id="'.esc_sql($household_id).'"');
			unset($check);
		}
		if(empty($check))
		{
			$people_order=$wpdb->get_results('SELECT people_id FROM '.CA_PEO_TBL.' WHERE people_order=1 AND household_id="'.esc_sql($household_id).'" ORDER BY people_id ASC');
			if($people_order)
			{//people_order set and more than 1 is 1
				if($wpdb->num_rows>1)
				{
					//more than one entry has people order 1 so tidy that first
					$wpdb->query('UPDATE '.CA_PEO_TBL.' SET people_order=0 WHERE household_id="'.esc_sql($household_id).'"');
					$x=1;
					foreach($people_order AS $people)
					{
						$wpdb->query('UPDATE '.CA_PEO_TBL.' SET people_order="'.(int)$x.'" WHERE people_id="'.esc_sql($people->people_id).'"');
						$x++;
					}
				}
				//set household_id for frst person
				$wpdb->query('UPDATE '.CA_PEO_TBL.' SET head_of_household=1 WHERE household_id="'.esc_sql($household_id).'" AND people_order=1');
			}
			else
			{
				//no people order set or head of household_id
				$people=$wpdb->get_results('SELECT people_id FROM '.CA_PEO_TBL.' WHERE  household_id="'.esc_sql($household_id).'" ORDER BY people_id ASC');
				if(!empty($people))
				{
					$x=1;
					foreach($people AS $person)
					{
						if($x==1){$wpdb->query('UPDATE '.CA_PEO_TBL.' SET head_of_household=1, people_order=1 WHERE people_id="'.esc_sql($person->people_id).'"');}
						else{$wpdb->query('UPDATE '.CA_PEO_TBL.' SET  people_order='.$x.' WHERE people_id="'.esc_sql($person->people_id).'"');}
						$x++;
					}
				
				}
			}
		}
    $people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE head_of_household=1 AND household_id="'.esc_sql($household_id).'"');
    return $people_id;

}



function church_admin_shortcodes_list()
{
	global $wpdb,$wp_locale;
	//shortcodes
	echo'<h1>'.__('Shortcodes','church-admin').'</h1>';
	echo '<h3>'.__('Communications','church-admin').'</h3>';
	//classes
	echo'<h3>'.__('Classes','church-admin').'</h3>';
	echo'<p>[church_admin type="classes" today=TRUE] '.__('displays a list of classes, today (remove today=TRUE for current classes). Logged in users can book in. Logged in Class leaders can check in students','church-admin').'</p>';
    //calendar
    echo'<h3>'.__('Calendar','church-admin').'</h3>';
    //calendar
    echo'<p>[church_admin type="calendar-list" days="28" category="1,2,3"] '.__('displays a list of calendar events for the next 28 days from (optional) 1,2,3 categories','church-admin').'</p>';
    echo'<p>[church_admin type="calendar" style="old"] '.__('displays a monthly calendar table','church-admin').'</p>';
    echo'<p>[church_admin type="calendar" ] '.__('displays a day to view calendar','church-admin').'</p>';
    echo '<p>'.__('[church_admin type="calendar-list" category="1,2,3" weeks="4"] shows calendar events from categories 1,2 and 3 for the next 4 weeks','church-admin').'</p>';
    $results=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."church_admin_calendar_category");
    if($results)
    {
    	echo'<table><thead><tr><th>'.__('Shortcode','church-admin').'</th><th>Category</th></tr></thead><tbody>';
        foreach($results AS $row)
        {
             $shortcode='<strong>[church_admin type="calendar-list" category="'.esc_html($row->cat_id).'" weeks="4"]</strong>';
            echo'<tr><th scope="row">'.$shortcode.'</th><td>'.sprintf(__('Calendar List by Category %1$s','church-admin'),esc_html($row->category)).'</td></tr>';
        }
        echo'</tbody></table>';
    }
	//directory

    echo'<h3>'.__('Directory','church-admin').'</h3>';
    echo'<p>'.__('The directory shortcode is [church_admin type="address-list" member_type_id="#" photo="1" map="1" site_id="0" pdf="1"]','church-admin').'</strong></p>';
		  echo'<p>'.__('pdf=0 will not display PDF links, pdf=1 displays standard PDF, pdf=2 displays alternate version ','church-admin').'</p>';
		echo'<p>'.__('photo=1 will display a thumbnail if one has been uploaded','church-admin').'</p>';
    echo'<p>'.__('site=0 will display people from all sites, or if comma separated numbers used individual sites.','church-admin').'</p>';
	echo'<p>'.__('map=1 shows a map for households where you have updated location on the google map when editing.','church-admin').' </p>';
    echo'<p>'.__('Member type can include more than one member type separated with commas e.g.:','church-admin').'<strong>[church_admin type=address-list member_type_id=1,2 map=1 photo=1]</strong></p>';
    echo'<p>'.__('kids=0 will stop children being shown','church-admin').'.</p>';
    echo'<p>'.__('loggedin=TRUE makes the page available to logged in users only','church-admin').'</p>';
    echo'<p>'.__("updateable=FALSE disables the edit link on each entry for admins and logged in user's entry",'church-admin').'</p>';

    $member_types=$wpdb->get_results('SELECT * FROM '.CA_MTY_TBL.' ORDER BY member_type_id');
    if($member_types)
    {
        echo '<p>'.__('These are your current member types','church-admin').'</p>';
        foreach($member_types AS $row)
        {
            echo'<p><label>'.esc_html($row->member_type).': </label>member_type_id='.intval($row->member_type_id).'</p>';
        }
    }
	echo '<h3>'.__('Follow Up funnels','church-admin').'</h3>';
	echo '<p>'.__('[church_admin type="follow-up"] display recent people activity and follow up actions menu','church-admin').'</p>';
    echo'<h3>'.__('Names','church-admin').'</h3>';
    echo'<p>'.__('[church_admin type=names member_type_id=# people_types=#] displays just names','church-admin').'</p>';
     echo'<p>'.__('people_types can be "all","adults","teens","children" or a combination separated by a comma','church-admin').'</p>';

    //media
    echo'<h3>'.__('Media','church-admin').'</h3>';
    echo'<p><strong>[church_admin type=podcast] </strong>'.__('Lists all sermons','church-admin').'</p>';
	echo'<p><strong>[church_admin type=podcast most_popular=FALSE] </strong>'.__('Lists all sermons and turns off Most Popular tab','church-admin').'</p>';
    $results=$wpdb->get_results('SELECT * FROM '.CA_SERM_TBL);
    if($results)
    {//results
    	echo'<table class="widefat striped">';
    	echo'<thead><tr><th>'.__('Series Name','church-admin').'</th><th>'.__('Number of sermons','church-admin').'</th><th>'.__('Shortcode'.'church-admin').'</th></tr></thead><tfoot><tr><th>'.__('Series Name','church-admin').'</th><th>'.__('Number of sermons','church-admin').'</th><th>'.__('Shortcode'.'church-admin').'</th></tr></tfoot><tbody>';
    	foreach ($results AS $row)
    	{
    		$files=$wpdb->get_var('SELECT count(*) FROM '.CA_FIL_TBL.' WHERE series_id="'.esc_sql($row->series_id).'"');
            if(!$files)$files="0";
    		echo'<tr><td>'.esc_html($row->series_name).'</td><td>'.intval($files).'</td><td>[church_admin type="podcast" series_id="'.(int)$row->series_id.'"]</td></tr>';
    	}
    	echo'</tbody></table>';
    }
    //member map
    echo'<h3>'.__('Member Map','church-admin').'</h3>';
    echo'<p>'.__('[church_admin_map member_type_id="#" zoom="13" small_group="1"]- zoom is Google map zoom level, small_group=1 for different colours for small groups, 0 for all in red','church-admin').'</p>';
    //ministries
    echo'<h3>'.__('Ministries','church-admin').'</h3>';
    echo'<p><strong>[church_admin type="ministries" ministry_id=# member_type_id="#"] </strong>'.__('Lists people doing various ministries - just specify ministry_ids','church-admin').'</p>';
    $min=get_option('church_admin_ministries');
    if(!empty($min)){
    	foreach($min AS $id=>$ministry) echo'<p>'.sprintf( esc_html__( '"%1$s" has id %2$s.', 'church-admin' ), $ministry, (int)$id ).'</p>';

    }
    echo'<p>'.__('[church_admin type="kidswork"] shows the childrens groups','church-admin').'.</p>';
	//volunteers
    echo'<h3>'.__('Online serving/volunteer application','church-admin').'</h3>';
	echo'<p>'.__('[church_admin type="volunteer"] allows logged in users to volunteer for ministries where the online volunteer checkbox is checked','church-admin').'.</p>';
    //recent
	echo'<h3>'.__('Recent Visitors','church-admin').'</h3>';
	echo'<p><strong>[church_admin type="recent" member_type_id="#"] </strong>'.__('Lists your recent visitors - just specify member_types_ids','church-admin').'</p>';
    //small groups
    echo'<h3>'.__('Small groups','church-admin').'</h3>';
    echo'<p><strong>[church_admin type="small-groups-list" map="1"]</strong>'.__(' lists all your small group\'s details in map form (map=1)or as a list (map=0)','church-admin').'</p>';
    echo'<p><strong>[church_admin type="small-groups" member_type_id="#" ]</strong>'.__('lists all your small groups and their members for a specific member type','church-admin').'</p>';
    echo'<p>'.__('For the small-groups shortcode you can add loggedin=TRUE and restricted=TRUE to only show groups the user is in or leading','church-admin').'</p>';

    //rotas
    echo'<h3>'.__('Schedules','church-admin').'</h3>';
    echo'<p><strong>[church_admin type="my_rota"]</strong>'.__(' shows a logged in user their schedule involvement.','church-admin').'</p>';
    echo'<p><strong>[church_admin type="rota" service_id="1"]</strong>'.__(' lists the upcoming schedule for a particular service','church-admin').'</p>';

    $results=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL.' ORDER BY service_id');
    if($results)
    {
        echo '<p>'.__('These are your current services','church-admin').'</p>';
        foreach($results AS $row)
        {
            if(!(ctype_digit($row->service_day)&&$row->service_day>=0 &&$row->service_day<=7))$row->service_day=0;

            	echo'<p><label>'.esc_html($row->service_name).' on '.$wp_locale->get_weekday($row->service_day).' at '.esc_html($row->service_time).' </label>service_id='.intval($row->service_id).'</p>';

        }
    }

    //user registration
    echo'<h3>'.__('User Registration','church-admin').'</h3>';
    echo'<p><strong>[church_admin_register create_user=FALSE admin_email=TRUE] </strong></p>';
    echo'<p>'.__('This shortcode allows new people to register and logged in users to update their own entry.','church-admin').'</p>';
     echo'<p>'.__('create_user=TRUE will create a subscriber user for each valid email address','church-admin').'</p>';
      echo'<p>'.__('admin_email=TRUE lets the admin email know that a new address entry has been created','church-admin').'</p>';
echo '<p> exclude="middle-name,nickname,prefix,date-of-birth,marital-status,image,small-groups,classes,socials,ministries,mobile,gender,custom" '.__('allows you to exclude and or all of those fields from the form','church-admin').'</p>';
    //recent activity
    echo'<h3>'.__('Recent Directory Activity','church-admin').'</h3>';
    echo'<p><strong>[church_admin_recent]</strong></p>';



	//Attendance
	 echo'<h3>'.__('Attendance','church-admin').'</h3>';
    echo'<p><strong>[church_admin type="graph" width="900" height="500"]</strong> - '.__('displays graph image 900x500px;','church-admin').'</p>';
    //Birthdays
	echo'<h3>'.__('Birthdays','church-admin').'</h3>';
	echo'<p><strong>[church_admin type="birthdays" member_type_id="#" days="#" show_age=FALSE people_type_id="#"]</strong> - '.__('displays upcoming birthdays for the next # days for member_types_ids # and people_type_ids=#. show_age=FALSE stops the year and age displaying!','church-admin').'</p>';
	//Restricted content
	echo'<h3>'.__('Restricted Content','church-admin').'</h3>';
	echo'<p><strong>[church_admin type="restricted" member_type_id="#"]'.__('Some Content','church-admin').'[/church_admin]</strong> - '.__('restrictes the content to certain member_types_ids #, which can be comma separated e.g. 1,2,3','church-admin').'</p>';
	if($member_types)
	{
			echo '<p>'.__('These are your current member types','church-admin').'</p>';
			foreach($member_types AS $row)
			{
					echo'<p><label>'.esc_html($row->member_type).': </label>member_type_id='.intval($row->member_type_id).'</p>';
			}
	}
}

/*********************************************************
*
* Correctly add $months months to datetime object $date
*
*********************************************************/
function church_admin_addMonths($date, $months)
{
    $years = floor(abs($months / 12));
    $leap = 29 <= $date->format('d');
    $m = 12 * (0 <= $months?1:-1);
    for ($a = 1;$a < $years;++$a) {
        $date = addMonths($date, $m);
    }
    $months -= ($a - 1) * $m;
   
    $init = clone $date;
    if (0 != $months) {
        $modifier = $months . ' months';
       
        $date->modify($modifier);
        if ($date->format('m') % 12 != (12 + $months + $init->format('m')) % 12) {
            $day = $date->format('d');
            $init->modify("-{$day} days");
        }
        $init->modify($modifier);
    }
   
    $y = $init->format('Y');
    if ($leap && ($y % 4) == 0 && ($y % 100) != 0 && 28 == $init->format('d')) {
        $init->modify('+1 day');
    }
    return $init;
}


function church_admin_is_post_type($type){
    global $wp_query;
    if($type == get_post_type()) 
        return true;
    return false;
}



function church_admin_generateVideoEmbedUrl($url){
    
    //This is a general function for generating an embed link of an FB/Vimeo/Youtube Video.
    $finalUrl = '';
    if(strpos($url, 'facebook.com/') !== false) {
        //it is FB video
        $finalUrl.='https://www.facebook.com/plugins/video.php?href='.rawurlencode($url).'&show_text=1&width=200';
    }else if(strpos($url, 'vimeo.com/') !== false) {
        //it is Vimeo video
        $videoId = explode("vimeo.com/",$url)[1];
        if(strpos($videoId, '&') !== false){
            $videoId = explode("&",$videoId)[0];
        }
        $finalUrl.='https://player.vimeo.com/video/'.$videoId;
    }else if(strpos($url, 'youtube.com/') !== false) {
        //it is Youtube video
        $videoId = explode("v=",$url)[1];
        if(strpos($videoId, '&') !== false){
            $videoId = explode("&",$videoId)[0];
        }
        $finalUrl.='https://www.youtube.com/embed/'.$videoId;
    }else if(strpos($url, 'youtu.be/') !== false){
        //it is Youtube video
        $videoId = explode("youtu.be/",$url)[1];
        if(strpos($videoId, '&') !== false){
            $videoId = explode("&",$videoId)[0];
        }
        $finalUrl.='https://www.youtube.com/embed/'.$videoId;
    }else{
        $finalUrl=$url;
        $videoId=NULL;
    }
    
    $output=array('embed'=>$finalUrl,'id'=>$videoId);
    return $output;
}


function church_admin_youtube_api($embed_id)
{
   $views='';
    $google_api=get_option('church_admin_google_api_key');
    if(!empty($google_api)&&!empty($embed_id))
     {
          $args = array('headers' => array( 'Referer' => site_url() ));
           $response=wp_remote_get('https://www.googleapis.com/youtube/v3/videos?part=statistics&id='.esc_html($embed_id).'&key='.$google_api,$args);
           $api_response =  json_decode(wp_remote_retrieve_body( $response ),TRUE);
           $views=$api_response['items'][0]['statistics']['viewCount'];
     }
    return $views;
}
function church_admin_bible_audio_link($holy_str,$version)
{
    
    // split verses from book chapters
    $parts = preg_split('/\s*:\s*/', trim($holy_str, " ;"));

    // init book
    $book = array('name' => "", 'chapter' => "", 'verses' => array());

    // $part[0] = book + chapter, if isset $part[1] is verses
    if(isset($parts[0]))
    {
      // 1.) get chapter
      if(preg_match('/\d+\s*$/', $parts[0], $out)) {
        $book['chapter'] = rtrim($out[0]);
      }

      // 2.) book name
        $searchBook = trim(preg_replace('/\d+\s*$/', "", $parts[0]));
        $book['book'] =church_admin_bible_gateway_books($searchBook);    
        
    }

    // 3.) verses
    if(isset($parts[1])) {
      $book['verses'] = preg_split('~\s*,\s*~', $parts[1]);
    }
    switch($version)
    {
            
        case 'ESV':case'ESVUK':
            $book['url']='https://www.biblegateway.com/audio/mclean/esv/'.$book['book'].'.'.$book['chapter'];
                $book['linkText']='ESV audio';
        break;
        case 'NIV':case'NIVUK' :                    $book['url']='https://www.biblegateway.com/audio/mclean/niv/'.$book['book'].'.'.$book['chapter'];
            $book['linkText']='NIV audio';
        break;
        case 'NASB':    $book['url']='https://www.biblegateway.com/audio/mcconachie/nasb/'.$book['book'].'.'.$book['chapter'];
            $book['linkText']='NASB audio';
        break;
        case 'NVI':
            $book['url']='https://www.biblegateway.com/audio/single/nvi/'.$book['book'].'.'.$book['chapter'];
            $book['linkText']='Nueva Versión Internacional audio';
        break;
        case 'NTLR':
            $book['url']='https://www.biblegateway.com/audio/biblica/ntlr/'.$book['book'].'.'.$book['chapter'];
            $book['linkText']='Nouă Traducere În Limba Română';
        break;
        case 'NVIPT':
            $book['url']='https://www.biblegateway.com/audio/biblica/nvi-pt/'.$book['book'].'.'.$book['chapter'];
            $book['linkText']='Nova Versão Internacional';
        break;
    }
    
    return $book;
}
/*************************************************
*
*   This function returns the abbrev biblegateway.com is looking for
*
**************************************************/
function church_admin_bible_gateway_books($book)
{
    $books=array("Gen"=>array('Genesis','Gen','Ge','Gn'),
       "Exod"=>array('Exodus','Exo','Ex','Exod'),
       "Lev"=>array('Leviticus','Lev','Le','Lv'),
       "Num"=>array('Numbers','Num','Nu','Nm','Nb'),
       "Deut"=>array('Deuteronomy','Deut','Dt'),
       "Josh"=>array('Joshua','Josh','Jos','Jsh'),
       "Judg"=>array('Judges','Judg','Jdg','Jg','Jdgs'),
        "Ruth"=>array('Ruth','Rth','Ru'),
       "1Sam"=>array('1 Samuel','1 Sam','1 Sa','1Samuel','1S','I Sa','1 Sm','1Sa','I Sam','1Sam','I Samuel','1st Samuel','First Samuel'), 
       "2Sam"=>array('2 Samuel','2 Sam','2 Sa','2S','II Sa','2 Sm','2Sa','II Sam','2Sam','II Samuel','2Samuel','2nd Samuel','Second Samuel'), 
       "1Kgs"=>array('1 Kings','1 Kgs','1 Ki','1K','I Kgs','1Kgs','I Ki','1Ki','I Kings','1Kings','1st Kgs','1st Kings','First Kings','First Kgs','1Kin'), 
       "2Kgs"=>array('2 Kings','2 Kgs','2 Ki','2K','II Kgs','2Kgs','II Ki','2Ki','II Kings','2Kings','2nd Kgs','2nd Kings','Second Kings','Second Kgs','2Kin'), 
       "1Chr"=>array('1 Chronicles','1 Chron','1 Ch','I Ch','1Ch','1 Chr','I Chr','1Chr','I Chron','1Chron','I Chronicles','1Chronicles','1st Chronicles','First Chronicles'), 
       "2Chr"=>array('2 Chronicles','2 Chron','2 Ch','II Ch','2Ch','II Chr','2Chr','II Chron','2Chron','II Chronicles','2Chronicles','2nd Chronicles','Second Chronicles'), "Ezra"=>array('Ezra','Ezra','Ezr'), 
       "Neh"=>array('Nehemiah','Neh','Ne'), 
       "Est"=>array('Esther','Esth','Es'), 
        "Job"=>array('Job','Job','Job','Jb'), 
       "Ps"=>array('Psalm','Pslm','Ps','Psalms','Psa','Psm','Pss'), "Prov"=>array('Proverbs','Prov','Pr','Prv'),
        "Eccl"=>array('Ecclesiastes','Eccles','Ec','Ecc','Qoh','Qoheleth'), 
       "Song"=>array('Song of Solomon','Song','So','Canticle of Canticles','Canticles','Song of Songs','SOS'), 
       "Isa"=>array('Isaiah','Isa','Is'), 
       "Jer"=>array('Jeremiah','Jer','Je','Jr'), 
       "Lam"=>array('Lamentations','Lam','La'), 
       "Eze"=>array('Ezekiel','Ezek','Eze','Ezk'), 
       "Dan"=>array('Daniel','Dan','Da','Dn'), 
       "Hos"=>array('Hosea','Hos','Ho'), 
       "Joel"=>array('Joel','Joel','Joe','Jl'), 
       "Amos"=>array('Amos','Amos','Am'), 
       "Obad"=>array('Obadiah','Obad','Ob'), 
    "Jonah"=>array('Jonah','Jnh','Jon'), 
       "Mic"=>array('Micah','Micah','Mic'), 
       "Nah"=>array('Nahum','Nah','Na'), 
       "Hab"=>array('Habakkuk','Hab','Hab'), 
       "Zeph"=>array('Zephaniah','Zeph','Zep','Zp'), 
       "Hag"=>array('Haggai','Haggai','Hag','Hg'), 
       "Zech"=>array('Zechariah','Zech','Zec','Zc'), 
       "Mal"=>array('Malachi','Mal','Mal','Ml'), 
       "Matt"=>array('Matthew','Matt','Mt'), 
       "Mark"=>array('Mark','Mrk','Mk','Mr'), 
       "Luke"=>array('Luke','Luk','Lk'), 
       "John"=>array('John','John','Jn','Jhn'), 
       "Acts"=>array('Acts','Acts','Ac'), 
    "Rom"=>array('Romans','Rom','Ro','Rm'), 
       "1Cor"=>array('1 Corinthians','1 Cor','1 Co','I Co','1Co','I Cor','1Cor','I Corinthians','1Corinthians','1st Corinthians','First Corinthians'), 
       "2Cor"=>array('2 Corinthians','2 Cor','2 Co','II Co','2Co','II Cor','2Cor','II Corinthians','2Corinthians','2nd Corinthians','Second Corinthians'), "Gal"=>array('Galatians','Gal','Ga'), 
       "Eph"=>array('Ephesians','Ephes','Eph'), 
       "Phil"=>array('Philippians','Phil','Php'), 
       "Col"=>array('Colossians','Col','Col'), 
       "1Thess"=>array('1 Thessalonians','1 Thess','1 Th','I Th','1Th','I Thes','1Thes','I Thess','1Thess','I Thessalonians','1Thessalonians','1st Thessalonians','First Thessalonians'), "2Thess"=>array('2 Thessalonians','2 Thess','2 Th','II Th','2Th','II Thes','2Thes','II Thess','2Thess','II Thessalonians','2Thessalonians','2nd Thessalonians','Second Thessalonians'), 
       "1Tim"=>array('1 Timothy','1 Tim','1 Ti','I Ti','1Ti','I Tim','1Tim','I Timothy','1Timothy','1st Timothy','First Timothy'), 
       "2Tim"=>array('2 Timothy','2 Tim','2 Ti','II Ti','2Ti','II Tim','2Tim','II Timothy','2Timothy','2nd Timothy','Second Timothy'), 
       "Titus"=>array('Titus','Titus','Tit'), 
       "Phlm"=>array('Philemon','Philem','Phm'), 
       "Heb"=>array('Hebrews','Hebrews','Heb'), 
       "Jas"=>array('James','James','Jas','Jm'), 
       "1Pet"=>array('1 Peter','1 Pet','1 Pe','I Pe','1Pe','I Pet','1Pet','I Pt','1 Pt','1Pt','I Peter','1Peter','1st Peter','First Peter'), 
       "2Pet"=>array('2 Peter','2 Pet','2 Pe','II Pe','2Pe','II Pet','2Pet','II Pt','2 Pt','2Pt','II Peter','2Peter','2nd Peter','Second Peter'), 
       "1John"=>array('1 John','1 John','1 Jn','I Jn','1Jn','I Jo','1Jo','I Joh','1Joh','I Jhn','1 Jhn','1Jhn','I John','1John','1st John','First John'), 
       "2John"=>array('2 John','2 John','2 Jn','II Jn','2Jn','II Jo','2Jo','II Joh','2Joh','II Jhn','2 Jhn','2Jhn','II John','2John','2nd John','Second John'), 
       "3John"=>array('3 John','3 John','3 Jn','III Jn','3Jn','III Jo','3Jo','III Joh','3Joh','III Jhn','3 Jhn','3Jhn','III John','3John','3rd John','Third John'), 
       "Jude"=>array('Jude','Jude','Jud'), 
       "Rev"=>array('Revelation','Rev','Re','The Revelation') ); 
    
    foreach($books AS $key=>$bookArray)
    {
        if(in_array($book,$bookArray))return $key;
    }
    return $book;
}







function nthday($nth,$day,$date)
{
   //Updated 2020-01-01 because of translated plugin issues...
    //don't use wp_locale as doesn't play nicely with strtotime()
	$days=array(0=>'Sunday',1=>"Monday",2=>"Tuesday",3=>"Wednesday",4=>"Thursday",5=>"Friday",6=>"Saturday");
    $month=date('M',strtotime($date));
    $year=date('Y',strtotime($date));
    return date('Y-m-d',strtotime("$nth {$days[$day]} $month $year"));
}


function church_admin_favourites_menu()
{
    global $church_admin_url,$church_admin_menu;
    $user=wp_get_current_user();
/***************************************
*
*   Favourites    
*
****************************************/
echo '<li class="church-admin-top-menu">';
echo '<div class="church-admin-top-menu-item " data-menu-id="favourites" ><span class="dashicons dashicons-heart"></span> '.__("Favourites",'church-admin')."</div>\r\n";    
$favourites=get_option('church-admin-favourites');

if(!empty($favourites))
{
    $fave=$favourites[$user->ID];
    
    if(!empty($fave))
        {
            echo'<ul id="favourites" class="church-admin-submenu-favourites">'."\r\n";;
            $firstSubMenuItem=1;
            foreach($fave AS $key=>$menuID)
            {
                echo '<li class="favourites ';
                if($firstSubMenuItem==1)echo' first-item';
                $firstSubMenuItem=0;
                echo'" data-menuItem="'.$menuID.'">'."\r\n";
                echo  '<a href="'.wp_nonce_url(str_replace('section='.$church_admin_menu[$menuID]['parent'],'section=favourites',$church_admin_menu[$menuID]['link']),$menuID).'">'.$church_admin_menu[$menuID]['title'].'</a> <span class="remove dashicons dashicons-no" data-remove="'.esc_html($menuID).'"></span>'."\r\n";
                echo"</li>\r\n";
            }
            echo'</ul>';
        }
}
    echo'</li>';
}

/***************************************************
*
*   Premium check and signup
*
****************************************************/
//deprecated
/*function church_admin_premium_check()
{
    $premium=get_option('church_admin_premium');
    if($premium)return TRUE;
    $url = 'https://www.churchadminplugin.com/wp-admin/admin-ajax.php?action=church_admin_premium_check&token='.md5(site_url());
    $result=wp_remote_get($url);
    if($result['body']=='premium')
    {return TRUE;}
    else{
        return FALSE;
    }
}*/
function church_admin_premium()
{   
    $premium=NULL;
    echo '<div class="ca-notice">';
    if(church_admin_app_licence_check())
    {
        $premium=get_option('church_admin_premium');
        
            if(!empty($_POST['save-paypal-details']))
            {
               $premium=array('paypal_email'=>stripslashes($_POST['paypal_email']),
                              'paypal_currency'=>stripslashes($_POST['paypal_currency']),
                              'currency_symbol'=>stripslashes($_POST['currency_symbol']),
                              );
                if(!empty($_POST['gift_aid']))
                {
                    $premium['gift_aid']=TRUE;
                }else $premium['gift_aid']=FALSE;
                if(!empty($_POST['show-in-app']))
                {
                    $premium['show-in-app']=TRUE;
                }else $premium['show-in-app']=FALSE;
                update_option('church_admin_premium',$premium);
            }
            if(empty($premium['paypal_email'])||empty($premium['paypal_currency'])||empty($premium['currency_symbol'])){$paypalClass=' style="color:red" ';}else{$paypalClass='';}
            echo'<h2 class="toggle" id="paypal" '.$paypalClass.'>'.__('Setup  PayPal details (Click to toggle)','church-admin').'</h2>';
            echo'<div class="paypal" style="display:none;" >';
            echo'<form action="" method="POST">';
            echo'<div class="church-admin-form-group"><label>'.__("Paypal email",'church-admin').'</label><input type="email" name="paypal_email" ';
            if(!empty($premium['paypal_email']))echo' value="'.esc_html($premium['paypal_email']).'" ';
            echo'/></div>';
            echo'<div class="church-admin-form-group"><label>'.__("Paypal currency",'church-admin').'</label><select name="paypal_currency" >';
           
            echo'<option value="AUD" '.selected("AUD",$premium['paypal_currency'],FALSE).'>Australian dollar</option>';
            echo'<option value="CAD" '.selected("CAD",$premium['paypal_currency'],FALSE).'>Canadian dollar</option>';
            echo'<option value="EUR" '.selected("EUR",$premium['paypal_currency'],FALSE).'>Euro</option>';
            echo'<option value="MXN" '.selected("MXN",$premium['paypal_currency'],FALSE).'>Mexican Peso</option>';
            echo'<option value="GBP" '.selected("GBP",$premium['paypal_currency'],FALSE).'>Pounds Sterling</option>';
            echo'<option value="SEK" '.selected("SEK",$premium['paypal_currency'],FALSE).'>Swedish Krona</option>';
            echo'<option value="USD" '.selected("USD",$premium['paypal_currency'],FALSE).'>US dollar</option>';
            echo'</select></div>';
            echo'<div class="church-admin-form-group"><label>'.__("Currency Symbol",'church-admin').'</label><input type="text" name="currency_symbol" ';
            if(!empty($premium['currency_symbol']))echo' value="'.esc_html($premium['currency_symbol']).'" ';
            echo'/></div>';
            echo'<div class="church-admin-form-group"><label>'.__("UK churches - gift aid form",'church-admin').'</label><input type="checkbox" name="gift_aid" ';
            if(!empty($premium['gift_aid']))echo' checked="checked" ';
            echo'/></div>';
            echo'<div class="church-admin-form-group"><label>'.__("Show PayPal giving form in app",'church-admin').'</label><input type="checkbox" name="show-in-app" ';
            if(!empty($premium['show-in-app']))echo' checked="checked" ';
            echo'/></div>';
            echo'<p><input type="hidden" name="save-paypal-details" value="TRUE"/><input type="submit" class="button-primary" value="'.__('Save','church-admin').'"/></p></form>';
            echo'</div><script>jQuery(document).ready(function($){$("#paypal").click(function(){$(".paypal").toggle();});});</script>';
        
    }
    else
    {
        echo'<h2>'.__('The Giving module and paid tickets are only available to churches who have the Our Church app.').'</h2>';
        echo'<p><a href="admin.php?page=church_admin/index.php&action=app&section=app">'.__('Buy the app','church-admin').'</a></p>';
        
    }
     echo'</div>';   
    return $premium;
}

function church_admin_app_licence_check()
{
    $licence=get_option('church_admin_app_new_licence');
    if(empty($licence))
    {
        //need to check
        $url = 'https://www.churchadminplugin.com/?licence_check='.md5(site_url());
		
    	$result = wp_remote_get( $url );
		if(is_array($result) && !is_wp_error($result) && $result['body']!='no-sub' && ctype_digit($result['body']))
		{
			update_option('church_admin_app_new_licence','subscribed');
			update_option('church_admin_app_id',$result['body']);
			update_option('church_admin_licence_checked',date('Y-m-d'));
			
		}
        $licenc='subscribed';
    }
    if($licence =='subscribed')
    {
        return true;
    }
    else return FALSE;
    
}


function church_admin_current_donations($people_id,$currYear,$currPledge)
{
    global $wpdb;
    
    $out='';
    $premium=get_option('church_admin_premium');
    $donations=$wpdb->get_results('SELECT * FROM '.CA_GIV_TBL.' WHERE people_id="'.(int)$people_id.'" AND YEAR(donation_date)="'.intval($currYear).'" ORDER BY donation_date DESC');
        if(!empty($donations))
        {
            $total=0;
            $out.='<h3>'.__('Your generosity so far this year','church-admin').'</h3><table><thead><tr><th>'.__('Date','church-admin').'</th><th>'.__('Amount','church-admin').'</th><th>'.__('How given','church-admin').'</th><th>'.__('Fund','church-admin').'</th></tr></thead><tbody>';
            foreach($donations AS $donation)
            {
                $total+=$donation->gross_amount;
                $out.='<tr><td>'.mysql2date(get_option('date_format'),$donation->donation_date).'</td><td>';
                if(!empty($premium['currency_symbol']))$out.=$premium['currency_symbol'];
                $out.=number_format_i18n($donation->gross_amount,2).'</td><td>'.esc_html($donation->txn_type).'</td><td>'.esc_html($donation->fund).'</td></tr>';
            }
            $out.='<tr><td><strong>'.__('Total','church-admin').'</td><td>';
            if(!empty($premium['currency_symbol']))$out.=$premium['currency_symbol'];
            $out.=number_format($total,2).'</td><td colspan=2>&nbsp;</td></tr>';
            if(!empty($currPledge))
            {
                $out.='<tr><td><strong>'.__('Current Pledge','church-admin').'</td><td>';
                if(!empty($premium['currency_symbol']))$out.=$premium['currency_symbol'];
                $out.=number_format_i18n($currPledge,2).'</td><td colspan=2>&nbsp;</td></tr>';
                $out.='<tr><td><strong>'.__('Amount Outstanding','church-admin').'</td><td>';
                if(!empty($premium['currency_symbol']))$out.=$premium['currency_symbol'];
                $out.=number_format_i18n($currPledge-$total,2).'</td><td colspan=2>&nbsp;</td></tr>';
            }
            $out.='</tbody></table>';
        }
    return $out;
}
/********************************************************
*
*   attempt to convert phone number to e.164 format
*
*******************************************************/
function church_admin_e164($mobile)
{
    $mobile=str_replace(' ','',$mobile);
    $mobile=str_replace('-','',$mobile);
    $mobile=str_replace('(','',$mobile);
    $mobile=str_replace(')','',$mobile);
    $mobile=ltrim($mobile,'0');//Europe
    $country=get_option('church_admin_sms_iso');
    $e164cell='+'.$country.$mobile;
    return $e164cell;
}
/********************************************************
*
*   spam check
*   returns TRUE for spam
*   $type = email,text
*******************************************************/
function church_admin_spam_check($text,$type)
{
    if(defined('CA_DEBUG'))church_admin_debug("*****************Spam Check \r\n Checking - $text and type $type");
    //check email type is an email
    if($type=='email' &&!is_email($text))
    {
        //church_admin_debug('Should be an email');
        return TRUE;
    }    
    //look for links
    if(substr_count($text, "http") > 0)
    {
        //church_admin_debug('Contains a link');
        return TRUE;
    }
        //check for spam songs
    $needle=array('click here','Page 1 rankings','bitcoin','shemail','lesbian','gay','Make $1000','casino','teen photos','passive income','porn','bitcoin','viagra','fuck','penis','sex','visit your website','www.yandex.ru','сайт','products on this site','business directory','<script','onClick','boobs','tits','horny','all-night');
    foreach($needle as $query) {
        if(strpos(strtoupper($text), strtoupper($query), 0) !== false)
        {
            //church_admin_debug('Spam words');
            return true; // stop on first true result
        }
    }
    return FALSE;
    
}



/*************************************************************
*
*   Email confirmation send if no GDPR reason and $people_id
*
*************************************************************/
function church_admin_email_confirm($people_id)
{
    //only send email confirm if no GDPR reason
    global $wpdb;
    $person=$wpdb->get_row('SELECT * FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
    if(!empty($person) &&!empty($person->email)&& empty($person->gdpr_reason))
    {
        $message='<p>'.__('Thank you for registering.','church-admin');
        $message.='<p><a href="'.site_url().'/?confirm_email='.md5($person->email).'&amp;people_id='.md5($people_id).'">'.__('Click to confirm your email','church-admin').'</p>';
        add_filter( 'wp_mail_from_name','church_admin_from_name' );
		add_filter( 'wp_mail_from', 'church_admin_from_email');
        add_filter('wp_mail_content_type','church_admin_email_type');
        wp_mail($person->email,__('Please confirm your email address','church-admin'),$message);
        remove_filter('wp_mail_content_type','church_admin_email_type');
        remove_filter( 'wp_mail_from_name','church_admin_from_name' );
		remove_filter( 'wp_mail_from', 'church_admin_from_email');
    }
}


function church_admin_excerpt($string,$length,$end='...')
{
    $string = strip_tags($string);

    if (strlen($string) > $length) {

        // truncate string
        $stringCut = substr($string, 0, $length);

        // make sure it ends in a word so assassinate doesn't become ass...
        $string = substr($stringCut, 0, strrpos($stringCut, ' ')).$end;
    }
    return $string;
}


function church_admin_gz($source, $level = 9){ 
    $dest = $source . '.gz'; 
    $mode = 'wb' . $level; 
    $error = false; 
    if ($fp_out = gzopen($dest, $mode)) { 
        if ($fp_in = fopen($source,'rb')) { 
            while (!feof($fp_in)) 
                gzwrite($fp_out, fread($fp_in, 1024 * 512)); 
            fclose($fp_in); 
        } else {
            $error = true; 
        }
        gzclose($fp_out); 
    } else {
        $error = true; 
    }
    if ($error)
        return false; 
    else
        return $dest; 
} 