<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly





/*************************************
*
*		GIVING List
*
**************************************/
function church_admin_giving_list()
{
    global $wpdb;
    
    echo'<h1>Giving List</h1>';
    church_admin_premium();
    $premium=get_option('church_admin_premium');
    if(empty($premium))
    {
        echo'<p>'.__('To use the PayPal giving shortcode and block please set up PayPal above. Manual giving logging is below','church-admin').'</p>';
    }
    else
    {  echo'<h2>UK Churches</h2>';
        echo'<p>I have just checked with a churches accountancy specialist, <a href="https://marshsolutions.uk">Chris Marsh</a>, to clarify claiming gift aid on Paypal donations. Here is what he said...<br/>In the UK, the Gift Aid would be claimed on the Gross (full) donation value. The fees are a separate expense where the charge value is based on the donation value. When reporting the income, it should be the Gross donations value going to the income and the charge going to the expenditure, which the net amount then reconciles to the balance change.</p><p>You can add Gift Aid tracking in the Setup PayPal details box above</p>';
    }
    
    
    echo'<p><a class="button-primary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit-gift&amp;section=giving','edit-gift').'">'.__('Add donation','church-admin').'</a></p>';
     require_once(plugin_dir_path(dirname(__FILE__)).'includes/pagination.class.php');
    $sql='SELECT a.*,b.*,c.*,a.gift_aid AS thisGA FROM '.CA_GIV_TBL.' a LEFT JOIN '.CA_PEO_TBL.' b ON a.people_id=b.people_id  LEFT JOIN '.CA_SER_TBL.' c ON a.service_id=c.service_id ORDER BY donation_date DESC';
    
    $results=$wpdb->get_results($sql);
    $items=$wpdb->num_rows;
    if($items > 0)
    {

	   $p = new caPagination;
	   $p->items($items);
       $page_limit=get_option('church_admin_pagination_limit');
	   if(empty($page_limit))
       {
           $page_limit=20;
           update_option('church_admin_pagination_limit',20);
       }
	   $p->limit($page_limit); // Limit entries per page
        $p->target("admin.php?page=church_admin/index.php&section=giving&action=giving");
        if(!isset($p->paging))$p->paging=1;
        if(!isset($_GET[$p->paging]))$_GET[$p->paging]=1;
        $p->currentPage((int)$_GET[$p->paging]); // Gets and validates the current page
        $p->calculate(); // Calculates what to show
        $p->parameterName('paging');
        $p->adjacents(1); //No. of page away from the current page
        if(!isset($_GET['paging']))
        {
            $p->page = 1;
        }
        else
        {
            $p->page = intval($_GET['paging']);
        }
            //Query for limit paging
        $limit = esc_sql(" LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit);
        $results=$wpdb->get_results($sql.$limit);
        if(!empty($premium['gift_aid']))
        {
            $tableHeader='<tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Donation date','church-admin').'</th><th>'.__('Gross amount','church-admin').'</th><th>'.__('Transaction fee','church-admin').'</th><th>'.__('Net amount','church-admin').'</th><th>'.__('Donor','church-admin').'</th><th>'.__('Service','church-admin').'</th><th>'.__('Transaction Type','church-admin').'</th><th>'.__('Frequency','church-admin').'</th><th>'.__('Gift Aided?','church-admin').'</th></tr>';
        }
        else
        {
            $tableHeader='<tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Donation date','church-admin').'</th><th>'.__('Gross amount','church-admin').'</th><th>'.__('Transaction fee','church-admin').'</th><th>'.__('Net amount','church-admin').'</th><th>'.__('Donor','church-admin').'</th><th>'.__('Service','church-admin').'</th><th>'.__('Transaction Type','church-admin').'</th><th>'.__('Frequency','church-admin').'</th></tr>';
        }
        // Pagination
    	echo '<div class="tablenav"><div class="tablenav-pages">';
    	echo $p->show();
    	echo '</div></div>';
        echo'<table class="widefat striped"><thead>'.$tableHeader.'<thead><tfoot>'.$tableHeader.'</tfoot><tbody>';
        foreach($results AS $row)
        {
            
            $edit='<a class="button-secondary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit-gift&amp;section=giving&amp;gift_id='.intval($row->giving_id),'edit-gift').'">'.__('Edit','church-admin').'</a>';
            $delete='<a onclick="return confirm(\''.__('Are you sure you want to delete this item?','church-admin').'\')" class="button-secondary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=delete-gift&amp;section=giving&amp;gift_id='.intval($row->giving_id),'delete-gift').'">'.__('Delete','church-admin').'</a>';
            $date=mysql2date(get_option('date_format').' '.get_option('time_format'),$row->donation_date);
            if(!empty($row->last_name))
            {
                $donor='<a title="'.__('View donor giving','church-admin').'" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=donor-gift&amp;section=giving&amp;people_id='.intval($row->people_id),'donor-gift').'">'.esc_html(implode(" ",array_filter(array($row->first_name,$row->prefix,$row->last_name))));
            }
            else{ $donor=esc_html(__('Anonymous','church-admin'));}
            if(!empty($row->paypal_fee)){$fee=$row->paypal_fee;}else{$fee=0;}
            $net_amount=$row->gross_amount-$fee;
            if(empty($row->service))$row->service='';
            if(empty($row->venue))$row->venue='';
            if(empty($row->service_time))$row->service_time='';
            $venue=implode(" ",array_filter(array($row->service_name,$row->venue,$row->service_time)));
            echo'<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.$date.'</td><td>'.esc_html($premium['currency_symbol'].$row->gross_amount).'</td><td>'.esc_html($premium['currency_symbol'].$fee).'</td>
            <td>'.esc_html($premium['currency_symbol'].$net_amount).'</td>
            <td>'.$donor.'</td>
            <td>'.esc_html($venue).'</td><td>'.esc_html($row->txn_type).'</td><td>'.esc_html($row->txn_frequency).'</td>';
            if(!empty($row->thisGA))
            {
                $GA=__('Yes','church-admin');
            }
            else
            {
                $GA=__('No','church-admin');
            }
            if(!empty($premium['gift_aid']))echo'<td>'.$GA.'</td>';
            echo'</tr>';
        }
        echo'</tbody></table>';
        // Pagination
    	echo '<div class="tablenav"><div class="tablenav-pages">';
    	echo $p->show();
    	echo '</div></div>';
    }
    else echo'<p>'.__('No gifts processed yet','church-admin').'</p>';
}


/*************************************
*
*		Edit gift
*
**************************************/
function church_admin_giving_edit($giving_id=NULL)
{
    global $wpdb;
    $premium=get_option('church_admin_premium');
    echo'<h1>'.__('Edit gift','church-admin').'</h1>';
    
    if(!empty($_POST['save-gift']))
    {
        
        if(!empty($_POST['donor']))
        {
            $people_id=church_admin_get_one_id(stripslashes($_POST['donor']));
            if(!ctype_digit($people_id))$people_id=0;
        }else $people_id=0;
        $form=$sqlsafe=array();
        
        foreach($_POST AS $key=>$value)
        {
            $form[$key]=stripslashes($value);
            $sqlsafe[$key]=esc_sql($form[$key]);
        }
        if(!empty($sqlsafe['gift_aid'])){$giftAid=1;}else{$giftAid=0;}
        if(empty($premium['gift_aid']))$giftAid=0;
        if(empty($sqlsafe['email']))$sqlsafe['email']='';
        if(empty($giving_id))
        {
            $giving_id=$wpdb->get_var('SELECT giving_id FROM '.CA_GIV_TBL.' WHERE people_id="'.$people_id.'" AND gross_amount="'.$sqlsafe['amount'].'" AND donation_date="'.$sqlsafe['donation_date'].'" AND txn_type="'.$sqlsafe['txn_type'].'" AND txn_frequency="'.$sqlsafe['txn_frequency'].'" AND service_id="'.$sqlsafe['service_id'].'" AND email="'.$sqlsafe['email'].'"');
        }
        if(empty($giving_id))
        {//insert
            $wpdb->query('INSERT INTO '.CA_GIV_TBL.' (people_id,gross_amount,gift_aid,donation_date,txn_type,txn_frequency,service_id,email)VALUES("'.$people_id.'", "'.$sqlsafe['amount'].'","'.$giftAid.'" ,"'.$sqlsafe['donation_date'].'" ,"'.$sqlsafe['txn_type'].'" ,"'.$sqlsafe['txn_frequency'].'" ,"'.$sqlsafe['service_id'].'", "'.$sqlsafe['email'].'")');
            
        }
        else
        {//update
            $wpdb->query('UPDATE '.CA_GIV_TBL.' SET people_id="'.$people_id.'" , gross_amount="'.$sqlsafe['amount'].'" , donation_date="'.$sqlsafe['donation_date'].'" , txn_type="'.$sqlsafe['txn_type'].'" , txn_frequency="'.$sqlsafe['txn_frequency'].'" , service_id="'.$sqlsafe['service_id'].'",gift_aid="'.$giftAid.'", email="'.$sqlsafe['email'].'" WHERE giving_id="'.(int)$giving_id.'"');
            
        }
        echo'<div class="notice notice-success">'.__('Gift saved','church-admin').'</div>';
        church_admin_giving_list();
    }
    else
    {
        if(!empty($giving_id))$gift=$wpdb->get_row('SELECT * FROM '.CA_GIV_TBL.' WHERE giving_id="'.(int)$giving_id.'"');
        if(!empty($gift->donation_date))
        {
            $donation_date=$gift->donation_date;
        }
        else $donation_date= NULL;
        if(!empty($gift->people_id))
        {
            $name=$wpdb->get_var('SELECT first_name,last_name FROM '. CA_PEO_TBL.' WHERE people_id="'.intval($gift->people_id).'"');
            
        }else $name='';
        echo'<form action="" method="POST">';
        //date
        echo'<div class="church-admin-form-group"><label>'.__('Donation date','church-admin').'</label>'.church_admin_date_picker($donation_date,'donation_date',FALSE,date('Y-m-d',strtotime("-10 years")),NULL,'donation_date','donation_date',FALSE).'</div>';
        //donor
        echo'<div class="church-admin-form-group"><label>'.__('Donor','church-admin').'</label>'.church_admin_autocomplete('donor','friends','to',$name).'</div>';
        echo '<div class="church-admin-form-group"><label>'.__('Email','church-admin').'</label><input type="email" name="email" class="church-admin-form-control"/></div>';
        $services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
        if(!empty($services))
        {
            echo'<div class="church-admin-form-group"><label>'.__('Service','church-admin').'</label><select class="church-admin-form-control" name="service_id"><option value=0>'.__('Pick service','church-admin').'</option>';
            
            foreach($services AS $service)
            {
                if(!empty($gift->service_id)&&($gift->service_id==$service->service_id))
                {
                    echo'<option selected=selected value="'.(int)$service->service_id.'">'.esc_html($service->service_name. ' '.$service->venue.' '.$service->service_time).'</option>';
                }else echo'<option value="'.(int)$service->service_id.'">'.esc_html($service->service_name. ' '.$service->venue.' '.$service->service_time).'</option>';
            }
            echo'</select></div>';
        }
        echo'<div class="church-admin-form-group"><label>'.__('Amount','church-admin').'</label><input type="number" class="church-admin-form-control" name="amount"';
        if(!empty($gift->gross_amount)) echo ' value="'.number_format($gift->gross_amount,2).'"';
        echo'/</div>';
        echo'<div class="church-admin-form-group"><label>'.__('Donation Type','church-admin').'</label><select class="church-admin-form-control" name="txn_type">';
        $types=array(__('Cash','church-admin'),__('Check','church-admin'),__('BACs','church-admin'),__('Standing order','church-admin'));
        foreach($types AS $key=>$type)
        {
            echo '<option value="'.$type.'"';
            if(!empty($gift->txn_type) && $gift->txn_type ==$type) echo 'selected="selected" ' ;
            echo'>'.$type.'</option>';
        }
        echo'</select></div>';
        $freq=array(__('One off','church-admin'),__('Weekly','church-admin'),__('Monthly','church-admin'));
        echo'<div class="church-admin-form-group"><label>'.__('Donation Frequency','church-admin').'</label><select class="church-admin-form-control" name="txn_frequency">';
        foreach($freq AS $key=>$fr)
        {
            echo '<option value="'.$fr.'"';
            if(!empty($gift->txn_type) && $gift->txn_type ==$fr) echo 'selected="selected" ' ;
            echo'>'.$fr.'</option>';
        }
        echo'</select></div>';
        if(!empty($premium['gift_aid']))
        {
            echo'<div class="church-admin-form-group"><label>'.__('Gift Aided?','church-admin').'</label><input type="checkbox" name="gift_aid" ';
            if(!empty($fift->gift_aid))echo' checked="checked"';
            echo'/></div>';
        }
        echo'<div class="church-admin-form-group"><input type="hidden" name="save-gift" value="TRUE"/><input type="submit" value="Save"  class="button-primary"/>';
    }

}
/*************************************
*
*		refund gift
*
**************************************/
function church_admin_giving_delete($giving_id=NULL)
{
    global $wpdb;
    echo'<h1>'.__('Delete gift','church-admin').'</h1>';
    $wpdb->query('DELETE FROM '.CA_GIV_TBL.' WHERE giving_id="'.intval($giving_id).'"');
    echo'<div class="notice notice-success">'.__('Gift deleted','church-admin').'</div>';
    church_admin_giving_list();

}
/*************************************
*
*		View donor
*
**************************************/
function church_admin_donor_giving($people_id=NULL)
{
    global $wpdb;
    echo'<h1>'.__('View donor giving','church-admin').'</h1>';
    if(!church_admin_premium_check())return church_admin_premium();

}
/*************************************
*
*		GIVING funds
*
**************************************/
function church_admin_giving_funds()
{
    echo'<p><a class="button-primary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit-fund&amp;section=giving','edit-fund').'">'.__('Add fund','church-admin').'</a></p>';
    $funds=get_option('church_admin_giving_funds');
    if(!empty($funds))
    {
        $tableHeader='<tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Fund name','church-admin').'</th></tr>';
        echo'<p>'.__("Deleting a fund won't affect previous donations to that fund",'church-admin').'</p>';
        echo'<table class="widefat striped"><thead>'.$tableHeader.'</thead><tfoot>'.$tableHeader.'<tfoot><tbody>';
        foreach($funds AS $key=>$fund)
        {
            $edit='<a class="button-secondary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit-fund&amp;section=giving&amp;fund_id='.intval($key),'edit-fund').'">'.__('Edit','church-admin').'</a>';
            $delete='<a onclick="return confirm(\''.__('Are you sure you want to delete this item?','church-admin').'\')" class="button-secondary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=delete-fund&amp;section=giving&amp;fund_id='.intval($key),'delete-fund').'">'.__('Delete','church-admin').'</a>';
            echo'<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.esc_html($fund).'</td></tr>';
        }
        echo'</tbody></table>';
    }
    
}
/*************************************
*
*		Delete Fund
*
**************************************/

function church_admin_delete_fund($id)
{
    $funds=get_option('church_admin_giving_funds');
    unset($funds[$id]);
    update_option('church_admin_giving_funds',$funds);
    echo'<div class="notice notice-success">'.__('Fund deleted','church-admin').'</div>';
        church_admin_giving_funds();
}
/*************************************
*
*		Edit Fund
*
**************************************/
function church_admin_edit_fund($id)
{
    $funds=get_option('church_admin_giving_funds');
    
    if(!empty($_POST['save-fund']))
    {
        if(isset($id))
        {
            $funds[$id]=stripslashes($_POST['fund']);
        }else $funds[]=stripslashes($_POST['fund']);
        update_option('church_admin_giving_funds',$funds);
        echo'<div class="notice notice-success">'.__('Fund edited','church-admin').'</div>';
        church_admin_giving_funds();
    }
    else
    {
        echo'<h2>'.__('Edit Fund','church-admin').'</h2>';
        echo'<form action="" method="POST">';
        echo'<div class="church-admin-form-group"><label>'.__('Fund name','church-admin').'</label><input type="text" name="fund" ';
        if(!empty($id)&&!empty($funds[$id])) echo ' value="'.esc_html($funds[$id]).'"';
        echo'/></div>';
        echo'<div class="church-admin-form-group"><input type="hidden" name="save-fund" value="TRUE"/><input type="submit" value="Save"  class="button-primary">';
        
    }
}
/*************************************
*
*		CSV  Form
*
**************************************/
function church_admin_giving_csv()
{
    global $wpdb; 
    echo'<h2>'.__('Download CSV','church-admin').'</h2>';
    echo'<form action="" method="GET"><input type="hidden" name="ca_download" value="giving-csv"/>';
    echo'<div class="church-admin-form-group"><label>'.__('Start date','church-admin').'</label>'.church_admin_date_picker('start_date','start_date',FALSE,date('Y-m-d',strtotime("-10 years")),NULL,'start_date','start_date',FALSE).'</div>';
    echo'<div class="church-admin-form-group"><label>'.__('End date','church-admin').'</label>'.church_admin_date_picker('end_date','end_date',FALSE,date('Y-m-d',strtotime("-10 years")),NULL,'end_date','end_date',FALSE).'</div>';
    //people
    $sql='SELECT a.* FROM '.CA_PEO_TBL.' a, '.CA_GIV_TBL.' b WHERE a.people_id=b.people_id GROUP BY a.people_id ORDER By a.last_name';
   
    $results=$wpdb->get_results($sql);
    if(!empty($results))
    {
        echo'<div class="church-admin-form-group"><label>'.__('People','church-admin').'</label><select name="people_id" class="church-admin-form-control"><option value="0">'.__('Everyone','church-admin').'</option>';
        foreach($results AS $row)
        {
            $name=implode(" ",array_filter(array($row->first_name,$row->prefix,$row->last_name)));
            echo'<option value="'.intval($row->people_id).'">'.esc_html($name).'</option>';
        }
        echo '</select></div>';
    }
    
    echo'<div class="church-admin-form-group"><input type="hidden" name="save-fund" value="TRUE"/><input type="submit" value="Save"  class="button-primary"></form>';
}
function church_admin_gift_aid_csv()
{
    global $wpdb; 
    echo'<h2>'.__('Download Gift Aid Report CSV','church-admin').'</h2>';
    $premium=get_option('church_admin_premium');
    if(empty($premium['gift_aid']))
    {
        echo '<p>'.__('You need to be an app subscriber and have setup the Paypal details to include Gift Aid',"church-admin").'</p>';
        return;
    }
    
    echo'<form action="" method="GET"><input type="hidden" name="ca_download" value="gift-aid-csv"/>';
    echo'<div class="church-admin-form-group"><label>'.__('Start date','church-admin').'</label>'.church_admin_date_picker('start_date','start_date',FALSE,date('Y-m-d',strtotime("-10 years")),NULL,'start_date','start_date',FALSE).'</div>';
    echo'<div class="church-admin-form-group"><label>'.__('End date','church-admin').'</label>'.church_admin_date_picker('end_date','end_date',FALSE,date('Y-m-d',strtotime("-10 years")),NULL,'end_date','end_date',FALSE).'</div>';
    $funds=get_option('church_admin_giving_funds');
    echo '<div class="church-admin-form-group"><label>'.__('Fund','church-admin').'</label><select name="fund"><option value="All">'.__('All','church-admin').'</option>';
    foreach($funds AS $key=>$fund)
    {
        echo'<option value="'.urlencode($fund).'">'.esc_html($fund).'</option>';
    }
    echo'</select></div>';
    echo'<div class="church-admin-form-group"><input type="hidden" name="save-fund" value="TRUE"/><input type="submit" value="Save"  class="button-primary"></form>';
}