<?php

if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly

/**
 *
 * Mailchimp sync
 *
 * @author  Andy Moyle
 * @param
 * @return   html string
 * @version  0.1
 *
 *
 */
 function church_admin_mailchimp_sync()
 {
	
	global $wpdb,$people_type;
	if(defined('CA_DEBUG'))$wpdb->show_errors();
	require_once(plugin_dir_path(dirname(__FILE__)).'includes/mailchimp.inc.php');




	echo'<h2>Mailchimp Sync</h2>';
	echo'<p>'.__('From v2.2510 Church Admin will be using "tags" instead of interests and groupings - which will be much easier for you to use','church-admin').'</p>';
	$settings=get_option('church_admin_mailchimp');


	/*********************
	*
	* Set API key
	*
	**********************/
	if(!empty($_POST['save-api-key']))
	{
		$settings['api_key']=stripslashes($_POST['api_key']);
		update_option('church_admin_mailchimp',$settings);
	}

	echo'<h3 id="step1" class="ca-click">'.__('Step 1 - API key (Click to toggle)','church-admin').'</h3><div class="step1" style="display:none">';
	if(empty($settings['api_key']))echo'<p><a target="_blank" href="https://kb.mailchimp.com/accounts/management/about-api-keys/#Find-or-Generate-Your-API-Key">'.__( 'Click here to get your Mailchimp API key','church-admin').'</a></p>';
	echo'<form action="" method="POST">
			<table>
				<tbody>
					<tr>
						<th scope="row">Mailchimp API key</th>
						<td><input type="text" name="api_key" ';
	if(!empty($settings['api_key']))echo ' value="'.esc_html($settings['api_key']).'"';
	echo '/></td><td><input type="hidden" name="save-api-key" value="true"/><input type="submit" class="button-secondary" value="'.esc_html(__('Save','church-admin')).'"/>
		</td>
	</tr>
	</table>
	</form></div>';

	/*********************
	*
	* Instantiate Mailchimp API
	*
	**********************/

	if(!empty($settings['api_key']))
	{
		$MailChimp = new MailChimp($settings['api_key']);
		$MailChimp->verify_ssl = 'false';
	}

	if(!empty($MailChimp))
	{
		$result = $MailChimp->get("lists");
		/*********************
		*
		* Set listID
		*
		**********************/
		if(!empty($_POST['save-listID']))
		{
			$settings['listID']=stripslashes($_POST['listID']);
			update_option('church_admin_mailchimp',$settings);
		}

		$lists=$result['lists'];
		echo '<h3 id="step2" class="ca-click">'.__('Step 2 - Your Mailchimp lists  (Click to toggle)','church-admin').'</h3><div class="step2" style="display:none"><form action="" method="POST">';
		foreach($lists AS $list)
		{
			echo'<p><input type="radio" name="listID" value="'.esc_html($list['id']).'"';
			if(!empty($settings['listID']) && $settings['listID']==$list['id']) echo ' checked="checked" ';
			echo'/> '.esc_html($list['name']).'</p>';
		}
		echo'<p><input type="hidden" name="save-listID" value="true"/><input type="submit" class="button-secondary" value="'.esc_html(__('Save','church-admin')).'"/></p></form></div>';
		//only show sync button if interests have been selected
		if(!empty($settings))
		{
			echo'<h3>'.__('Step 3 - Sync mailchimp','church-admin').'</h3><p><form action="" method="POST"><input type="hidden" name="sync" value="true"/><input class="button-primary" type="submit" value="'.__('Sync','church-admin').'"/></form></p>';
			echo'<p><strong>'.__('Screen will be blank while processing, please be patient','church-admin').'</strong></p>';
		}
		/*********************
		*
		* Get details of list
		*
		**********************/
		if(!empty($settings)&&!(empty($_POST['sync'])))
		{
			$listID=$settings['listID'];
			$listDetails=$MailChimp->get("/lists/$listID");
			church_admin_mailchimp_sync_message($MailChimp);
			$listCount=$listDetails['stats']['member_count'];
			echo '<p>List chosen is "'.$listDetails['name'].'" </p>';
			echo "<p>Number of people on list is $listCount</p>";
			if(defined('CA_DEBUG'))church_admin_debug("Starting Sync");
			/*********************
			*
			* Sort tags
			*
			**********************/
			echo'<p><strong>'.__("Syncing tags",'church-admin').'</strong></p>';
			$tags=church_admin_mailchimp_tags();//tags needed by Church Admin

			if(is_array($tags))
			{
				$MCtags=$MailChimp->get("/lists/$listID/segments",array('count'=>100));
				$total_tags = $MCtags['total_items'];
				echo esc_html(sprintf(__('Current tag count on MailChimp is %1$s','church-admin'),$total_tags)).'<br/>';
				foreach ($MCtags['segments'] as $segment) 
				{
					$MailChimpTags[$segment['id']]=$segment['name'];
				}

				foreach($tags AS $key=>$tag)
				{
					if(!is_array($MailChimpTags)||!in_array($tag,$MailChimpTags))
					{
						echo esc_html(sprintf(__('Adding tag "%1$s"','church-admin'),$tag)).'<br/>';
						$args=array('name'=>$tag,'static_segment'=>array());
						$addTagResponse=$MailChimp->post("/lists/$listID/segments",$args);

					}
					else
					{
						echo esc_html(sprintf(__('"%1$s" is already a tag on MailChimp','church-admin'),$tag)).'<br/>';
					}
				}
				//get the array of tags again for use later
				$MCtags=$MailChimp->get("/lists/$listID/segments",array('count'=>100));
				$MailChimpTags=array();
				foreach ($MCtags['segments'] as $segment) 
				{
					$MailChimpTags[$segment['id']]=$segment['name'];
				}
				$new_total_tags = $MCtags['total_items'];
				update_option('church-admin-MailChimp-Tags',$MailChimpTags);
				echo esc_html(sprintf(__('Current tag count on MailChimp is now %1$s','church-admin'),$new_total_tags)).'<br/>';
			}
			/*********************
			*
			* Work through MailChimp contacts
			*
			**********************/
			$result=$MailChimp->get("/lists/$listID/members",array('status'=>'subscribed','count'=>$listCount));
			
			church_admin_mailchimp_sync_message($MailChimp);
			foreach($result['members'] AS $member)
			{
				
				if(is_array($member)&&!empty($member['email_address'])&&is_email($member['email_address']))
				{	
					$email_address=$member['email_address'];
					$first_name=$member['merge_fields']['FNAME'];
					$last_name=$member['merge_fields']['LNAME'];
					$hash=md5(strtolower($email_address));
					$mailchimp_id=$member['id'];
					echo'<p><strong>'.esc_html(sprintf(__('Handling MailChimp contact %1$s','church-admin'),$first_name.' '.$last_name.' ('.$email_address.')')).'</strong><br/>';
					if(defined('CA_DEBUG'))church_admin_debug(sprintf(__('Handling MailChimp contact %1$s','church-admin'),$first_name.' '.$last_name.' ('.$email_address.')'));
					//check for mailchimp id
					if(defined('CA_DEBUG'))church_admin_debug('Check if MailChimp contact is stored');
					$person=$wpdb->get_row('SELECT people_id,gdpr_reason FROM '.CA_PEO_TBL.' WHERE mailchimp_id="'.esc_sql($mailchimp_id).'"');
					if(empty($person))
					{
						if(defined('CA_DEBUG'))church_admin_debug('Mailchimp_id not stored');
						//first sync or not yet in church admin, look for name and email
						$person=$wpdb->get_row('SELECT people_id,gdpr_reason FROM '.CA_PEO_TBL.' WHERE email="'.esc_sql($email_address).'" AND first_name="'.esc_sql($first_name).'" AND last_name="'.esc_sql($last_name).'"');
					}
				
					if(!empty($person))
					{
						if(defined('CA_DEBUG'))church_admin_debug(" $email_address in directory");
						/**************************************************************************************************
						*
						*	we have found the contact from mailchimp in the directory. 
						*	1 Update CA_PEO_TBL with mailchimp_id and add GDPR reason mailchimp sub if field is empty
						*
						***************************************************************************************************/
						//1 Update CA_PEO_TBL with mailchimp_id and add GDPR reason mailchimp sub if field is empty
						if(empty($person->gdpr_reason))
						{
							$sql='UPDATE '.CA_PEO_TBL.' SET mailchimp_id="'.esc_sql($mailchimp_id).'" , gdpr_reason="'.esc_sql('Subscribed via Mailchimp','church-admin').'" WHERE people_id="'.(int)$person->people_id.'"';
							if(defined('CA_DEBUG'))church_admin_debug("No GDPR reason for contact, but they are subscribed to MailChimp, so update reason\r\n".$sql);
						}
						else
						{
							$sql='UPDATE '.CA_PEO_TBL.' SET mailchimp_id="'.esc_sql($mailchimp_id).'" WHERE people_id="'.(int)$person->people_id.'"';
							if(defined('CA_DEBUG'))church_admin_debug("Update contact with mailchimp_id\r\n".$sql);
						}	
						$wpdb->query($sql);
						//set tags
						$tags=church_admin_mailchimp_person_tags($person->people_id);
						if(!empty($tags))
						{
							echo esc_html(sprintf(__('Set tags for %1$s','church-admin'),$first_name.' '.$last_name)).'<br/>';
							$response=$MailChimp->post("/lists/{$listID}/members/{$hash}/tags",array('tags'=>$tags));
							if($response==1)echo __('Tag update completed','church-admin').'<br/>';
						}
					}
					else
					{
						/***************************************************************************************************
						*
						*	Contact not in Church Admin so add them
						*
						****************************************************************************************************/
						if(defined('CA_DEBUG'))church_admin_debug('MailChimp contact not in Church Admin');
						$wpdb->query('INSERT INTO '.CA_HOU_TBL.' (address,phone)VALUES("","")');
						$household_id=$wpdb->insert_id;
						$member_type_id=$wpdb->get_var('SELECT member_type_id FROM '.CA_MTY_TBL.' ORDER BY member_type_id ASC LIMIT 1 ');
						if(empty($member_type_id))$member_type_id=1;
						$sql='INSERT INTO '.CA_PEO_TBL.' (first_name,last_name,email,member_type_id,mailchimp_id,household_id,people_type_id,head_of_household)VALUES("'.esc_sql($first_name).'","'.esc_sql($last_name).'","'.esc_sql($email_address).'","'.$member_type_id.'","'.esc_sql($mailchimp_id).'","'.(int)$household_id.'",1,1)';
						if(defined('CA_DEBUG'))church_admin_debug($sql);
						$wpdb->query($sql);
						$people_id=$wpdb->insert_id;
						echo "<p>\t".'<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_people&amp;people_id='.(int)$people_id,'edit_people').'" target="_blank">'.esc_html($first_name.' '.$last_name.' ('.$email_address.')').' '.__('added to church admin','church-admin').'</a></p>';
                        $tags=church_admin_mailchimp_person_tags($people_id);
						if(!empty($tags))
						{
							echo esc_html(sprintf(__('Set tags for %1$s','church-admin'),$first_name.' '.$last_name)).'<br/>';
							$response=$MailChimp->post("/lists/{$listID}/members/{$hash}/tags",array('tags'=>$tags));
							if($response==1)echo __('Tag update completed','church-admin').'<br/>';
						}
					}
					echo esc_html(sprintf(__('Finished processing contact from MailChimp %1$s','church-admin'),$first_name.' '.$last_name.' ('.$email_address.')')).'</p>';
				}//valid email address
			}//end work through $members from MailChimp
			echo'<p><strong>'.esc_html(__('Finished processing all contacts from MailChimp','church-admin')).'</strong></p>';
			/***************************************************************************************************
			*
			*	Go through CA_PEO_TBL add anyone with no mailchimp id and GDPR Reason is valid
			*
			****************************************************************************************************/				
			
			echo'<p><strong>'.__('Start processing contacts from Church Admin not yet on MailChimp','church-admin').'</strong></p>';
			$sql='SELECT first_name,last_name,email,people_id FROM '.CA_PEO_TBL.' WHERE email!="" AND (gdpr_reason!="" OR gdpr_reason iS NOT NULL) AND mailchimp_id IS NULL';
			
			$people=$wpdb->get_results($sql);
			
			if(!empty($people))
			{
				foreach($people AS $person)
				{
					echo'<p><strong>'.esc_html(sprintf(__('Adding %1$s ','church-admin'),$person->first_name.' '.$person->last_name.' ('.$person->email.')')).'</strong></p>';
					$args=array('status'=>'subscribed','email_address'=>$person->email,'merge_fields'=>array('FNAME'=>$person->first_name,'LNAME'=>$person->last_name));
					$response=$MailChimp->post("/lists/$listID/members",$args);
					
					if(!empty($response['id']))
					{
						$wpdb->query('UPDATE '.CA_PEO_TBL.' SET mailchimp_id="'.esc_sql($response['id']).'" WHERE people_id="'.(int)$person->people_id.'"');
						echo '<p>'.esc_html($person->first_name.' '.$person->last_name.' ('.$person->email.')').' '.__('added to MailChimp','church-admin').'</p>';
					}
					$tags=church_admin_mailchimp_person_tags($person->people_id);
					if(!empty($tags))
					{
						$hash=md5($person->email);
						echo esc_html(sprintf(__('Set tags for %1$s','church-admin'),$person->first_name.' '.$person->last_name)).'<br/>';
						$response=$MailChimp->post("/lists/{$listID}/members/{$hash}/tags",array('tags'=>$tags));
						if($response==1)echo __('Tag update completed','church-admin').'<br/>';
					}
				}
			}
			else
			{
				echo'<p>'.__("No new Church Admin people entries to add to MailChimp",'church-admin').'</p>';
		
			}
			echo'<p><strong>'.__("MailChimp sync finished",'church-admin').'</strong></p>';
		}//end of processing list
			
		
	}
	echo '<script>jQuery(document).ready(function($) {


			 	$(".ca-click").on("click",function(){
					
					var toggleClass=$(this).attr("id");
					
					console.log(toggleClass);
					
					$("."+toggleClass).toggle();
				
				});
				
				});
				</script>';

}





function church_admin_mailchimp_sync_message($MailChimp)
{
	
	
	if (!$MailChimp->success())
	{
		
		if(defined('CA_DEBUG'))church_admin_debug("*********\r\n".$MailChimp->getLastError());
		
		if(defined('CA_DEBUG'))church_admin_debug(print_r( $MailChimp->getLastRequest(),TRUE));
		
		echo '<p>'.__('MailChimp Error','church-admin')."\r\n".$MailChimp->getLastError().'<pre>';
		
		print_r( $MailChimp->getLastRequest());
		
		echo'</pre></p>';

	
	}
	


}

function church_admin_mailchimp_tags()
{
	
	global $wpdb;
	$tags=array();
	/*********************
	*
	* Build tag list
	*
	**********************/
	//prayer requests
	$tags[]=__('Prayer requests send','church-admin');
	$tags[]=__('Bible readings send','church-admin');
	$tags[]=__('News send','church-admin');
	//gender
	$gender=get_option('church_admin_gender');
	foreach($gender AS $key=>$sex)
	{
		
		$tags[]=$sex;
	}
	//member types
	$member_types=church_admin_member_type_array();
	foreach($member_types AS $id=>$member_type)
	{
		
		$tags[]=$member_type;
	}
	//sites
	$sites=church_admin_sites_array();
	foreach($sites AS $id=>$site)
	{
		
		$tags[]=$site;
	}
	//ministries
	$ministries=church_admin_ministries_array();
	foreach($ministries AS $id=>$ministry)
	{
		
		$tags[]=$ministry;
	}	
	//parents of children
	$kidswork=church_admin_kidswork_array();
	
	if(!empty($kidswork))foreach($kidswork AS $id=>$kidsworkGroup){$tags[]=$kidsworkGroup;}
	//current & future classes
	$classes=$wpdb->get_results('SELECT * FROM '.CA_CLA_TBL.' WHERE end_date>NOW()');
	if(!empty($classes))
	{
		foreach($classes AS $class)$tags[]=__('Class','church-admin').' - '.$class->name;
	}
	//smallgroups
	//Only 100 tags allowed
	$tagCount=count($tags);
	$small_groups=church_admin_small_groups_array();
	if(!empty($small_groups)&&count($small_groups)+$tagCount<=100)
	{
		
		foreach($small_groups AS $id=>$smallgroup)
		{
			
			$tags[]=__('Smallgroup','church-admin').' - '.$smallgroup;
		}
	}
	return $tags;
}


function church_admin_mailchimp_person_tags($people_id)
{
	
	global $wpdb;
	$tags=array();
	$data=$wpdb->get_row('SELECT * FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
	if(!empty($data))
	{
		
		/*********************
		*
		* Build tag list
		*
		**********************/
		//gender
		$gender=get_option('church_admin_gender');
		foreach($gender AS $key=>$sex)
		{
			if($data->sex==$key){$active='active';}else{$active='inactive';}
			$tags[]=array('name'=>$sex,'status'=>$active);
		}
		//member types
		$member_types=church_admin_member_type_array();
		foreach($member_types AS $id=>$member_type)
		{
			if($data->member_type_id==$id){$active='active';}else{$active='inactive';}
			$tags[]=array('name'=>$member_type,'status'=>$active);
			
		}
		//sites
		$sites=church_admin_sites_array();
		foreach($sites AS $id=>$site)
		{
		
			if($data->site_id==$id){$active='active';}else{$active='inactive';}
			$tags[]=array('name'=>$site,'status'=>$active);
		}
		//ministries
		$ministries=church_admin_ministries_array();
		$personMinistries=church_admin_get_people_meta($people_id,'ministry');
		foreach($ministries AS $id=>$ministry)
		{
			if(is_array($personMinistries)&&In_Array($id,$personMinistries)){$active='active';}else{$active='inactive';}
			$tags[]=array('name'=>$ministry,'status'=>$active);
			
		}	
		//parents of children
		$kidswork=church_admin_kidswork_array();
		$parentOf=church_admin_get_kids_groups($people_id);
		if(!empty($kidswork))
		{
			foreach($kidswork AS $id=>$kidsworkGroup)
			{
				if(!empty($parentOf) && is_array($parentOf) && in_array($id,$parentOf)){$active='active';}else{$active='inactive';}
				$tags[]=array('name'=>$kidsworkGroup,'status'=>$active);
			}
		}
		//smallgroups
		//Only 100 tags allowed
		$tagCount=count($tags);
		$small_groups=church_admin_small_groups_array();
		$personGroups=church_admin_get_people_meta($people_id,'smallgroup');
		if(!empty($small_groups)&&count($small_groups)+$tagCount<=100)
		{
		
			foreach($small_groups AS $id=>$smallgroup)
			{
				if(!empty($personGroups) && is_array($personGroups) && in_array($id,$personGroups)){$active='active';}else{$active='inactive';}
				$tags[]=array('name'=>__('Smallgroup - ','church-admin').' - '.$smallgroup,'status'=>$active);
			}
		}
	}
	return $tags;
}