<?php

if ( ! defined( 'ABSPATH' ) ) exit('You need Jesus!'); // Exit if accessed directly
/********************************************
*
*
*	Reconfigured for CA_ROTA_TBL:
* 	January 2017
*
*********************************************/


/**
 *
 * displays rota for $service_id
 *
 * @author  Andy Moyle
 * @param    $service_id
 * @return   html string
 * @version  0.1
 *
 *
 */

function church_admin_rota_list($service_id=NULL)
{
	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
	//initialise
	global $wpdb,$wp_locale;
    $csv='';
	if(empty($service_id))
	{
		//look for first service
		$service_id=$wpdb->get_var('SELECT service_id FROM '.CA_SER_TBL.' WHERE active=1  ORDER BY service_id ASC LIMIT 1');

		if(empty($service_id))
		{
					echo'<div class="notice notice-warning inline"><a href="'.wp_nonce_url("admin.php?page=church_admin/index.php&section=rota&amp;action=edit_service",'edit_service').'">'.__('Please set up a service','church-admin').'</a></div>';
		}

	}



	//check for more than one service and show form if there is
	$sql='SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.active=1';
    
    $services=$wpdb->get_results($sql);
    
	$noOfServices=$wpdb->num_rows;
    
	//always show choose service form if more than one
    if($noOfServices==0){echo'<div class="notice notice-inline notice-warning"><h2 style="color:red">'.__('Please check your services are active under the Services tab','church-admin').'</h2></div>';}
	if($noOfServices>1)
	{
		echo'<form action="admin.php?page=church_admin/index.php&section=rota&amp;action=church_admin_rota_list" method="POST">';
		echo'<table class="form-table"><tbody><tr><th scope=row>'.__('Change Service?','church-admin').'</th><td><select name="service_id">';
		echo'<option>'.__('Choose Service','church-admin').'</option>';
		foreach($services AS $service)
		{

			if($service->service_day!=8)
			{
				echo'<option value="'.(int)$service->service_id.'">'.sprintf( esc_html__( '%1$s at %2$s on %3$s %4$s', 'church-admin' ), $service->service_name, $service->venue,$wp_locale->get_weekday($service->service_day),$service->service_time).'</option>';
			}
			else
			{
				echo'<option value="'.(int)$service->service_id.'">'.sprintf( esc_html__( '%1$s at %2$s', 'church-admin' ), $service->service_name, $service->venue ).'</option>';
			}

		}
		echo'</select> <input type="submit" class="button-primary" name="choose_service" value="'.__('Choose service','church-admin').' &raquo;" /></td></tr></tbody></table></form>';
	}



	//get details of service for title

	$service=$wpdb->get_row('SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.service_id="'.(int)$service_id.'"');
    
	if(!empty($service)&&$service->service_day>=0&&$service->service_day<=7){echo '<h2>'.sprintf( esc_html__( 'Schedule for %1$s at %2$s on %3$s  %4$s', 'church-admin' ), $service->service_name, $service->venue,$wp_locale->get_weekday($service->service_day),$service->service_time ).'</h2>';}
	else{echo '<h2>'.sprintf( esc_html__( 'Schedule for %1$s at %2$s', 'church-admin' ), $service->service_name, $service->venue).'</h2>';}

	//check rota jobs are set up
	$allRotaJobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.'  ORDER by rota_order');
	if(empty($allRotaJobs))
	{//no rota jobs
		echo'<div class="notice notice-warning inline"><a href="'.wp_nonce_url("admin.php?page=church_admin/index.php&section=rota&amp;action=church_admin_rota_settings_list",'rota_settings_list').'">'.__('Please set up some schedule jobs first','church-admin').'</a></div>';
	}
	else
	{//rota jobs exist, so safe to proceed


		$rotaJobs=church_admin_required_rota_jobs($service_id);

		//we now have an array $rotaJobs that contains id as key and name of job as value

		//get rota dates
		if(!empty($_POST['rota_date'])){$rota_date=esc_sql(stripslashes($_POST['rota_date']));}else{$rota_date=NULL;}
		if(!empty($rota_date)&&church_admin_checkdate($rota_date))
		{
			$sql='SELECT rota_date,service_time FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date>="'.$rota_date.'" GROUP BY rota_date';
		}
		else
		{
			$sql='SELECT rota_date,service_time FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date>=CURDATE() GROUP BY rota_date';
		}
		$rotaDatesResults=$wpdb->get_results($sql);

		//If none add 12 weeks worth
		if(empty($rotaDatesResults))
		{
			echo '<p><a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&section=rota&action=edit_rota&amp;service_id='.(int)$service_id.'&amp;mtg_type=service','edit_rota').'">'.__('Add new schedule date','church-admin').'</a>';

		}
		else
		{


			//feed in message if rota date has been copied and then redirected back here
			if(!empty($_GET['message'])&&$_GET['message']=='copied')echo'<div class="notice notice-success inline">'.__('Schedule date copied','church-admin').'</div>';

			//Build Table Header
			echo '<p><a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&section=rota&action=edit_rota&amp;service_id='.(int)$service_id.'&amp;mtg_type=service','edit_rota').'">'.__('Add new schedule date','church-admin').'</a>';
            
           
			//months dropdown
			
			$earliest=$wpdb->get_var('SELECT rota_date FROM '.CA_ROTA_TBL.' WHERE rota_date!="0000-00-00" ORDER BY rota_date LIMIT 1');
			$latest=$wpdb->get_var('SELECT rota_date FROM '.CA_ROTA_TBL.' WHERE rota_date!="0000-00-00" ORDER BY rota_date DESC LIMIT 1');
			
			if(!empty($earliest))
			{
				if(!empty($rota_date)){$current=new DateTime($_POST['rota_date']);}
				else
				{
					$current= new DateTime('today');
					$current->modify('first day of this month');
				}
				$start    = new DateTime($latest);
				$start->modify('first day of next month');
				$end      = new DateTime($earliest);
				$end->modify('first day of this month');
				$interval = DateInterval::createFromDateString('1 month');
				$period   = new DatePeriod($end, $interval, $start);
                
        
	           
				//MICK WALL
				//Added action here, else I was getting unpredictable results.  
				echo'<form action="admin.php?page=church_admin/index.php&section=rota&amp;action=church_admin_rota_list" method="POST"><table><tr><th scope="row">'.__('Choose period starting ','church-admin').'</th><td><select name="rota_date">';	
				echo'<option value="'.$current->format("Y-m-d").'">'.$current->format(get_option('date_format')).'</option>';
				foreach ($period as $dt) {
    				echo'<option value="'.$dt->format("Y-m-d").'">'.$dt->format(get_option('date_format')).'</option>';
				}
				echo'</select>';
				echo'<input type="hidden" name="service_id" value="'.(int)$service_id.'"/><input type="hidden" />';
				echo'<input type="submit" class="button-primary" value="'.__('Go to','church-admin').'"/></table></form>';

			}

			$thead='<tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th width="100">'.__('Date','church-admin').'</th><th>'.__('Time','church-admin').'</th>';
			foreach($rotaJobs AS $id=>$value)
            {
                $thead.='<th>'.esc_html($value).'</th>';
                $csvheader[]='"'.esc_html($value).'"';   
            }
			$thead.='<th>'.__("Copy",'church-admin').'</th>';
			echo '<table class="widefat striped"><thead>'.$thead.'</thead><tfoot>'.$thead.'</tfoot><tbody>';
			$id=1;
           
            
			//build row for each date
			$date_options=$rotaDatesResults;
			foreach($rotaDatesResults AS $row)
			{
				
                $edit_url=wp_nonce_url('admin.php?page=church_admin/index.php&section=rota&action=edit_rota&rota_date='.esc_html($row->rota_date).'&amp;service_id='.(int)$service_id.'&amp;mtg_type=service','edit_rota');
			$delete_url=wp_nonce_url('admin.php?page=church_admin/index.php&section=rota&action=delete_rota&rota_date='.esc_html($row->rota_date).'&amp;service_id='.(int)$service_id.'&amp;mtg_type=service','delete_rota');


				echo'<tr>
					<td><a href="'.$edit_url.'">'.__('Edit','church-admin').'</a></td>
					<td><a href="'.$delete_url.'" onclick="return confirm(\'Are you sure?\')">'.__('Delete','church-admin').'</a></td>
					<td>'.mysql2date(get_option('date_format'),$row->rota_date).'</td><td>'.mysql2date(get_option('time_format'),$row->service_time).'</td>';
				
				foreach($rotaJobs AS $rota_task_id=>$jobName)
				{
					//note that rota_id for ALL rota jobsrefers to the rota task id!
					$people=church_admin_rota_people_array($row->rota_date,$rota_task_id,$service_id,'service');
                    
					echo'<td class="ca-names" id="'.$id.'"><span class="rota_edit" data-time="'.esc_html($row->service_time).'" data-id="'.$id.'" data-date="'.esc_html($row->rota_date).'" data-service_id="'.(int)$service_id.'" data-rota_task_id="'.(int)$rota_task_id.'" >';
					if(!empty($people)){ echo esc_html(implode(", ",$people));}else{echo '<em>'. __('Click to enter data','church-admin').'</em>';}
					echo '</span></td>';
					$id++;
                    
				}
                
				//copy section
				echo'<td><form action="'.admin_url().'admin.php" method="GET">';
				echo'<input type="hidden" name="page" value="church_admin/index.php"/><input type="hidden" name="tab" value="rota"/><input type="hidden" name="action" value="copy_rota_data"/>';
				echo wp_nonce_field('copy_rota','copy_rota');
				echo'<input type="hidden" name="service_id" value="'.(int)$service_id.'"/><input type="hidden" name="mtg_type" value="service"/>';
				echo'<input type="hidden" name="rotaDate1" value="'.esc_html($row->rota_date).'"/>';
				echo __('Copy to new schedule date...','church-admin').church_admin_date_picker($row->rota_date,'rotaDate2',FALSE,NULL,NULL,'new_date'.$row->rota_date,'new_date'.$row->rota_date);
				echo'<input type="submit" value="'.__('Copy schedule','church-admin').'"/></form></td>';
				echo'</tr>';
               }
            
			echo'</tbody></table>';
			$nonce = wp_create_nonce("edit_rota");
			echo '<script>jQuery(document).ready(function($) {
				$("body").on("click",".rota_edit",function(){
				console.log("Rota Item clicked");
					var date=$(this).data("date");
					var rota_task_id=$(this).data("rota_task_id");
					var id=$(this).data("id");
					console.log(" id is "+id);
					var time=$(this).data("time");
					var data=$(this).text();
                    console.log(data);
					//undo all current input fields
					$("body .editing").each(function(){
						var oldId=$(this).data("id");
						var html=$(this).data("data");
						$("#"+oldId).html(html);
					})
									
					var newText="<input  type=\"text\" data-service_id=\"'.(int)$service_id.'\" data-id=\""+ id +"\" data-data=\""+data+"\" val=\""+data+"\" data-time= \""+time+"\" data-date=\""+date+"\" data-rota_task_id=\""+rota_task_id+"\" data-data=\""+data+"\" class=\"editable_rota\" autofocus placeholder=\""+data+"\"/>"; 
					$("#"+id).html(newText)
				});
				
				$("body").on("change", ".editable_rota", function()
				{
					console.log("Changed");
					var data=$(this).val();
					var rota_task_id=$(this).data("rota_task_id");
					var rota_date=$(this).data("date");
					var id=$(this).data("id");
					var service_id=$(this).data("service_id");
					var time=$(this).data("time");
					var data = {
						"action": "church_admin",
						"method": "edit_rota",
						"nonce": "'.$nonce.'",
						"rota_task_id":rota_task_id,
						"rota_date":rota_date,
						"content":data,
						"id":id,
						"time":time,
						"service_id":service_id
					};
					console.log(data);
					// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
					jQuery.post(ajaxurl, data, function(response) {console.log(response);
						$("#"+id).html(response);
						
					});
				})
			
			});</script>';
		

        
        }
        
	   



	}//end rota jobs exist
}//end function

function church_admin_rota_csv($start_date,$end_date,$service_id,$initials=0)
{
    if(!is_user_logged_in())exit(__('Login required','church-admin'));
    if(empty($service_id))exit(__('Service needs specifying','church-admin'));
    global $wpdb;
    //csv header
    $rotaJobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER BY rota_order');
		$requiredRotaJobs=$rotaDates=array();
		foreach($rotaJobs AS $rota_task)
		{
			$allServiceID=maybe_unserialize($rota_task->service_id);
			if(is_array($allServiceID)&&in_array($service_id,$allServiceID))$requiredRotaJobs[$rota_task->rota_id]=array('job'=>$rota_task->rota_task,'initials'=>$rota_task->initials);
		}
        
    $csv='';
    $csvheader=array(__('"Date"','church-admin'));
    foreach($requiredRotaJobs AS $id=>$rotaJobsArray)
    {
        $csvheader[]='"'.esc_html($rotaJobsArray['job']).'"';   
    }
    //get dates
    $sql='SELECT rota_date,service_time FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date>="'.esc_sql($start_date).'" AND rota_date<="'.esc_sql($end_date).'" GROUP BY rota_date ORDER BY rota_date ASC';
    
    $rotaDatesResults=$wpdb->get_results($sql);
    if(!empty($rotaDatesResults))
    {
        
        foreach($rotaDatesResults AS $rotaDateRow)
        {
            $csvrow=array();
            foreach($requiredRotaJobs AS $rota_task_id=>$jobArray)
			{
				            
                if(empty($initials)&&empty($jobArray['initials']))
                    {
					   $people=esc_html(church_admin_rota_people($rotaDateRow->rota_date,$rota_task_id,$service_id,'service'));
                    }
                    else
                    {//initials
                        
                        $people=esc_html(church_admin_rota_people_initials($rotaDateRow->rota_date,$rota_task_id,$service_id,'service'));
                    }
                $csvrow[]='"'.html_entity_decode($people).'"';
            }
            $csv.='"'.mysql2date(get_option('date_format'),$rotaDateRow->rota_date).'",'.implode(",",$csvrow)."\r\n";
        }
     church_admin_debug($csv);   
    
    }else{$csv='Nothing here yet';}
    header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename="schedule.csv"');
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate');
	header('Pragma: public');
	header("Content-Disposition: attachment; filename=\"schedule.csv\"");
	echo implode(",",$csvheader)."\r\n".$csv;
}



  /**
 *
 * Delete rota entry
 *
 * @author  Andy Moyle
 * @param    $date,$mtg_type,$service_id
 * @return   BOOL
 * @version  0.1
 *
 */
 function church_admin_delete_rota($rota_date,$mtg_type,$service_id)
 {
 	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
 	global $wpdb;
 	$wpdb->query('DELETE FROM '.CA_ROTA_TBL.' WHERE rota_date="'.esc_sql($rota_date).'" AND mtg_type="'.esc_sql($mtg_type).'" AND service_id="'.(int)$service_id.'"');
 	echo '<div class="notice notice-success inline">'.__('Schedule Date Deleted','church-admin').'</div>';
	//MICK WALL
	 //Redirect back to the list for current selected service.
	 $url=admin_url().'admin.php?page=church_admin%2Findex.php&action=church_admin_rota_list&message=Schedule Date Deleted&section=rota&service_id='.$service_id;
	 wp_redirect( $url );
 	exit();
 }

/**
 *
 * copies data from rota_date to another rota_date
 *	Call early and then redirect to protect url, in case it is done again.
 *
 * @author  Andy Moyle
 * @param    $rotaDate1,$rotaDate2, $service_id,$mtg_type
 * @return   NULL
 * @version  0.1
 *
 */
function church_admin_copy_rota($rotaDate1,$rotaDate2, $service_id,$mtg_type)
{
	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
	$message=__("copied",'church-admin');
	//$rotaDate1 is destination
	//$rotaDate2 is copy
	global $wpdb;
	//Mick Wall
	// only copy if the dates are different
	if ($rotaDate1 != $rotaDate2)
	{
		$wpdb->query('DELETE FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date="'.$rotaDate2.'"');
		$results=$wpdb->get_results('SELECT * FROM '.CA_ROTA_TBL.' WHERE rota_date="'.esc_sql($rotaDate1).'"  AND mtg_type="'.esc_sql($mtg_type).'" AND service_id="'.(int)$service_id.'"');
		if(!empty($results))
		{
			foreach($results AS $row)
			{
				church_admin_update_rota_entry($row->rota_task_id,$rotaDate2,$row->people_id,$mtg_type,$service_id,$row->service_time);
			}
		}
	}
	else
		$message="ERROR:+You+cannot+copy+to+the+same+date.";
	return $message;
}
/**
 *
 * Edit Rota Date
 *
 * @author  Andy Moyle
 * @param    $rota_date,$mtg_type,$service_id
 * @return
 * @version  0.1
 *
 */
function church_admin_edit_rota($rota_date=NULL,$mtg_type='service',$service_id=1)
{
	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
	global $wpdb;

	if(empty($rota_date)&&!empty($_POST['rota_date'])){$rota_date=$_POST['rota_date'];}

	$requiredRotaJobs=church_admin_required_rota_jobs($service_id);
	//grab service details
	$service=$wpdb->get_row('SELECT * FROM '.CA_SER_TBL.' WHERE service_id="'.(int)$service_id.'"');
	if(!empty($rota_date))$service_time=$wpdb->get_var('SELECT service_time FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND rota_date="'.esc_sql($rota_date).'" LIMIT 1');
	//grab rota jobs for thsi service id
	$rota_tasks=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.'  ORDER BY rota_order');
	$requiredRotaJobs=$requiredMinistries=array();
	foreach($rota_tasks AS $rota_task)
	{
		$allServiceID=maybe_unserialize($rota_task->service_id);
		if(is_array($allServiceID)&&in_array($service_id,$allServiceID))$requiredRotaJobs[$rota_task->rota_id]=$rota_task->rota_task;
		$requiredMinistries[$rota_task->rota_id]=maybe_unserialize($rota_task->ministries);
	}



	if(!empty($_POST['save_rota'])&&!empty($rota_date)&&check_admin_referer('edit_rota','nonce'))
	{
		//clear out current entries for that date,service_id and mtg_type;
		$wpdb->query('DELETE FROM '.CA_ROTA_TBL.' WHERE service_id="'.(int)$service_id.'" AND mtg_type="service" AND rota_date="'.$rota_date.'"');

		foreach($requiredRotaJobs AS $job_id=>$job_name)
		{
			//deal with checkbox generated entries
			if(!empty($_POST['j'.$job_id]))
			{

				foreach($_POST['j'.$job_id] AS $key=>$people_id)
				{


					church_admin_update_rota_entry($job_id,$rota_date,$people_id,'service',$service_id,$_POST['service_time']);
				}
			}
			//deal with autocomplete
			if(!empty($_POST[$job_id]))
			{
				$people=unserialize(church_admin_get_people_id(stripslashes($_POST[$job_id])));
				foreach($people AS $key=>$people_id)
				{
					church_admin_update_rota_entry($job_id,$rota_date,$people_id,'service',$service_id,$_POST['service_time']);
				}
			}
		}

		echo '<div class="notice notice-success inline">'.__('Schedule Updated','church-admin').'</div>';
		church_admin_rota_list($service_id);

	}
	else
	{//form
		echo'<h2>'.__('Edit Schedule for','church-admin').' ';
		if(!empty($rota_date))echo mysql2date(get_option('date_format'),$rota_date).' ';
		echo esc_html($service->service_name).'</h2>';

		echo'<form action="" method="POST">';
		echo'<table class="form-table">';
		if(empty($rota_date))
		{
			echo '<tr><th scope="row">'.__('Date','church-admin').'</th><td>'.church_admin_date_picker(NULL,'rota_date',FALSE,NULL,NULL,'rota_date','rota_date').'</td></tr>';

		}
		
		echo '<tr><th scope="row">'.__('Service time','church-admin').'</th><td><input type="text" name="service_time" ';
		if(!empty($service_time)){echo' value="'.esc_html($service_time).'" ';}else{echo' value="'.esc_html($service->service_time).'" ';}
			echo'/></td></tr>';
		
		foreach($requiredRotaJobs AS $job_id=>$job_name)
		{
			echo'<tr><th scope="row">'.esc_html($job_name).'</th><td>';

			//checkbox first
			$currentPeople=church_admin_rota_people_array($rota_date,$job_id,$service_id,'service');

			$allMinistryPeople=array();
			if(!empty($requiredMinistries[$job_id]))
			{

				foreach($requiredMinistries[$job_id]AS $key=>$ministry_id)
				{

					$allMinistryPeople=$allMinistryPeople+church_admin_ministry_people_array($ministry_id);
				}

				asort($allMinistryPeople);
				foreach($allMinistryPeople AS $people_id=>$name)
				{
					echo'<input  type="checkbox" name="j'.intval($job_id).'[]" value="'.(int)$people_id.'"';
					if(!empty($currentPeople[$people_id])) {echo ' checked="checked "';unset($currentPeople[$people_id]);}
					echo'/> <span class="ca-names">'.esc_html($name).'</span><br/>';
				}
			}
			//autocomplete text field populated with rest of names!
			if(!empty($currentPeople)){$current=implode(", ",$currentPeople);}else{$current='';}

			echo church_admin_autocomplete(intval($job_id),'friends'.intval($job_id),'to'.intval($job_id),$current,FALSE);
			echo'</tr>';
		}
		echo'<tr><td cellspacing=2><input type="hidden" name="save_rota" value="yes"/>'.wp_nonce_field('edit_rota','nonce').'<input type="submit" class="button-primary" value="'.__('Save','church-admin').'"/></td></tr>';
		echo'</table></form>';

	}//form


}





 /**
 *
 * Emails out the rota
 *
 * @author  Andy Moyle
 * @param    $service_id,$date
 * @return   html string
 * @version  0.2
 *
 * Fix for translated installs, don't translate date
 */
function church_admin_email_rota($service_id=1,$date=NULL)
{
	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
 	$debug=TRUE;

	global $church_admin_version,$wpdb,$wp_locale;
	//don't translate days as strtotime doesn't work
	$wpdb->show_errors;
	//grab service details
	 $service=$wpdb->get_row('SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.service_id="'.esc_sql($service_id).'"');
    
    church_admin_debug(print_r($service,TRUE));
    if(empty($date)){$rota_data=$wpdb->get_row('SELECT rota_date,service_time FROM '.CA_ROTA_TBL.' WHERE mtg_type="service" AND service_id="'.(int)$service_id.'" AND rota_date>=CURDATE() ORDER BY service_id,rota_date ASC LIMIT 1');}
    else
    {
        $rota_data=$wpdb->get_row('SELECT rota_date,service_time FROM '.CA_ROTA_TBL.' WHERE mtg_type="service" AND service_id="'.(int)$service_id.'" AND rota_date="'.esc_sql($date).'" ORDER BY service_id,rota_date ASC LIMIT 1'); 
    }


	if(!empty($_POST['rota_email'])&& check_admin_referer('send_rota','nonce'))
	{//process form and send email


		$rotaJobs=church_admin_required_rota_jobs($service_id);

		//$rotaJobs is an array rota_task_id=>rota_task


		//build email

			//build rota with jobs
			$user_message=stripslashes(nl2br($_POST['message']));
			//fix floated images for email
			$user_message=str_replace('class="alignleft ','style="float:left;margin-right:20px;" class="',$user_message);
			$user_message=str_replace('class="alignright ','style="float:right;margin-left:20px;" class="',$user_message);
			//$textversion=strip_tags($user_message).'\r\n for '.$service->service_name.' on '.$days[$service->service_day].' at '.$service->service_time.' '.$service->venue.'\r\n';
			if($service->service_day!=8){$message=$user_message.'<h4>'.esc_html(sprintf(__('Schedule for %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,$wp_locale->get_weekday($service->service_day).' '.mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time )).'</h4>';}
			else{$message=$user_message.'<h4>'. esc_html(sprintf(__( 'Schedule for %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time)).'</h4>';}

	
			$message.='<table><thead><tr><th>'.__('Ministry','church-admin').'</th><th>'.__('Who','church-admin').'</th></tr></thead><tbody>';
			$recipients=$pushTokens=array();
			$app_id=get_option('church_admin_app_id');
			foreach($rotaJobs AS $rota_task_id=>$jobName)
				{
					$people='';
					
					$people=church_admin_rota_people_array($rota_data->rota_date,$rota_task_id,$service_id,'service');

					if(!empty($people))
					{
						foreach($people AS $people_id=>$name)
						{
							$email=$wpdb->get_var('SELECT email FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'" AND email!="" AND email_send=1 && gdpr_reason!=""');
                            //send copy to parent if a child
                            $moreData=$wpdb->get_row('SELECT * FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'"');
                            if($moreData->people_type_id!=1)
                            {
                                $parentEmail=$wpdb->get_var('SELECT email FROM '.CA_PEO_TBL.' WHERE household_id="'.intval($moreData->household_id).'" AND email!="" AND email_send=1 && gdpr_reason!="" ORDER BY people_order LIMIT 1');
                                $parentName=sprintf(__('Parent of %1$s',"church-admin"),$name);
                                if(!empty($parentEmail))$recipients[$parentName]=$parentEmail;
                            }
							if(!empty($email)&&!in_array($email,$recipients))$recipients[$name]=$email;
							$pushTokenDetails=$wpdb->get_row('SELECT CONCAT_WS(" ",first_name,last_name) AS name, pushToken FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'" AND (pushToken!=""||pushToken!=NULL)');
							if(!empty($pushTokenDetails->pushToken)&&!in_array($pushTokenDetails->pushToken,$pushTokens))$pushTokens[$name]=$pushTokenDetails->pushToken;
							if(defined('CA_DEBUG'))church_admin_debug(print_r($pushTokenDetails,TRUE));
							
						}
						$message.='<tr><td>'.esc_html($jobName).'</td><td>'.esc_html(implode(", ",$people)).'</td></tr>';
					}
				}
				$message.='</table>';


			//start emailing the message
			$message.='';
			if(!empty($recipients))
			{

				add_filter( 'wp_mail_from_name','church_admin_from_name' );
				add_filter( 'wp_mail_from', 'church_admin_from_email');
				add_filter('wp_mail_content_type','church_admin_email_type');
				foreach($recipients AS $name=>$email)
				{
					 	$email_content='<p>'.__('Dear','church-admin').' '.$name.',</p>'.$message;
						$whenToSend=get_option('church_admin_cron');
						if($whenToSend=='immediate'||empty($whenToSend))
						{

							add_filter( 'wp_mail_content_type', 'set_html_content_type' );


							if(wp_mail($email,__("This week's service schedule for ",'church-admin').mysql2date(get_option('date_format'),$rota_data->rota_date),$email_content))
							{
								echo'<p>Email to '.esc_html($email).' sent immediately</p>';

							}
							else
							{//log errors
								global $phpmailer;
								if (isset($phpmailer)) {
									church_admin_debug("**********\r\n rota.new.php line303\r\n ".print_r($phpmailer->ErrorInfo,TRUE)."\r\n");
								}
							}
							remove_filter( 'wp_mail_content_type', 'set_html_content_type' );
						}
						else
						{
							if(QueueEmail($email,__("This week's service schedule",'church-admin'),$email_content,'',get_option('blogname'),get_option('admin_email'),'',''))
							{
								echo'<p>Email to '.esc_html($name).' queued</p>';
															}
						}
					}
				}
				//push notification...
				if(!empty($pushTokenDetails)&&!empty($app_id))
				{
					foreach($pushTokenDetails AS $name=>$pushToken)
					{	
						$api_key="AAAA50JK2is:APA91bE-SZWcUncaSxdbevuGOdochq7zS2fgJabNBAmbqBnmR8Lq4BoaQwG_p-JM2Ftx5rAKInlnG5RmxhWW_LcOPW9A9cQqpg7tUA1GFi1-NvX2q5YbFqnM9ZmV5xuE0PfeRWFUL1d4Te4zwzpu5qglwzZpg_JWzg";
						$url = 'https://fcm.googleapis.com/fcm/send';

						$headers = array('Authorization: key=' . $api_key,'Content-Type: application/json');

						$data=array("notification"=>array(
									"title"=>"Church App",
									"body"=>esc_html(sprintf(__('Don\'t forget you are involved at the %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time )),
									"sound"=>"default",
									"click_action"=>"FCM_PLUGIN_ACTIVITY",
									"icon"=>"fcm_push_icon",
									"content_available"=> true
								),
                                    "apns"=> array(
                                            'headers'=> array( 
                                                        'apns-push-type'=> 'alert',
                                                        "apns-priority"=>5,
                                                        "apns-topic"=>"com.churchadminplugin.wpchurch"
                                            ),
                                            "payload"=>array("alert"=>array("title"=>"Church App","body"=>esc_html(sprintf(__('Don\'t forget you are involved at the %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time )),
                                                             "aps"=>array( "content-available"=>1),
                                                             "sound"=>"default","content-available"=>1
                                                            )
                                            )
                                ),
								"data"=>array(
									"title"=>"Church App",
									"body"=>esc_html(sprintf(__('Don\'t forget you are involved at the %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time )),
									"type"=>'rota'
								),
								"to"=>$pushToken,
								"priority"=>"high",
							);
							$ch = curl_init ();
							curl_setopt ( $ch, CURLOPT_URL, $url );
							curl_setopt ( $ch, CURLOPT_POST, true );
							curl_setopt ( $ch, CURLOPT_HTTPHEADER, $headers );
							curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, true );
							curl_setopt ( $ch, CURLOPT_POSTFIELDS, json_encode($data) );

							$result = curl_exec ( $ch );
							echo'<p>Push Notification sent to '.esc_html($name).'</p>';
							curl_close ( $ch );
					}//foreach
				}
	}//end send out email
	else
	{
		if($service->service_day!=8){$day=$wp_locale->get_weekday($service->service_day);}else{$day='';}
		echo'<h2>'.esc_html (sprintf( __( 'Email service schedule for %1$s at %2$s on %3$s at %4$s', 'church-admin' ),$service->service_name, $service->venue,$day.' '.mysql2date(get_option('date_format'),$rota_data->rota_date),$rota_data->service_time )).'</h2><form action="" method="post">';
		echo'<table class="form-table"><tr><th scope="row">'.__('From name','church-admin').'</th><td><input type="text" id="from_name" name="from_name"  ';
		$from_name=get_option('church_admin_from_name');
		if(!empty($from_name)) echo ' value="'.esc_html($from_name).'"';
		echo'/></td></tr>';
		echo'<tr><th scope="row">'.__('From email','church-admin').'</th><td><input type="text" id="from_email" name="from_email"  ';
		$from_email=get_option('church_admin_from_email');
		if(!empty($from_email)) echo ' value="'.esc_html($from_email).'"';
		echo'/></td></tr></table>';
		echo'<p>'.__('The email will contain a salutation and the service schedule. Please add your own message','church-admin').'</p>';
		wp_editor('','message',"", true);
		echo'<p><input type="hidden" name="rota_email" value="yes"/>'.wp_nonce_field('send_rota','nonce').'<input type="submit" class="button-primary" value="'.__('Send to rota participants','church-admin').'"/></p>';
		echo'</form>';
	}

}

 /**
 *
 * SMS next rota out for $service_id
 *
 * @author  Andy Moyle
 * @param    $service_id
 * @return   html
 * @version  0.1
 *
 *
 */

function church_admin_sms_rota($service_id=NULL)
{
  if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
   	$debug=TRUE;

    global $wpdb,$wp_locale;
    $rota_date=$wpdb->get_var('SELECT rota_date FROM '.CA_ROTA_TBL.' WHERE mtg_type="service" AND service_id="'.(int)$service_id.'" AND rota_date>CURDATE() ORDER BY rota_date ASC LIMIT 1');
    if(!empty($rota_date))
    {
    	 $service=$wpdb->get_row('SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.service_id="'.esc_sql($service_id).'"');

    	if($service->service_day!=8){echo '<h2>'.sprintf( esc_html__( 'Schedule for %1$s at %2$s on %3$s at %4$s', 'church-admin' ), $service->service_name, $service->venue,mysql2date(get_option('date_format'),$rota_date),$service->service_time ).'</h2>';}
			else{echo '<h2>'.sprintf( esc_html__( 'Schedule for %1$s at %2$%', 'church-admin' ), $service->service_name, $service->venue).'</h2>';}

		$username=get_option('church_admin_sms_username');
		$password=get_option('church_admin_sms_password');
		$sender=get_option('church_admin_sms_reply');
		$sms_type=get_option('church_admin_bulksms');
		if(empty($username)||empty($password)||empty($sender)||empty($sms_type))
		{
			$out='<h2>Please setup your Bulksms account settings first</h2>';
			echo $out;
			if(!empty($debug))church_admin_debug("**********\r\n rota.new.php line632\r\n FORM ".$out."\r\n");
		}
		else
		{
			//initialise sms sending
			require_once(plugin_dir_path(__FILE__).'/sms.php');

    		if(!empty($debug))church_admin_debug('SMS Schedule Send: '.date('Y-m-d h:i:s'));
			//get jobs
			$jobs=church_admin_required_rota_jobs($service_id);
			//get people and mobile for each job
			$recipients=array();
			foreach($jobs AS $job_id=>$jobName)
			{
				//array of people
				$people=church_admin_rota_people_array($rota_date,$job_id,$service_id,'service');
				foreach($people AS $people_id=>$name)
				{
					$message=sprintf(__('A quick reminder from %1$s, on %2$s at %3$s, you are scheduled for %4$s','church-admin'),get_option('blogname'),mysql2date(get_option('date_format'),$rota_date),mysql2date(get_option('time_format'),$service->service_time),$jobs[$job_id]);
					$mobile=$wpdb->get_var('SELECT mobile FROM '.CA_PEO_TBL.' WHERE people_id="'.(int)$people_id.'" AND mobile!=""');
					$mobile=str_replace(' ','',$mobile);
					$mobile=str_replace('(','',$mobile);
					$mobile=str_replace(')','',$mobile);
                    $country=get_option('church_admin_sms_iso');
					$sendmobile=$country.$mobile;//non UK
					if(($country==44||$country==33||$country==61) && !empty($mobile) && $mobile{0}=='0')//uk & FR remove preceding 0
					{
             			$sendmobile=$country.substr($mobile, 1);
        			}
                   
					$result=church_admin_sms($sendmobile,$message);
					//$result=array('success'=>TRUE);//debug
					if( $result['success'] )
					{
						echo'<p>'.__('SMS sent to','church-admin').' '.esc_html($name).'</p>';
					}
				}
			}

		}
	}//rota_date found
}


 /**
 *
 * Required rota jobs for service_id
 *
 * @author  Andy Moyle
 * @param    $service_id
 * @return   array rota_task_id=>$rota_task
 * @version  0.1
 *
 *
 */
function church_admin_required_rota_jobs($service_id)
{
	global $wpdb;
	$rota_tasks=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.'  ORDER BY rota_order');
	$requiredRotaJobs=array();
	foreach($rota_tasks AS $rota_task)
	{
		$allServiceID=maybe_unserialize($rota_task->service_id);
		if(is_array($allServiceID)&&in_array($service_id,$allServiceID))$requiredRotaJobs[$rota_task->rota_id]=$rota_task->rota_task;
	}
	return $requiredRotaJobs;

}

/**
*
* Check rota wp-cron jobs
*
* @author  Andy Moyle
* @param
* @return
* @version  0.1
*
*
*/
function church_admin_cron_check()
{
 global $wpdb,$wp_locale;

    $cron=get_option('cron');
    echo'<h1>'.__('Current auto schedule email wp-cron jobs','church-admin').'</h1>';
    $tableData='';
    if(!empty($cron))
    {
         foreach($cron AS $ts=>$details)
         {
             if(!empty($details['church_admin_cron_email_rota']))
             {
                    $churchAdminCronJobs=$details['church_admin_cron_email_rota'];



                    foreach($churchAdminCronJobs AS $key=>$churchAdminCronJob)
                    {
                        
                        $service_id=$churchAdminCronJob['args']['service_id'];
                        $serviceRow=$wpdb->get_row('SELECT a.*,b.venue FROM '.CA_SER_TBL.' a, '.CA_SIT_TBL.' b WHERE a.site_id=b.site_id AND a.service_id="'.esc_sql($service_id).'"');
                        if(!empty($serviceRow))
                        {
                            if($serviceRow->service_day>=0||$serviceRow->service_day<=7){$day=$wp_locale->get_weekday($serviceRow->service_day);}else{$day='';}
                            $service=sprintf( esc_html__( '%1$s at %2$s on %3$s %4$s', 'church-admin' ), $serviceRow->service_name, $serviceRow->venue,$day,$serviceRow->service_time);
                            $delete='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=delete-cron&amp;section=rota&ts='.esc_html($ts).'&key='.esc_html($key),'delete-cron').'">'.__('Delete','church-admin').'</a>';

                            $tableData.='<tr><td>'.$delete.'</td><td>'.mysql2date(get_option('date_format').' '.get_option('time_format'),date('Y-m-d h:i:s',$ts)).'</td><td>'.esc_html($service).'</td></tr>';
                        }
                    }

                }
            }
		  if(!empty($tableData))
			{
				
				echo '<table class="widefat"><thead><tr><th>'.__('Delete','church-admin').'</th><th>'.__('Next send','church-admin').'</th><th>'.__('Which Service','church-admin').'</th></tr></thead><tfoot><tr><th>'.__('Delete','church-admin').'</th><th>'.__('Next send','church-admin').'</th><th>'.__('Which Service','church-admin').'</th></tr></tfoot><tbody>';
				echo $tableData;
				echo'</tbody></table>';
			}
            else
            {//there is cron but no church admin ones
              echo'<p>'.__('No cron jobs set to email the schedule','church-admin').'</p>';
                echo'<p><a class="button-primary" href="admin.php?page=church_admin/index.php&section=rota&action=rota-auto-email">'.__('Setup auto email of schedule','church-admin').'</a></p>';
          }
    }
    else
    {//no cron jobs set up at all (unlikely to happen!!!!)
        echo'<p>'.__('No cron jobs set to email the schedule','church-admin').'</p>';
        echo'<p><a class="button-primary" href="admin.php?page=church_admin/index.php&section=rota&action=rota-auto-email">'.__('Setup auto email of schedule','church-admin').'</a></p>';
    }
}

function church_admin_delete_cron($ts,$key)
{
	if(!church_admin_level_check('Rota'))wp_die(__('You don\'t have permission to do that','church-admin'));
	$cron=get_option('cron');
	unset($cron[$ts]['church_admin_cron_email_rota'][$key]);
	update_option('cron',$cron);
}
function church_admin_sms_rota_form()
{
    echo '<h1>'.__('SMS out service schedule','church-admin').'</h1>';
    global $wpdb,$wp_locale;
    $services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
    $sms=get_option('church_admin_sms_username');
    if(!empty($sms))
		{
			
			echo'<form action="'.admin_url().'" method="GET"><input type="hidden" name="page" value="church_admin/index.php"/><input type="hidden" name="action" value="sms-rota"/><input type="hidden" name="tab" value="rota">';

            echo'<p><select name="service_id">';
            echo'<option value="">'.__('Choose a service','church-admin').'...</option>';
            foreach($services AS $service)
            {
            echo'<option value="'.$service->service_id.'">'.sprintf( __('%1$s on %2$s at %3$s ', 'church-admin'), 	$service->service_name,$wp_locale->get_weekday($service->service_day),$service->service_time).'</option>';
            }
            echo'</select><input  class="button-primary"  type="submit" name="submit" value="'.__('Send service schedule','church-admin').'"></p>';
            echo'</form>';
		}
    else
    {
        echo'<p>'.__("You have not set up BulkSMS yet",'church-admin').'</p>';
    }
}
function church_admin_email_rota_form()
{
    global $wpdb,$wp_locale;
    echo'<h1>'.__('Email out service schedule','church-admin').'</h1>';
    echo'<form action="'.admin_url().'" method="GET"><input type="hidden" name="page" value="church_admin/index.php"/><input type="hidden" name="action" value="email_rota"/><input type="hidden" name="sectiom" value="rota">';
    echo'<table ><tr><td><select id="services" name="service_id">';
    echo'<option value="">'.__('Choose a service','church-admin').'...</option>';
    $services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
    foreach($services AS $service)
    {
    echo'<option value="'.$service->service_id.'">'.sprintf( __('%1$s on %2$s at %3$s ', 'church-admin'), $service->service_name,$wp_locale->get_weekday($service->service_day),$service->service_time).'</option>';
    }
        echo'</select></td><td><span id="dates">'.__('Choose services, then choice of dates will appear','church-admin').'</span></td><td><input  	class="button-primary"  type="submit" name="submit" value="'.__('Send service rota','church-admin').'"></td></tr></table>';
    echo'</form>';
    $nonce = wp_create_nonce("church_admin_rota_dates");
   echo'<script>jQuery(document).ready(function($) {
			$("body").on("change","#services",function() {
            
			var service_id=$(this).val();
			var data = {
                "action": "church_admin",
                "method":"rota-dates",
                "service_id":service_id,
                "nonce": "'.$nonce.'"
		      };
        console.log(data);
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {
			$("#dates").html(response);
		});

			});
			});</script>';
}

function church_admin_rota_auto_email()
{
    global $wpdb,$wp_locale;
    echo'<h1>'.__('Communicate the schedule ','church-admin').'</h2>';
	if(!empty($_POST['email_rota_day']))
    {   
        echo'<div class="notice notice-success"><h2>'.__('Schedule cron job saved','church-admin').'</h2></div>';
        church_admin_cron_check();
    }
    else
    {    $email_day=get_option('church_admin_email_rota_day');
        if(!empty($email_day)&&!empty($rota_days[$email_day])) echo'<p><strong>'.sprintf(__('This week\'s schedules are automatically emailed on %1$s, when your website is first accessed that day.','church-admin'),$rota_days[$email_day]).'</strong></p>';
        echo'<form action="" method="POST">';
        echo'<h3>'.__('Set up auto email of schedule','church-admin').'</h3>';
        echo'<table ><tr><th scope="row">'.__('Which Service?','church-admin').'</th><td><select name="service_id">';
        $services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);    
        foreach($services AS $service) echo'<option value="'.(int)$service->service_id.'">'.esc_html($service->service_name.' on '.$wp_locale->get_weekday($service->service_day).' at '.$service->service_time).'</option>';
        echo'</select>';
        echo'</td><td>'. __("Automatically email current week's schedule",'church-admin').'</td><td>';
        echo'<select name="email_rota_day">';
        echo'<option value="8"'.selected( $email_day, NULL ).'>'.__('No Auto Send','church-admin').'</option>';
        echo'<option value="1"'.selected( $email_day, 1 ).'>'.__('Monday','church-admin').'</option>';
        echo'<option value="2"'.selected( $email_day, 2 ).'>'.__('Tuesday','church-admin').'</option>';
        echo'<option value="3"'.selected( $email_day, 3 ).'>'.__('Wednesday','church-admin').'</option>';
        echo'<option value="4"'.selected( $email_day, 4 ).'>'.__('Thursday','church-admin').'</option>';
        echo'<option value="5"'.selected( $email_day, 5 ).'>'.__('Friday','church-admin').'</option>';
        echo'<option value="6"'.selected( $email_day, 6 ).'>'.__('Saturday','church-admin').'</option>';
        echo'<option value="7"'.selected( $email_day, 7 ).'>'.__('Sunday','church-admin').'</option>';
        echo'</select><td></tr>';
        $message='';
        $message=get_option('church_admin_auto_rota_email_message');
        echo '<tr><th scope="row">'.__('Email message','church-admin').'</th><td colspan=2><textarea name="auto-rota-message" class="large-text">'.$message.'</textarea></td></tr>';
        echo'<tr><td cellpsacing=2><input   class="button-primary" type="submit" value="Save"/></td></tr></table></form>';
    }
}


function church_admin_rota_pdf_menu()
{
    global $wpdb,$wp_locale;
    	echo'<h2 >'.__('Schedule PDF','church-admin').' </h2>';
echo'<form action="'.home_url().'" method="GET"><table class="form-table">';
		//dates
		echo'<tr><th scope="row">'.__('Select month','church-admin').'</th><td><select name="date">';	
		for($x=0;$x<=12;$x++)
		{
			$date=date('Y-m-01',strtotime("+ $x month"));
			echo '<option value="'.$date.'">'.mysql2date('M Y', $date).'</option>';
		}
		echo'</select></td></tr>';
		echo'<tr><th scope="row">'.__('Select Service','church-admin').'<input type="hidden" name="ca_download" value="horizontal_rota_pdf"/></th><td><select name="service_id">';

		$services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
		foreach($services AS $service)
		{
					if($service->service_day!=8){echo'<option value="'.$service->service_id.'">'.sprintf( __('%1$s on %2$s at %3$s', 'church-admin'),$service->service_name,$wp_locale->get_weekday($service->service_day),$service->service_time).'</option>';}
					else{echo'<option value="'.$service->service_id.'">'.$service->service_name.'</option>';}
		}
		echo'</select></td></tr>';
        /*
        $rota_jobs=$wpdb->get_results('SELECT * FROM '.CA_RST_TBL.' ORDER BY rota_order');
        foreach($rota_jobs AS $rota_job)
        {
			
            echo'<tr><th scope="row">'.$rota_job->rota_task.'</th><td><input type="checkbox" name="rota_id[]" value="'.$rota_job->rota_id.'"/> '.__('Initials?','church-admin').'<input type="checkbox" name="initials[]" value="'.$rota_job->rota_id.'"/></td></tr>';

		
        }*/

        echo'<tr><td colspan="2"><input   class="button-primary" type="submit" value="'.__('Create PDF','church-admin').'"/></td></tr></table></form>';
   		
}


function church_admin_rota_csv_menu()
{
    global $wpdb,$wp_locale;
    /*********************************************************
        *
        *   Rota CSV
        *
        ***********************************************************/
        echo'<h2>'.__('Download schedule CSV','church-admin').'</h2>';
        echo'<form action="" method="GET"><table>';
        echo'<tr><th scope="row">'.__('Select Service','church-admin').'<input type="hidden" name="ca_download" value="rota-csv"/></th><td><select name="service_id">';
        $services=$wpdb->get_results('SELECT * FROM '.CA_SER_TBL);
		foreach($services AS $service)
		{
			if($service->service_day!=8){echo'<option value="'.$service->service_id.'">'.sprintf( __('%1$s on %2$s at %3$s', 'church-admin'),$service->service_name,$wp_locale->get_weekday($service->service_day),$service->service_time).'</option>';}
			else{echo'<option value="'.$service->service_id.'">'.$service->service_name.'</option>';}
        }
		echo'</select></td></tr>';
        echo'<tr><th scope="row">'.__('Earliest date','church-admin').'</th><td>'.church_admin_date_picker(NULL,'start_date',FALSE,date("Y-m-d",strtotime("-10years")),NULL,'start_date','start_date').'</td></tr>';
        echo'<tr><th scope="row">'.__('Latest date','church-admin').'</th><td>'.church_admin_date_picker(NULL,'end_date',FALSE,date("Y-m-d",strtotime("-10years")),NULL,'end_date','end_date').'</td></tr>';
        echo'<tr><td colspan="2"><input   class="button-primary" type="submit" value="'.__('Download CSV','church-admin').'"/></td></tr></table></form>';
    
}