<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/************************************
*
*   Twilio listener
*
*************************************/
function church_admin_twilio_listener()
{
    global $wpdb;
    if(defined('CA_DEBUG'))church_admin_debug("*******************\r\n Twilio Listener function");
    if(defined('CA_DEBUG'))church_admin_debug($_POST);
    $smsProvider=get_option('church_admin_sms_provider');
    if(empty($smsProvider)||$smsProvider!='twilio'){
        church_admin_debug('SMS provider not twilio');   
        exit('Jesus loves you');
    }
    $sqlsafe=array();
    foreach($_POST AS $key=>$value)$sqlsafe[$key]=esc_sql(stripslashes($value));
    $check=$wpdb->get_var('SELECT message_id FROM '.CA_TWI_TBL.' WHERE twilio_id="'.$sqlsafe['MessageSid'].'"');
    if(empty($check))
    {
        $people_id=0;
        $people_id=$wpdb->get_var('SELECT people_id FROM '.CA_PEO_TBL.' WHERE e164cell="'.$sqlsafe['From'].'"');
        if(defined('CA_DEBUG'))church_admin_debug($wpdb->last_query);
        $wpdb->query('INSERT INTO '.CA_TWI_TBL.' (mobile,direction,message, twilio_id,message_date,people_id)VALUES("'.$sqlsafe['From'].'","0","'.$sqlsafe['Body'].'","'.$sqlsafe['MessageSid'].'","'.date('Y-m-d H:i:s').'","'.(int)$people_id.'")');
        if(defined('CA_DEBUG'))church_admin_debug($wpdb->last_query);
    }

}
/******************************************
*
*   Twilio recent replies list
*
*******************************************/
function church_admin_twilio_replies_list()
{
    global $wpdb;
    echo'<h2>'.__('Twilio replies list','church-admin').'</h2>';
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/sms.php');
    church_admin_sms_credits();
    
    $smsProvider=get_option('church_admin_sms_provider');
    if(empty($smsProvider)||$smsProvider!='twilio'){
        echo '<p><strong>'.__('You need to set Twilio as your SMS provider to use this feature','church-admin').'</strong></p>';
        echo'<p><a href="admin.php?page=church_admin/index.php&amp;action=sms-settings" class="button-primary">'.__('SMS Settings','church-admin').'</a></p>';
    }
    else
    {    
        echo'<p>'.sprintf(__('To receive replies make sure you set this webhook %1$s at %2$s. Instruction at %3$s','church-admin'),'<strong>'.admin_url('admin-ajax.php?action=church_admin_twilio_listener').'</strong>','<a target="_blank" href="https://www.twilio.com/console/phone-numbers/incoming">Twilio Numbers page</a>','<a target="_blank"  href="https://www.churchadminplugin.com/tutorials/twilio-incoming-numbers">tutorial page</a>').'</p>';
        echo'<p>'.__('This list refreshes automatically every 10secs. Best to delete threads when finished to save data!','church-admin').'</p>';
        
        
        echo'<table class="widefat">';
        $tableHeader='<tr><th>'.__('Delete thread','church-admin').'</th><th>'.__('Last message received','church-admin').'</th><th>'.__('Name','church-admin').'</th><th>'.__('Cell number','church-admin').'</th><th>'.__('Message','church-admin').'</th><th>'.__('View thread','church-admin').'</th><tr>';
        echo'<thead>'.$tableHeader.'</thead><tfoot>'.$tableHeader.'</tfoot><tbody class="ca-sms-replies">';
        echo church_admin_sms_replies_list();
        echo'</tbody></table>';
        $nonce=wp_create_nonce('refresh-sms-replies');
        echo'<script>
        jQuery(document).ready(function($){
            var timeout = setInterval(reloadChat, 10000);    
            function reloadChat () {
               
                var data={"action":"church_admin","method":"refresh-sms-replies","nonce":"'.$nonce.'"};
		 	  
		 	    $.getJSON({
		 			url: ajaxurl,
		 			type: "POST",
		 			data: data,
		 			success: function(res) 
                    {
                    
                        $(".ca-sms-replies").html(res)
		 			}
		 	    });
                
            }
        
        });
    
    </script>';    
        
    }
}
function church_admin_sms_replies_list()
{
    global $wpdb;
     $results=$wpdb->get_results('SELECT t1.* FROM '.CA_TWI_TBL.' t1 INNER JOIN ( SELECT `mobile`, MAX(message_date) AS max_message_date FROM '.CA_TWI_TBL.' WHERE direction=0 GROUP BY `mobile` ) t2 ON t1.`mobile` = t2.`mobile` AND t1.message_date = t2.max_message_date');

        if(!empty($results))
        {
            $out='';
            foreach($results AS $row)
            {
                $name='&nbsp;';
                $nameObj=$wpdb->get_row('SELECT first_name,prefix,last_name FROM '.CA_PEO_TBL.' WHERE e164cell="'.esc_sql($row->mobile).'"');
                if(!empty($nameObj))$name=implode(" ",array_filter(array($nameObj->first_name,$nameObj->prefix,$nameObj->last_name)));
                $deleteThread='<a onclick="return confirm(\''.__('Are you sure?','church-admin').'\')"  href="'.wp_nonce_url('admin.php?page=church_admin/index.php&section=comms&amp;action=delete-sms-thread&mobile='.urlencode($row->mobile),'delete-sms-thread').'">'.__('Delete SMS thread','church-admin').'</a>';
                $viewThread='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=view-sms-thread&section=comms&mobile='.urlencode($row->mobile),'view-sms-thread').'">'.__('View SMS thread','church-admin').'</a>';
                $out.='<tr><td>'.$deleteThread.'</td><td>'.mysql2date(get_option('date_format').' '.get_option('time_format'),$row->message_date).'</td><td>'.$name.'</td><td>'.esc_html($row->mobile).'</td><td>'.esc_html($row->message).'</td><td>'.$viewThread.'</td></tr>';
            }
        }else $out='<tr><td colspan=6>'.__('No replies received yet','church-admin').'</td></tr>';
    return $out;
}
/******************************************
*
*   Delete SMS thread
*
*******************************************/
function church_admin_delete_sms_thread($mobile)
{
    global $wpdb;
    $e164cell='+'.trim($mobile);
    $wpdb->query('DELETE FROM '.CA_TWI_TBL.' WHERE mobile="'.esc_sql($e164cell).'"');
    echo '<div class="notice notice-success"><h2>'.sprintf(__('Message thread for %1$s deleted','church-admin'),$e164cell).'</h2></div>';
    church_admin_twilio_replies_list();
}

/******************************************
*
*   View thread
*
*******************************************/
function church_admin_view_sms_thread($mobile)
{
    global $wpdb;
    require_once(plugin_dir_path(dirname(__FILE__)).'includes/sms.php');
    $e164cell='+'.trim($mobile);
    $name='';
    $nameObj=$wpdb->get_row('SELECT first_name,prefix,last_name FROM '.CA_PEO_TBL.' WHERE e164cell="'.esc_sql($e164cell).'"');
    if(!empty($nameObj))$name=implode(" ",array_filter(array($nameObj->first_name,$nameObj->prefix,$nameObj->last_name)));
    if(!empty($_POST['e164cell']))
    {
        
        church_admin_sms(stripslashes($_POST['e164cell']),stripslashes($_POST['ca-sms-message']),FALSE);
        
    }
    echo'<h2>'.sprintf(__('Message thread for %1$s %2$s','church-admin'),$name, $e164cell).'</h2>';
     echo'<p>'.__('This list refreshes automatically every 5secs.','church-admin').'</p>';
    church_admin_sms_credits();
    $results=$wpdb->get_results('SELECT * FROM '.CA_TWI_TBL.' WHERE mobile="'.esc_sql($e164cell).'" ORDER BY message_date ASC');
    if(!empty($results))
    {
        echo'<div class="ca-message-container"><div class="ca-sms-messages">';
        foreach($results AS $row)
        {
            switch($row->direction)
            {
                case '0': 
                    $class= 'class="ca-message-blue"';
                    $tsClass='class="ca-message-timestamp-left"';
                break;
                case '1': 
                    $class= 'class="ca-message-orange"';
                    $tsClass='class="ca-message-timestamp-right"';    
                break;
            }
            echo'<div '.$class.'>';
            
            echo '<div class="ca-message-content">'.esc_html($row->message).'</div>'."\r\n";
            echo'<div '.$tsClass.'>'.mysql2date(get_option('date_format').' '.get_option('time_format'),$row->message_date).'</div></div>'."\r\n";
        }
        $messageID=(int)$row->message_id;
        echo'</div>'."\r\n".'<div class="message_id" data-messageid="'.$messageID.'"></div>'."\r\n";
        echo'</div>'."\r\n";
    }
    echo'<h3>'.__('Send reply','church-admin').'</h3>';
    echo'<form action="" class="ca-send-form" method="post">';
    echo'<textarea class="ca-send-message" name="ca-sms-message"></textarea>';
    echo'<input type="hidden" name="e164cell" value="'.esc_html($e164cell).'"/>';
    echo'<p><input type="submit" class="button-primary" value="'.__('Send','church-admin').'"/></p></form>';$nonce=wp_create_nonce('refresh-sms');
    echo'<script>
        jQuery(document).ready(function($){
            var timeout = setInterval(reloadChat, 5000);    
            function reloadChat () {
            /* must use .attr as .data doesnt pick up changed DOM! */
                var lastID=$("body .message_id").attr("data-messageid");
                var e164cell="'.esc_html($e164cell).'";
                var data={"action":"church_admin","method":"refresh-sms","lastID":lastID,"e164cell":e164cell,"nonce":"'.$nonce.'"};
		 	  
		 	    $.getJSON({
		 			url: ajaxurl,
		 			type: "POST",
		 			data: data,
		 			success: function(res) 
                    {
                        if(res.messages)$(".ca-sms-messages").append(res.messages)
                        if(res.id)$(".message_id").attr("data-messageid",res.id);
		 			}
		 	    });
                
            }
        
        });
    
    </script>';
}