<?php
/**
 * Widgets
 */

/*******************************************************
*
* Calendar Widget
*
********************************************************/


//function to register the widget
add_action( 'widgets_init', 'church_admin_calendar_register_widget' );
function church_admin_calendar_register_widget() {

 register_widget( 'church_admin_calendar_Widget' );
  
}


class church_admin_calendar_Widget extends WP_Widget {
    function __construct() {

     $widget_options = array (
      'classname' => 'church_admin_calendar_widget',
      'description' => __('Calendar events','church-admin')
     );

     parent::__construct( 'church_admin_calendar_widget', 'Church Admin Calendar', $widget_options );

    }
    function form( $instance ) 
    {
        global $wpdb;
        //defaults
        $title = ! empty( $instance['title'] ) ? $instance['title'] : esc_html__( 'Calendar', 'church-admin' );
        $description = ! empty( $instance['description'] ) ? $instance['description'] : esc_html__( 'Church events coming soon', 'church-admin' );
        $cat_id = isset( $instance['cat_id'] ) ? $instance['cat_id'] : 0;
        $howmany = isset( $instance['howmany'] ) ? $instance['howmany'] : 5;
        //form
        echo '<p> <label for="'.esc_attr( $this->get_field_id( 'title' ) ).'">'.__('Title','church-admin').'</label><input class="widefat" type="text" id="'.esc_attr( $this->get_field_id( 'title' ) ).'" name="'.esc_attr( $this->get_field_name( 'title' ) ).'" value="'.$title.'" /></p>';
        
        echo '<p> <label for="'.esc_attr( $this->get_field_id( 'description' ) ).'">'.__('Description','church-admin').'</label><textarea class="widefat" id="'.esc_attr( $this->get_field_id( 'desciption' ) ).'"  name="'.esc_attr( $this->get_field_name( 'description' ) ).'">'.$description.'</textarea></p>';
        echo '<p> <label for="'.esc_attr( $this->get_field_id( 'hwomany' ) ).'">'.__('How many','church-admin').'</label><input class="widefat" type="text" id="'.esc_attr( $this->get_field_id( 'howmany' ) ).'" name="'.esc_attr( $this->get_field_name( 'howmany' ) ).'" value="'.$howmany.'" /></p>';
        
        echo'<p><label for="'.esc_attr( $this->get_field_id( 'cat_id' ) ).'">'.__('Select a Category','church-admin').'</label>';
        $sql='SELECT * FROM '.CA_CAT_TBL;
        if(empty($instance['cat_id']))$instance['cat_id']=0;
        $results=$wpdb->get_results($sql );
        echo'<select id="'.esc_attr( $this->get_field_id( 'title' ) ).'" name="'.esc_attr( $this->get_field_name( 'cat_id' ) ).'">';
        echo'<option value="0">'.__('All events','church-admin').'</option>';
        foreach($results AS $row)
        {
            echo'<option value="'.esc_html($row->cat_id).'" '.selected($row->cat_id,$cat_id,false).'>'.esc_html($row->category).'</option>';
        }
        echo'</select></p>';
        
    }
    
    //function to define the data saved by the widget

  
    function update( $new_instance, $old_instance ) 
    {
        
        $expected=array('title','description','howmany','cat_id');
        
        $instance=array();
        $instance['title'] = ( ! empty( $new_instance['title'] ) ) ? sanitize_text_field( $new_instance['title'] ) : '';
        $instance['description'] = ( ! empty( $new_instance['description'] ) ) ? sanitize_text_field( $new_instance['description'] ) : '';
        $instance['howmany'] = intval($new_instance['howmany'] );
        $instance['cat_id'] = intval($new_instance['cat_id'] );
        return $instance;          

    }         

    
    //function to display the widget in the site

    function widget( $args, $instance ) {
         global $wpdb;
        church_admin_debug(print_r($args,TRUE));
       
        $title    = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : __('Calendar','church-admin');
        $description = ! empty( $instance['description'] ) ? $instance['description'] : esc_html__( 'Church events coming soon', 'church-admin' );
        $cat_id = isset( $instance['cat_id'] ) ? intval($instance['cat_id']) : 0;
        $howmany = isset( $instance['howmany'] ) ? intval($instance['howmany']) : 5;
        //output code
        echo $args['before_widget'];
        if ( $title ) {
			echo $args['before_title'] . $title . $args['after_title'];
		}
        //Calendar output
        if($cat_id!=0){$cat='a.cat_id="'.$cat_id.'" AND ';} else {$cat='';}
        $sql='SELECT a.*,b.category FROM '.CA_DATE_TBL.' a, '.CA_CAT_TBL.' b WHERE '.$cat.' a.cat_id=b.cat_id AND a.start_date>="'.date('Y-m-d').'" AND a.general_calendar=1 ORDER by a.start_date,a.start_time LIMIT '.$howmany;
        church_admin_debug($sql);
        $result=$wpdb->get_results($sql);
        if(!empty($result))
        {

            $old_date='';
            foreach($result AS $row)
            {

                $date=mysql2date(get_option('date_format'),$row->start_date);

                if($old_date!=$date){echo'<h3>'.$date.'</h3>';}
                echo'<p><strong>'.esc_html(mysql2date(get_option('time_format'),$row->start_time)).' - '.esc_html($row->title).'</strong></br/>';
                if(!empty($row->location))echo esc_html($row->location).'<br/>';
                if(!empty($options['description'])&&!empty($row->description))echo esc_html($row->description).'<br/>';
                if(!empty($row->link))echo '<div class="ca-day-link"><a href="'.esc_url($row->link).'">'.esc_html($row->link_title).'</a></div>';
                echo '</p>';
                $old_date=$date;
            }

            unset($date,$thisday,$class);

        }//end of non empty result
        else echo __('No calendar events','church-admin');
        echo $args['after_widget'];

    }
}


/*******************************************************
*
* Sermon Podcast Widget
*
********************************************************/


//function to register the widget
add_action( 'widgets_init', 'church_admin_podcast_register_widget' );
function church_admin_podcast_register_widget() {
    $ajax_nonce = wp_create_nonce("church_admin_mp3_play");
	//wp_enqueue_script('ca_podcast_audio',plugins_url('church-admin/includes/audio.min.js',dirname(__FILE__)),'',NULL);
	wp_enqueue_script('ca_podcast_audio_use');//,plugins_url('church-admin/includes/audio.use.js',dirname(__FILE__)),'',NULL);
	wp_localize_script( 'ca_podcast_audio_use', 'ChurchAdminAjax', array('security'=>$ajax_nonce, 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );

 register_widget( 'church_admin_podcast_Widget' );
  
}


class church_admin_podcast_Widget extends WP_Widget {
    function __construct() {

     $widget_options = array (
      'classname' => 'church_admin_podcast_widget',
      'description' => __('Sermon Podcast','church-admin')
     );

     parent::__construct( 'church_admin_podcast_widget', 'Church Admin Podcast', $widget_options );

    }
    function form( $instance ) 
    {
        global $wpdb;
        //defaults
        $title = ! empty( $instance['title'] ) ? $instance['title'] : esc_html__( 'Sermons', 'church-admin' );
        $description = ! empty( $instance['description'] ) ? $instance['description'] : esc_html__( 'Sermon podcasts', 'church-admin' );
        $howmany = isset( $instance['howmany'] ) ? $instance['howmany'] : 5;
        //form
        echo '<p> <label for="'.esc_attr( $this->get_field_id( 'title' ) ).'">'.__('Title','church-admin').'</label><input class="widefat" type="text" id="'.esc_attr( $this->get_field_id( 'title' ) ).'" name="'.esc_attr( $this->get_field_name( 'title' ) ).'" value="'.$title.'" /></p>';
        
        
        echo '<p> <label for="'.esc_attr( $this->get_field_id( 'howmany' ) ).'">'.__('How many','church-admin').'</label><input class="widefat" type="text" id="'.esc_attr( $this->get_field_id( 'howmany' ) ).'" name="'.esc_attr( $this->get_field_name( 'howmany' ) ).'" value="'.$howmany.'" /></p>';
       
        
    }
    
    //function to define the data saved by the widget

  
    function update( $new_instance, $old_instance ) 
    {
        
        $expected=array('title','description','howmany','cat_id');
        
        $instance=array();
        $instance['title'] = ( ! empty( $new_instance['title'] ) ) ? sanitize_text_field( $new_instance['title'] ) : '';
        $instance['description'] = ( ! empty( $new_instance['description'] ) ) ? sanitize_text_field( $new_instance['description'] ) : '';
        $instance['howmany'] = intval($new_instance['howmany'] );
       
        return $instance;          

    }         

    
    //function to display the widget in the site

    function widget( $args, $instance ) {
        global $wpdb;
        $upload_dir = wp_upload_dir();
		$path=$upload_dir['basedir'].'/sermons/';
        $upload_dir = wp_upload_dir();
		$url=content_url().'/uploads/sermons/';
        require_once(plugin_dir_path(dirname(__FILE__)).'includes/sermon-podcast.php');
        church_admin_debug(print_r($args,TRUE));
       
        $title    = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : __('Calendar','church-admin');
        $description = ! empty( $instance['description'] ) ? $instance['description'] : esc_html__( 'Church events coming soon', 'church-admin' );
       
        $howmany = isset( $instance['howmany'] ) ? intval($instance['howmany']) : 5;
        //output code
        echo $args['before_widget'];
        if ( $title ) {
			echo $args['before_title'] . $title . $args['after_title'];
		}
        
        $ca_podcast_settings=get_option('ca_podcast_settings');

	   if(!empty($ca_podcast_settings['link']))echo'<p><a title="Download on Itunes" href="'.$ca_podcast_settings['itunes_link'].'"><img  alt="badge_itunes-lrg" src="'.plugins_url('/images/badge_itunes-lrg.png',dirname(__FILE__) ).'" width="110" height="40" /></a></p>';
        $sermons=$wpdb->get_results('SELECT a.*,b.* FROM '.CA_FIL_TBL.' a, '.CA_SERM_TBL.' b WHERE a.series_id=b.series_id ORDER BY a.pub_date DESC LIMIT '.$howmany);
        if(!empty($sermons))
        {
            foreach($sermons AS $data)
            {
                $speaker=church_admin_get_people($data->speaker);
                if(!empty($data->file_title))echo'<h3>'.esc_html($data->file_title).'</h3>';
                    if(!empty($data->video_url))
                    {
                        if(strpos($data->video_url, 'amazonaws.com/') !== false)
                        {
                           echo'<video class="ca-video" width="560" height="315" controls><source src="'.$data->video_url.'" type="video/mp4">Your browser does not support the video tag.
    </video>'; 
                        }else
                        {
                            $video=church_admin_generateVideoEmbedUrl($data->video_url);
                            $videoUrl=$video['embed'];
                            echo'<iframe class="ca-video" width="560" height="315" src="'.esc_url($videoUrl).'" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>';
                        }
                    }

                    if(!empty($data->file_name)&& file_exists($path.$data->file_name))
                    {
                        echo'<p><audio class="sermonmp3" data-id="'.esc_html($data->file_id).'" src="'.esc_url($url.$data->file_name).'" preload="auto" controls></audio></p>';
                        $download='<a href="'.esc_url($url.$data->file_name).'" class="mp3download" data-id="'.(int)$data->file_id.'" title="'.esc_html($data->file_title).'" download>'.esc_html($data->file_title).'</a>';
                    }
                    elseif(!empty($data->external_file))
                    {
                            echo'<p><audio class="sermonmp3" data-id="'.esc_html($data->file_id).'" src="'.esc_url($data->external_file).'" preload="auto" controls></audio></p>';

                            $download='<a href="'.esc_url($data->external_file).'" class="mp3download" data-id="'.(int)$data->file_id.'" title="'.esc_html($data->file_title).'" download>'.esc_html($data->file_title).'</a>';
                    }
            }
            echo'<script>var mp3nonce="'.wp_create_nonce("church_admin_mp3_play").';"</script>';
        }

        echo $args['after_widget'];

    }
}


/******************************************************************************************************
*
* Use prayer request recent posts in recent posts widget when on prayer request/bible readings Archive
*
*****************************************************************************************************/

add_filter( 'widget_posts_args', 'church_admin_recent_posts_args');
add_filter('widget_comments_args', 'church_admin_recent_posts_args');
/**
 * Add CPTs to recent posts widget
 *
 * @param array $args default widget args.
 * @return array $args filtered args.
 */
function church_admin_recent_posts_args($args) {
   if(is_post_type_archive('prayer-requests')) $args['post_type'] = array('prayer-requests');
	 elseif(is_post_type_archive('bile-readings')) $args['post_type'] = array('bible-readings');
	 else {
	 $args['post_type'] = array('post');
	 }
    return $args;
}

/*******************************************************
*
* Prayer Request Widget
*
********************************************************/
// Register and load the widget
function church_admin_load_prayer_widget() {
    register_widget( 'ca_prayer_widget' );
}
add_action( 'widgets_init', 'church_admin_load_prayer_widget' );

// Creating the widget
class ca_prayer_widget extends WP_Widget {

        function __construct() {
        parent::__construct(

        // Base ID of your widget
        'ca_prayer_widget',

        // Widget name will appear in UI
        __('Submit Prayer Request Widget', 'church-admin'),

        // Widget description
        array( 'description' => __( 'Prayer Request widget', 'church-admin' ), )
        );
        }

        // Creating widget front-end

        public function widget( $args, $instance ) {
            if(empty($ins))
        $title =__('Submit prayer Request','church-admin');

        // before and after widget arguments are defined by themes
        echo $args['before_widget'].'<div class="widget-white-container">';
        if ( ! empty( $title ) )
        echo $args['before_title'] . $title . $args['after_title'];

        // This is where you run the code and display the output

        if(!empty($_POST['non_spammer']))
        {
            echo'<p>'.__('Prayer request saved for moderation','church-admin').'</p>';
        }
        else {
            $message=get_option('church_admin_prayer_request_message');
            if(!empty($message))echo'<p>'. esc_html($message).'</p>';
            echo'<form action="" method="POST">';
            echo'<table class="form-table"><tbody>';
            echo'<tr><th scope="row">'.__('Title','church-admin').'</th><td><input type="text" name="request_title"></td></tr>';
            echo'<tr><th scope="row">'.__('Prayer request','church-admin').'</th><td><textarea name="request_content"></textarea></td></tr>';
            echo'<tr class="widget-spam-proof">&nbsp;</td></tr>';
            echo'<tr><td cellspacing=2><input type="hidden" value="TRUE" name="save_prayer_request"/><input type="submit" value="'.__('Save','church-admin').'"/></td></tr></table>';

            echo'</form>';
            $nonce=wp_create_nonce('prayer-request');
            echo'<script>jQuery(document).ready(function($) {var content="<th scope=\"row\">'.__('Check box if not a spammer','church-admin').'</th><td><input type=\"checkbox\" name=\"non_spammer\" value=\"'.$nonce.'\"/></td></tr>";$(".widget-spam-proof").html(content);});</script>';
        }
        echo '</div>'.$args['after_widget'];
        }

} // Class wpb_widget ends here

